# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['MetadataSchemaArgs', 'MetadataSchema']

@pulumi.input_type
class MetadataSchemaArgs:
    def __init__(__self__, *,
                 resource_group_name: pulumi.Input[str],
                 schema: pulumi.Input[str],
                 service_name: pulumi.Input[str],
                 assigned_to: Optional[pulumi.Input[Sequence[pulumi.Input['MetadataAssignmentArgs']]]] = None,
                 metadata_schema_name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a MetadataSchema resource.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] schema: The schema defining the type.
        :param pulumi.Input[str] service_name: The name of Azure API Center service.
        :param pulumi.Input[str] metadata_schema_name: The name of the metadata schema.
        """
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "schema", schema)
        pulumi.set(__self__, "service_name", service_name)
        if assigned_to is not None:
            pulumi.set(__self__, "assigned_to", assigned_to)
        if metadata_schema_name is not None:
            pulumi.set(__self__, "metadata_schema_name", metadata_schema_name)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter
    def schema(self) -> pulumi.Input[str]:
        """
        The schema defining the type.
        """
        return pulumi.get(self, "schema")

    @schema.setter
    def schema(self, value: pulumi.Input[str]):
        pulumi.set(self, "schema", value)

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> pulumi.Input[str]:
        """
        The name of Azure API Center service.
        """
        return pulumi.get(self, "service_name")

    @service_name.setter
    def service_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "service_name", value)

    @property
    @pulumi.getter(name="assignedTo")
    def assigned_to(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['MetadataAssignmentArgs']]]]:
        return pulumi.get(self, "assigned_to")

    @assigned_to.setter
    def assigned_to(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['MetadataAssignmentArgs']]]]):
        pulumi.set(self, "assigned_to", value)

    @property
    @pulumi.getter(name="metadataSchemaName")
    def metadata_schema_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the metadata schema.
        """
        return pulumi.get(self, "metadata_schema_name")

    @metadata_schema_name.setter
    def metadata_schema_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "metadata_schema_name", value)


class MetadataSchema(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 assigned_to: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MetadataAssignmentArgs']]]]] = None,
                 metadata_schema_name: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 schema: Optional[pulumi.Input[str]] = None,
                 service_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Metadata schema entity. Used to define metadata for the entities in API catalog.
        Azure REST API version: 2024-03-01.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] metadata_schema_name: The name of the metadata schema.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] schema: The schema defining the type.
        :param pulumi.Input[str] service_name: The name of Azure API Center service.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MetadataSchemaArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Metadata schema entity. Used to define metadata for the entities in API catalog.
        Azure REST API version: 2024-03-01.

        :param str resource_name: The name of the resource.
        :param MetadataSchemaArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MetadataSchemaArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 assigned_to: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MetadataAssignmentArgs']]]]] = None,
                 metadata_schema_name: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 schema: Optional[pulumi.Input[str]] = None,
                 service_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MetadataSchemaArgs.__new__(MetadataSchemaArgs)

            __props__.__dict__["assigned_to"] = assigned_to
            __props__.__dict__["metadata_schema_name"] = metadata_schema_name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            if schema is None and not opts.urn:
                raise TypeError("Missing required property 'schema'")
            __props__.__dict__["schema"] = schema
            if service_name is None and not opts.urn:
                raise TypeError("Missing required property 'service_name'")
            __props__.__dict__["service_name"] = service_name
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:apicenter/v20240301:MetadataSchema")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(MetadataSchema, __self__).__init__(
            'azure-native:apicenter:MetadataSchema',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'MetadataSchema':
        """
        Get an existing MetadataSchema resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = MetadataSchemaArgs.__new__(MetadataSchemaArgs)

        __props__.__dict__["assigned_to"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["schema"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return MetadataSchema(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="assignedTo")
    def assigned_to(self) -> pulumi.Output[Optional[Sequence['outputs.MetadataAssignmentResponse']]]:
        return pulumi.get(self, "assigned_to")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> pulumi.Output[str]:
        """
        The schema defining the type.
        """
        return pulumi.get(self, "schema")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

