# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'BackendProtocol',
    'Confirmation',
    'LoggerType',
    'SubscriptionState',
    'UserState',
]


class BackendProtocol(str, Enum):
    """
    Backend communication protocol.
    """
    HTTP = "http"
    """
    The Backend is a RESTful service.
    """
    SOAP = "soap"
    """
    The Backend is a SOAP service.
    """


class Confirmation(str, Enum):
    """
    Determines the type of confirmation e-mail that will be sent to the newly created user.
    """
    SIGNUP = "signup"
    """
    Send an e-mail to the user confirming they have successfully signed up.
    """
    INVITE = "invite"
    """
    Send an e-mail inviting the user to sign-up and complete registration.
    """


class LoggerType(str, Enum):
    """
    Logger type.
    """
    AZURE_EVENT_HUB = "azureEventHub"
    """
    Azure Event Hub as log destination.
    """
    APPLICATION_INSIGHTS = "applicationInsights"
    """
    Azure Application Insights as log destination.
    """


class SubscriptionState(str, Enum):
    """
    Initial subscription state. If no value is specified, subscription is created with Submitted state. Possible states are * active – the subscription is active, * suspended – the subscription is blocked, and the subscriber cannot call any APIs of the product, * submitted – the subscription request has been made by the developer, but has not yet been approved or rejected, * rejected – the subscription request has been denied by an administrator, * cancelled – the subscription has been cancelled by the developer or administrator, * expired – the subscription reached its expiration date and was deactivated.
    """
    SUSPENDED = "suspended"
    ACTIVE = "active"
    EXPIRED = "expired"
    SUBMITTED = "submitted"
    REJECTED = "rejected"
    CANCELLED = "cancelled"


class UserState(str, Enum):
    """
    Account state. Specifies whether the user is active or not. Blocked users are unable to sign into the developer portal or call any APIs of subscribed products. Default state is Active.
    """
    ACTIVE = "active"
    """
    User state is active.
    """
    BLOCKED = "blocked"
    """
    User is blocked. Blocked users cannot authenticate at developer portal or call API.
    """
    PENDING = "pending"
    """
    User account is pending. Requires identity confirmation before it can be made active.
    """
    DELETED = "deleted"
    """
    User account is closed. All identities and related entities are removed.
    """
