# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetDaprComponentResiliencyPolicyResult',
    'AwaitableGetDaprComponentResiliencyPolicyResult',
    'get_dapr_component_resiliency_policy',
    'get_dapr_component_resiliency_policy_output',
]

@pulumi.output_type
class GetDaprComponentResiliencyPolicyResult:
    """
    Dapr Component Resiliency Policy.
    """
    def __init__(__self__, id=None, inbound_policy=None, name=None, outbound_policy=None, system_data=None, type=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if inbound_policy and not isinstance(inbound_policy, dict):
            raise TypeError("Expected argument 'inbound_policy' to be a dict")
        pulumi.set(__self__, "inbound_policy", inbound_policy)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if outbound_policy and not isinstance(outbound_policy, dict):
            raise TypeError("Expected argument 'outbound_policy' to be a dict")
        pulumi.set(__self__, "outbound_policy", outbound_policy)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="inboundPolicy")
    def inbound_policy(self) -> Optional['outputs.DaprComponentResiliencyPolicyConfigurationResponse']:
        """
        The optional inbound component resiliency policy configuration
        """
        return pulumi.get(self, "inbound_policy")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="outboundPolicy")
    def outbound_policy(self) -> Optional['outputs.DaprComponentResiliencyPolicyConfigurationResponse']:
        """
        The optional outbound component resiliency policy configuration
        """
        return pulumi.get(self, "outbound_policy")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetDaprComponentResiliencyPolicyResult(GetDaprComponentResiliencyPolicyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDaprComponentResiliencyPolicyResult(
            id=self.id,
            inbound_policy=self.inbound_policy,
            name=self.name,
            outbound_policy=self.outbound_policy,
            system_data=self.system_data,
            type=self.type)


def get_dapr_component_resiliency_policy(component_name: Optional[str] = None,
                                         environment_name: Optional[str] = None,
                                         name: Optional[str] = None,
                                         resource_group_name: Optional[str] = None,
                                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDaprComponentResiliencyPolicyResult:
    """
    Dapr Component Resiliency Policy.
    Azure REST API version: 2023-08-01-preview.


    :param str component_name: Name of the Dapr Component.
    :param str environment_name: Name of the Managed Environment.
    :param str name: Name of the Dapr Component Resiliency Policy.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['componentName'] = component_name
    __args__['environmentName'] = environment_name
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:app:getDaprComponentResiliencyPolicy', __args__, opts=opts, typ=GetDaprComponentResiliencyPolicyResult).value

    return AwaitableGetDaprComponentResiliencyPolicyResult(
        id=pulumi.get(__ret__, 'id'),
        inbound_policy=pulumi.get(__ret__, 'inbound_policy'),
        name=pulumi.get(__ret__, 'name'),
        outbound_policy=pulumi.get(__ret__, 'outbound_policy'),
        system_data=pulumi.get(__ret__, 'system_data'),
        type=pulumi.get(__ret__, 'type'))


@_utilities.lift_output_func(get_dapr_component_resiliency_policy)
def get_dapr_component_resiliency_policy_output(component_name: Optional[pulumi.Input[str]] = None,
                                                environment_name: Optional[pulumi.Input[str]] = None,
                                                name: Optional[pulumi.Input[str]] = None,
                                                resource_group_name: Optional[pulumi.Input[str]] = None,
                                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDaprComponentResiliencyPolicyResult]:
    """
    Dapr Component Resiliency Policy.
    Azure REST API version: 2023-08-01-preview.


    :param str component_name: Name of the Dapr Component.
    :param str environment_name: Name of the Managed Environment.
    :param str name: Name of the Dapr Component Resiliency Policy.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    ...
