# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AuthenticationMode',
    'ConnectionStatus',
    'CreateMode',
    'IdentityType',
    'PrivateLinkDelegation',
    'PublicNetworkAccess',
]


class AuthenticationMode(str, Enum):
    """
    The data plane proxy authentication mode. This property manages the authentication mode of request to the data plane resources.
    """
    LOCAL = "Local"
    """
    The local authentication mode. Users are not required to have data plane permissions if local authentication is not disabled.
    """
    PASS_THROUGH = "Pass-through"
    """
    The pass-through authentication mode. User identity will be passed through from ARM, requiring user to have data plane action permissions (Available via App Configuration Data Owner/ App Configuration Data Reader).
    """


class ConnectionStatus(str, Enum):
    """
    The private link service connection status.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"
    DISCONNECTED = "Disconnected"


class CreateMode(str, Enum):
    """
    Indicates whether the configuration store need to be recovered.
    """
    RECOVER = "Recover"
    DEFAULT = "Default"


class IdentityType(str, Enum):
    """
    The type of managed identity used. The type 'SystemAssigned, UserAssigned' includes both an implicitly created identity and a set of user-assigned identities. The type 'None' will remove any identities.
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"


class PrivateLinkDelegation(str, Enum):
    """
    The data plane proxy private link delegation. This property manages if a request from delegated ARM private link is allowed when the data plane resource requires private link.
    """
    ENABLED = "Enabled"
    """
    ARM private endpoint is required if the resource requires private link.
    """
    DISABLED = "Disabled"
    """
    Request is denied if the resource requires private link.
    """


class PublicNetworkAccess(str, Enum):
    """
    Control permission for data plane traffic coming from public networks while private endpoint is enabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"
