# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'ListKeyByAutomationAccountResult',
    'AwaitableListKeyByAutomationAccountResult',
    'list_key_by_automation_account',
    'list_key_by_automation_account_output',
]

@pulumi.output_type
class ListKeyByAutomationAccountResult:
    def __init__(__self__, keys=None):
        if keys and not isinstance(keys, list):
            raise TypeError("Expected argument 'keys' to be a list")
        pulumi.set(__self__, "keys", keys)

    @property
    @pulumi.getter
    def keys(self) -> Optional[Sequence['outputs.KeyResponse']]:
        """
        Lists the automation keys.
        """
        return pulumi.get(self, "keys")


class AwaitableListKeyByAutomationAccountResult(ListKeyByAutomationAccountResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListKeyByAutomationAccountResult(
            keys=self.keys)


def list_key_by_automation_account(automation_account_name: Optional[str] = None,
                                   resource_group_name: Optional[str] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListKeyByAutomationAccountResult:
    """
    Retrieve the automation keys for an account.
    Azure REST API version: 2022-08-08.

    Other available API versions: 2023-05-15-preview, 2023-11-01.


    :param str automation_account_name: The name of the automation account.
    :param str resource_group_name: Name of an Azure Resource group.
    """
    __args__ = dict()
    __args__['automationAccountName'] = automation_account_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:automation:listKeyByAutomationAccount', __args__, opts=opts, typ=ListKeyByAutomationAccountResult).value

    return AwaitableListKeyByAutomationAccountResult(
        keys=pulumi.get(__ret__, 'keys'))


@_utilities.lift_output_func(list_key_by_automation_account)
def list_key_by_automation_account_output(automation_account_name: Optional[pulumi.Input[str]] = None,
                                          resource_group_name: Optional[pulumi.Input[str]] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[ListKeyByAutomationAccountResult]:
    """
    Retrieve the automation keys for an account.
    Azure REST API version: 2022-08-08.

    Other available API versions: 2023-05-15-preview, 2023-11-01.


    :param str automation_account_name: The name of the automation account.
    :param str resource_group_name: Name of an Azure Resource group.
    """
    ...
