# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'ListAutomationAccountDeletedRunbooksResult',
    'AwaitableListAutomationAccountDeletedRunbooksResult',
    'list_automation_account_deleted_runbooks',
    'list_automation_account_deleted_runbooks_output',
]

@pulumi.output_type
class ListAutomationAccountDeletedRunbooksResult:
    """
    The response model for the list deleted runbook.
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> Optional[str]:
        """
        Gets or sets the next link.
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.DeletedRunbookResponse']]:
        """
        List of deleted runbooks in automation account.
        """
        return pulumi.get(self, "value")


class AwaitableListAutomationAccountDeletedRunbooksResult(ListAutomationAccountDeletedRunbooksResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListAutomationAccountDeletedRunbooksResult(
            next_link=self.next_link,
            value=self.value)


def list_automation_account_deleted_runbooks(automation_account_name: Optional[str] = None,
                                             resource_group_name: Optional[str] = None,
                                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListAutomationAccountDeletedRunbooksResult:
    """
    Retrieve the deleted runbooks for an automation account.


    :param str automation_account_name: The name of the automation account.
    :param str resource_group_name: Name of an Azure Resource group.
    """
    __args__ = dict()
    __args__['automationAccountName'] = automation_account_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:automation/v20230515preview:listAutomationAccountDeletedRunbooks', __args__, opts=opts, typ=ListAutomationAccountDeletedRunbooksResult).value

    return AwaitableListAutomationAccountDeletedRunbooksResult(
        next_link=pulumi.get(__ret__, 'next_link'),
        value=pulumi.get(__ret__, 'value'))


@_utilities.lift_output_func(list_automation_account_deleted_runbooks)
def list_automation_account_deleted_runbooks_output(automation_account_name: Optional[pulumi.Input[str]] = None,
                                                    resource_group_name: Optional[pulumi.Input[str]] = None,
                                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[ListAutomationAccountDeletedRunbooksResult]:
    """
    Retrieve the deleted runbooks for an automation account.


    :param str automation_account_name: The name of the automation account.
    :param str resource_group_name: Name of an Azure Resource group.
    """
    ...
