# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetCIAMTenantResult',
    'AwaitableGetCIAMTenantResult',
    'get_ciam_tenant',
    'get_ciam_tenant_output',
]

@pulumi.output_type
class GetCIAMTenantResult:
    """
    The Azure AD for customers resource.
    """
    def __init__(__self__, billing_type=None, create_tenant_properties=None, domain_name=None, effective_start_date_utc=None, id=None, location=None, name=None, provisioning_state=None, sku=None, system_data=None, tags=None, tenant_id=None, type=None):
        if billing_type and not isinstance(billing_type, str):
            raise TypeError("Expected argument 'billing_type' to be a str")
        pulumi.set(__self__, "billing_type", billing_type)
        if create_tenant_properties and not isinstance(create_tenant_properties, dict):
            raise TypeError("Expected argument 'create_tenant_properties' to be a dict")
        pulumi.set(__self__, "create_tenant_properties", create_tenant_properties)
        if domain_name and not isinstance(domain_name, str):
            raise TypeError("Expected argument 'domain_name' to be a str")
        pulumi.set(__self__, "domain_name", domain_name)
        if effective_start_date_utc and not isinstance(effective_start_date_utc, str):
            raise TypeError("Expected argument 'effective_start_date_utc' to be a str")
        pulumi.set(__self__, "effective_start_date_utc", effective_start_date_utc)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if location and not isinstance(location, str):
            raise TypeError("Expected argument 'location' to be a str")
        pulumi.set(__self__, "location", location)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if sku and not isinstance(sku, dict):
            raise TypeError("Expected argument 'sku' to be a dict")
        pulumi.set(__self__, "sku", sku)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)
        if tenant_id and not isinstance(tenant_id, str):
            raise TypeError("Expected argument 'tenant_id' to be a str")
        pulumi.set(__self__, "tenant_id", tenant_id)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="billingType")
    def billing_type(self) -> str:
        """
        The type of billing. Will be MAU for all new customers. Cannot be changed if value is 'MAU'. Learn more about Azure AD for customers billing at [aka.ms/b2cBilling](https://aka.ms/b2cbilling).
        """
        return pulumi.get(self, "billing_type")

    @property
    @pulumi.getter(name="createTenantProperties")
    def create_tenant_properties(self) -> 'outputs.CreateCIAMTenantPropertiesResponse':
        """
        These properties are used to create the Azure AD for customers tenant. These properties are not part of the Azure resource.
        """
        return pulumi.get(self, "create_tenant_properties")

    @property
    @pulumi.getter(name="domainName")
    def domain_name(self) -> str:
        """
        The domain name of the tenant
        """
        return pulumi.get(self, "domain_name")

    @property
    @pulumi.getter(name="effectiveStartDateUtc")
    def effective_start_date_utc(self) -> str:
        """
        The data from which the billing type took effect
        """
        return pulumi.get(self, "effective_start_date_utc")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        An identifier that represents the Azure AD for customers tenant resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def location(self) -> str:
        """
        The location in which the resource is hosted and data resides. Can be one of 'United States', 'Europe', 'Asia Pacific', or 'Australia'. Refer to [this documentation](https://aka.ms/ciam-data-location) for more information.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the Azure AD for customers tenant resource.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> str:
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter
    def sku(self) -> 'outputs.CIAMResourceSKUResponse':
        """
        SKU properties of the Azure AD for customers tenant. Learn more about Azure AD for customers billing at [https://aka.ms/ciambilling](https://aka.ms/ciambilling).
        """
        return pulumi.get(self, "sku")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Metadata pertaining to creation and last modification of the resource.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, str]]:
        """
        Resource Tags
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="tenantId")
    def tenant_id(self) -> Optional[str]:
        """
        An identifier of the Azure AD for customers tenant.
        """
        return pulumi.get(self, "tenant_id")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the Azure AD for customers tenant resource.
        """
        return pulumi.get(self, "type")


class AwaitableGetCIAMTenantResult(GetCIAMTenantResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCIAMTenantResult(
            billing_type=self.billing_type,
            create_tenant_properties=self.create_tenant_properties,
            domain_name=self.domain_name,
            effective_start_date_utc=self.effective_start_date_utc,
            id=self.id,
            location=self.location,
            name=self.name,
            provisioning_state=self.provisioning_state,
            sku=self.sku,
            system_data=self.system_data,
            tags=self.tags,
            tenant_id=self.tenant_id,
            type=self.type)


def get_ciam_tenant(resource_group_name: Optional[str] = None,
                    resource_name: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCIAMTenantResult:
    """
    Get the Azure AD for customers tenant resource.
    Azure REST API version: 2023-05-17-preview.


    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str resource_name: The initial sub domain of the tenant.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['resourceName'] = resource_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:azureactivedirectory:getCIAMTenant', __args__, opts=opts, typ=GetCIAMTenantResult).value

    return AwaitableGetCIAMTenantResult(
        billing_type=pulumi.get(__ret__, 'billing_type'),
        create_tenant_properties=pulumi.get(__ret__, 'create_tenant_properties'),
        domain_name=pulumi.get(__ret__, 'domain_name'),
        effective_start_date_utc=pulumi.get(__ret__, 'effective_start_date_utc'),
        id=pulumi.get(__ret__, 'id'),
        location=pulumi.get(__ret__, 'location'),
        name=pulumi.get(__ret__, 'name'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        sku=pulumi.get(__ret__, 'sku'),
        system_data=pulumi.get(__ret__, 'system_data'),
        tags=pulumi.get(__ret__, 'tags'),
        tenant_id=pulumi.get(__ret__, 'tenant_id'),
        type=pulumi.get(__ret__, 'type'))


@_utilities.lift_output_func(get_ciam_tenant)
def get_ciam_tenant_output(resource_group_name: Optional[pulumi.Input[str]] = None,
                           resource_name: Optional[pulumi.Input[str]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetCIAMTenantResult]:
    """
    Get the Azure AD for customers tenant resource.
    Azure REST API version: 2023-05-17-preview.


    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str resource_name: The initial sub domain of the tenant.
    """
    ...
