# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['ActiveDirectoryConnectorArgs', 'ActiveDirectoryConnector']

@pulumi.input_type
class ActiveDirectoryConnectorArgs:
    def __init__(__self__, *,
                 data_controller_name: pulumi.Input[str],
                 properties: pulumi.Input['ActiveDirectoryConnectorPropertiesArgs'],
                 resource_group_name: pulumi.Input[str],
                 active_directory_connector_name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a ActiveDirectoryConnector resource.
        :param pulumi.Input[str] data_controller_name: The name of the data controller
        :param pulumi.Input['ActiveDirectoryConnectorPropertiesArgs'] properties: null
        :param pulumi.Input[str] resource_group_name: The name of the Azure resource group
        :param pulumi.Input[str] active_directory_connector_name: The name of the Active Directory connector instance
        """
        pulumi.set(__self__, "data_controller_name", data_controller_name)
        pulumi.set(__self__, "properties", properties)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if active_directory_connector_name is not None:
            pulumi.set(__self__, "active_directory_connector_name", active_directory_connector_name)

    @property
    @pulumi.getter(name="dataControllerName")
    def data_controller_name(self) -> pulumi.Input[str]:
        """
        The name of the data controller
        """
        return pulumi.get(self, "data_controller_name")

    @data_controller_name.setter
    def data_controller_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "data_controller_name", value)

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Input['ActiveDirectoryConnectorPropertiesArgs']:
        """
        null
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: pulumi.Input['ActiveDirectoryConnectorPropertiesArgs']):
        pulumi.set(self, "properties", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the Azure resource group
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="activeDirectoryConnectorName")
    def active_directory_connector_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the Active Directory connector instance
        """
        return pulumi.get(self, "active_directory_connector_name")

    @active_directory_connector_name.setter
    def active_directory_connector_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "active_directory_connector_name", value)


class ActiveDirectoryConnector(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 active_directory_connector_name: Optional[pulumi.Input[str]] = None,
                 data_controller_name: Optional[pulumi.Input[str]] = None,
                 properties: Optional[pulumi.Input[pulumi.InputType['ActiveDirectoryConnectorPropertiesArgs']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Active directory connector resource
        Azure REST API version: 2023-01-15-preview. Prior API version in Azure Native 1.x: 2022-03-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] active_directory_connector_name: The name of the Active Directory connector instance
        :param pulumi.Input[str] data_controller_name: The name of the data controller
        :param pulumi.Input[pulumi.InputType['ActiveDirectoryConnectorPropertiesArgs']] properties: null
        :param pulumi.Input[str] resource_group_name: The name of the Azure resource group
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ActiveDirectoryConnectorArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Active directory connector resource
        Azure REST API version: 2023-01-15-preview. Prior API version in Azure Native 1.x: 2022-03-01-preview.

        :param str resource_name: The name of the resource.
        :param ActiveDirectoryConnectorArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ActiveDirectoryConnectorArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 active_directory_connector_name: Optional[pulumi.Input[str]] = None,
                 data_controller_name: Optional[pulumi.Input[str]] = None,
                 properties: Optional[pulumi.Input[pulumi.InputType['ActiveDirectoryConnectorPropertiesArgs']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ActiveDirectoryConnectorArgs.__new__(ActiveDirectoryConnectorArgs)

            __props__.__dict__["active_directory_connector_name"] = active_directory_connector_name
            if data_controller_name is None and not opts.urn:
                raise TypeError("Missing required property 'data_controller_name'")
            __props__.__dict__["data_controller_name"] = data_controller_name
            if properties is None and not opts.urn:
                raise TypeError("Missing required property 'properties'")
            __props__.__dict__["properties"] = properties
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:azurearcdata/v20220301preview:ActiveDirectoryConnector"), pulumi.Alias(type_="azure-native:azurearcdata/v20220615preview:ActiveDirectoryConnector"), pulumi.Alias(type_="azure-native:azurearcdata/v20230115preview:ActiveDirectoryConnector")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(ActiveDirectoryConnector, __self__).__init__(
            'azure-native:azurearcdata:ActiveDirectoryConnector',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'ActiveDirectoryConnector':
        """
        Get an existing ActiveDirectoryConnector resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = ActiveDirectoryConnectorArgs.__new__(ActiveDirectoryConnectorArgs)

        __props__.__dict__["name"] = None
        __props__.__dict__["properties"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return ActiveDirectoryConnector(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Output['outputs.ActiveDirectoryConnectorPropertiesResponse']:
        """
        null
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

