# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = ['SecuritySettingArgs', 'SecuritySetting']

@pulumi.input_type
class SecuritySettingArgs:
    def __init__(__self__, *,
                 cluster_name: pulumi.Input[str],
                 resource_group_name: pulumi.Input[str],
                 secured_core_compliance_assignment: Optional[pulumi.Input[Union[str, 'ComplianceAssignmentType']]] = None,
                 security_settings_name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a SecuritySetting resource.
        :param pulumi.Input[str] cluster_name: The name of the cluster.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Union[str, 'ComplianceAssignmentType']] secured_core_compliance_assignment: Secured Core Compliance Assignment
        :param pulumi.Input[str] security_settings_name: Name of security setting
        """
        pulumi.set(__self__, "cluster_name", cluster_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if secured_core_compliance_assignment is None:
            secured_core_compliance_assignment = 'Audit'
        if secured_core_compliance_assignment is not None:
            pulumi.set(__self__, "secured_core_compliance_assignment", secured_core_compliance_assignment)
        if security_settings_name is not None:
            pulumi.set(__self__, "security_settings_name", security_settings_name)

    @property
    @pulumi.getter(name="clusterName")
    def cluster_name(self) -> pulumi.Input[str]:
        """
        The name of the cluster.
        """
        return pulumi.get(self, "cluster_name")

    @cluster_name.setter
    def cluster_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "cluster_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="securedCoreComplianceAssignment")
    def secured_core_compliance_assignment(self) -> Optional[pulumi.Input[Union[str, 'ComplianceAssignmentType']]]:
        """
        Secured Core Compliance Assignment
        """
        return pulumi.get(self, "secured_core_compliance_assignment")

    @secured_core_compliance_assignment.setter
    def secured_core_compliance_assignment(self, value: Optional[pulumi.Input[Union[str, 'ComplianceAssignmentType']]]):
        pulumi.set(self, "secured_core_compliance_assignment", value)

    @property
    @pulumi.getter(name="securitySettingsName")
    def security_settings_name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of security setting
        """
        return pulumi.get(self, "security_settings_name")

    @security_settings_name.setter
    def security_settings_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "security_settings_name", value)


class SecuritySetting(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cluster_name: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 secured_core_compliance_assignment: Optional[pulumi.Input[Union[str, 'ComplianceAssignmentType']]] = None,
                 security_settings_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Security settings proxy resource
        Azure REST API version: 2023-11-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cluster_name: The name of the cluster.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Union[str, 'ComplianceAssignmentType']] secured_core_compliance_assignment: Secured Core Compliance Assignment
        :param pulumi.Input[str] security_settings_name: Name of security setting
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SecuritySettingArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Security settings proxy resource
        Azure REST API version: 2023-11-01-preview.

        :param str resource_name: The name of the resource.
        :param SecuritySettingArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SecuritySettingArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cluster_name: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 secured_core_compliance_assignment: Optional[pulumi.Input[Union[str, 'ComplianceAssignmentType']]] = None,
                 security_settings_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SecuritySettingArgs.__new__(SecuritySettingArgs)

            if cluster_name is None and not opts.urn:
                raise TypeError("Missing required property 'cluster_name'")
            __props__.__dict__["cluster_name"] = cluster_name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            if secured_core_compliance_assignment is None:
                secured_core_compliance_assignment = 'Audit'
            __props__.__dict__["secured_core_compliance_assignment"] = secured_core_compliance_assignment
            __props__.__dict__["security_settings_name"] = security_settings_name
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["security_compliance_status"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:azurestackhci/v20231101preview:SecuritySetting")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(SecuritySetting, __self__).__init__(
            'azure-native:azurestackhci:SecuritySetting',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'SecuritySetting':
        """
        Get an existing SecuritySetting resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = SecuritySettingArgs.__new__(SecuritySettingArgs)

        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["secured_core_compliance_assignment"] = None
        __props__.__dict__["security_compliance_status"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return SecuritySetting(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        The status of the last operation.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="securedCoreComplianceAssignment")
    def secured_core_compliance_assignment(self) -> pulumi.Output[Optional[str]]:
        """
        Secured Core Compliance Assignment
        """
        return pulumi.get(self, "secured_core_compliance_assignment")

    @property
    @pulumi.getter(name="securityComplianceStatus")
    def security_compliance_status(self) -> pulumi.Output['outputs.SecurityComplianceStatusResponse']:
        """
        Security Compliance Status
        """
        return pulumi.get(self, "security_compliance_status")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

