# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AuthenticationMode',
    'AutoStorageAuthenticationMode',
    'AutoUserScope',
    'CachingType',
    'CertificateStoreLocation',
    'CertificateVisibility',
    'ComputeNodeDeallocationOption',
    'ComputeNodeFillType',
    'ContainerType',
    'ContainerWorkingDirectory',
    'DiffDiskPlacement',
    'DiskEncryptionTarget',
    'DynamicVNetAssignmentScope',
    'ElevationLevel',
    'EndpointAccessDefaultAction',
    'IPAddressProvisioningType',
    'IPRuleAction',
    'InboundEndpointProtocol',
    'InterNodeCommunicationState',
    'KeySource',
    'LoginMode',
    'NetworkSecurityGroupRuleAccess',
    'NodeCommunicationMode',
    'NodePlacementPolicyType',
    'PoolAllocationMode',
    'PoolIdentityType',
    'PublicNetworkAccessType',
    'ResourceIdentityType',
    'StorageAccountType',
]


class AuthenticationMode(str, Enum):
    """
    The authentication mode for the Batch account.
    """
    SHARED_KEY = "SharedKey"
    """
    The authentication mode using shared keys.
    """
    AAD = "AAD"
    """
    The authentication mode using Azure Active Directory.
    """
    TASK_AUTHENTICATION_TOKEN = "TaskAuthenticationToken"
    """
    The authentication mode using task authentication tokens.
    """


class AutoStorageAuthenticationMode(str, Enum):
    """
    The authentication mode which the Batch service will use to manage the auto-storage account.
    """
    STORAGE_KEYS = "StorageKeys"
    """
    The Batch service will authenticate requests to auto-storage using storage account keys.
    """
    BATCH_ACCOUNT_MANAGED_IDENTITY = "BatchAccountManagedIdentity"
    """
    The Batch service will authenticate requests to auto-storage using the managed identity assigned to the Batch account.
    """


class AutoUserScope(str, Enum):
    """
    The default value is Pool. If the pool is running Windows a value of Task should be specified if stricter isolation between tasks is required. For example, if the task mutates the registry in a way which could impact other tasks, or if certificates have been specified on the pool which should not be accessible by normal tasks but should be accessible by start tasks.
    """
    TASK = "Task"
    """
    Specifies that the service should create a new user for the task.
    """
    POOL = "Pool"
    """
    Specifies that the task runs as the common auto user account which is created on every node in a pool.
    """


class CachingType(str, Enum):
    """
    Values are:

     none - The caching mode for the disk is not enabled.
     readOnly - The caching mode for the disk is read only.
     readWrite - The caching mode for the disk is read and write.

     The default value for caching is none. For information about the caching options see: https://blogs.msdn.microsoft.com/windowsazurestorage/2012/06/27/exploring-windows-azure-drives-disks-and-images/.
    """
    NONE = "None"
    """
    The caching mode for the disk is not enabled.
    """
    READ_ONLY = "ReadOnly"
    """
    The caching mode for the disk is read only.
    """
    READ_WRITE = "ReadWrite"
    """
    The caching mode for the disk is read and write.
    """


class CertificateStoreLocation(str, Enum):
    """
    The default value is currentUser. This property is applicable only for pools configured with Windows nodes (that is, created with cloudServiceConfiguration, or with virtualMachineConfiguration using a Windows image reference). For Linux compute nodes, the certificates are stored in a directory inside the task working directory and an environment variable AZ_BATCH_CERTIFICATES_DIR is supplied to the task to query for this location. For certificates with visibility of 'remoteUser', a 'certs' directory is created in the user's home directory (e.g., /home/{user-name}/certs) and certificates are placed in that directory.
    """
    CURRENT_USER = "CurrentUser"
    """
    Certificates should be installed to the CurrentUser certificate store.
    """
    LOCAL_MACHINE = "LocalMachine"
    """
    Certificates should be installed to the LocalMachine certificate store.
    """


class CertificateVisibility(str, Enum):
    START_TASK = "StartTask"
    """
    The certificate should be visible to the user account under which the start task is run. Note that if AutoUser Scope is Pool for both the StartTask and a Task, this certificate will be visible to the Task as well.
    """
    TASK = "Task"
    """
    The certificate should be visible to the user accounts under which job tasks are run.
    """
    REMOTE_USER = "RemoteUser"
    """
    The certificate should be visible to the user accounts under which users remotely access the node.
    """


class ComputeNodeDeallocationOption(str, Enum):
    """
    If omitted, the default value is Requeue.
    """
    REQUEUE = "Requeue"
    """
    Terminate running task processes and requeue the tasks. The tasks will run again when a node is available. Remove nodes as soon as tasks have been terminated.
    """
    TERMINATE = "Terminate"
    """
    Terminate running tasks. The tasks will be completed with failureInfo indicating that they were terminated, and will not run again. Remove nodes as soon as tasks have been terminated.
    """
    TASK_COMPLETION = "TaskCompletion"
    """
    Allow currently running tasks to complete. Schedule no new tasks while waiting. Remove nodes when all tasks have completed.
    """
    RETAINED_DATA = "RetainedData"
    """
    Allow currently running tasks to complete, then wait for all task data retention periods to expire. Schedule no new tasks while waiting. Remove nodes when all task retention periods have expired.
    """


class ComputeNodeFillType(str, Enum):
    SPREAD = "Spread"
    """
    Tasks should be assigned evenly across all nodes in the pool.
    """
    PACK = "Pack"
    """
    As many tasks as possible (taskSlotsPerNode) should be assigned to each node in the pool before any tasks are assigned to the next node in the pool.
    """


class ContainerType(str, Enum):
    DOCKER_COMPATIBLE = "DockerCompatible"
    """
    A Docker compatible container technology will be used to launch the containers.
    """
    CRI_COMPATIBLE = "CriCompatible"
    """
    A CRI based technology will be used to launch the containers.
    """


class ContainerWorkingDirectory(str, Enum):
    TASK_WORKING_DIRECTORY = "TaskWorkingDirectory"
    """
    Use the standard Batch service task working directory, which will contain the Task resource files populated by Batch.
    """
    CONTAINER_IMAGE_DEFAULT = "ContainerImageDefault"
    """
    Using container image defined working directory. Beware that this directory will not contain the resource files downloaded by Batch.
    """


class DiffDiskPlacement(str, Enum):
    """
    This property can be used by user in the request to choose which location the operating system should be in. e.g., cache disk space for Ephemeral OS disk provisioning. For more information on Ephemeral OS disk size requirements, please refer to Ephemeral OS disk size requirements for Windows VMs at https://docs.microsoft.com/en-us/azure/virtual-machines/windows/ephemeral-os-disks#size-requirements and Linux VMs at https://docs.microsoft.com/en-us/azure/virtual-machines/linux/ephemeral-os-disks#size-requirements.
    """
    CACHE_DISK = "CacheDisk"
    """
    The Ephemeral OS Disk is stored on the VM cache.
    """


class DiskEncryptionTarget(str, Enum):
    """
    If omitted, no disks on the compute nodes in the pool will be encrypted.
    """
    OS_DISK = "OsDisk"
    """
    The OS Disk on the compute node is encrypted.
    """
    TEMPORARY_DISK = "TemporaryDisk"
    """
    The temporary disk on the compute node is encrypted. On Linux this encryption applies to other partitions (such as those on mounted data disks) when encryption occurs at boot time.
    """


class DynamicVNetAssignmentScope(str, Enum):
    NONE = "none"
    """
    No dynamic VNet assignment is enabled.
    """
    JOB = "job"
    """
    Dynamic VNet assignment is done per-job. If this value is set, the network configuration subnet ID must also be set. This feature requires approval before use, please contact support
    """


class ElevationLevel(str, Enum):
    """
    nonAdmin - The auto user is a standard user without elevated access. admin - The auto user is a user with elevated access and operates with full Administrator permissions. The default value is nonAdmin.
    """
    NON_ADMIN = "NonAdmin"
    """
    The user is a standard user without elevated access.
    """
    ADMIN = "Admin"
    """
    The user is a user with elevated access and operates with full Administrator permissions.
    """


class EndpointAccessDefaultAction(str, Enum):
    """
    Default action for endpoint access. It is only applicable when publicNetworkAccess is enabled.
    """
    ALLOW = "Allow"
    """
    Allow client access.
    """
    DENY = "Deny"
    """
    Deny client access.
    """


class IPAddressProvisioningType(str, Enum):
    """
    The default value is BatchManaged
    """
    BATCH_MANAGED = "BatchManaged"
    """
    A public IP will be created and managed by Batch. There may be multiple public IPs depending on the size of the Pool.
    """
    USER_MANAGED = "UserManaged"
    """
    Public IPs are provided by the user and will be used to provision the Compute Nodes.
    """
    NO_PUBLIC_IP_ADDRESSES = "NoPublicIPAddresses"
    """
    No public IP Address will be created for the Compute Nodes in the Pool.
    """


class IPRuleAction(str, Enum):
    """
    Action when client IP address is matched.
    """
    ALLOW = "Allow"
    """
    Allow access for the matched client IP address.
    """


class InboundEndpointProtocol(str, Enum):
    TCP = "TCP"
    """
    Use TCP for the endpoint.
    """
    UDP = "UDP"
    """
    Use UDP for the endpoint.
    """


class InterNodeCommunicationState(str, Enum):
    """
    This imposes restrictions on which nodes can be assigned to the pool. Enabling this value can reduce the chance of the requested number of nodes to be allocated in the pool. If not specified, this value defaults to 'Disabled'.
    """
    ENABLED = "Enabled"
    """
    Enable network communication between virtual machines.
    """
    DISABLED = "Disabled"
    """
    Disable network communication between virtual machines.
    """


class KeySource(str, Enum):
    """
    Type of the key source.
    """
    MICROSOFT_BATCH = "Microsoft.Batch"
    """
    Batch creates and manages the encryption keys used to protect the account data.
    """
    MICROSOFT_KEY_VAULT = "Microsoft.KeyVault"
    """
    The encryption keys used to protect the account data are stored in an external key vault. If this is set then the Batch Account identity must be set to `SystemAssigned` and a valid Key Identifier must also be supplied under the keyVaultProperties.
    """


class LoginMode(str, Enum):
    """
    Specifies login mode for the user. The default value for VirtualMachineConfiguration pools is interactive mode and for CloudServiceConfiguration pools is batch mode.
    """
    BATCH = "Batch"
    """
    The LOGON32_LOGON_BATCH Win32 login mode. The batch login mode is recommended for long running parallel processes.
    """
    INTERACTIVE = "Interactive"
    """
    The LOGON32_LOGON_INTERACTIVE Win32 login mode. Some applications require having permissions associated with the interactive login mode. If this is the case for an application used in your task, then this option is recommended.
    """


class NetworkSecurityGroupRuleAccess(str, Enum):
    ALLOW = "Allow"
    """
    Allow access.
    """
    DENY = "Deny"
    """
    Deny access.
    """


class NodeCommunicationMode(str, Enum):
    """
    If omitted, the default value is Default.
    """
    DEFAULT = "Default"
    """
    The node communication mode is automatically set by the Batch service.
    """
    CLASSIC = "Classic"
    """
    Nodes using the Classic communication mode require inbound TCP communication on ports 29876 and 29877 from the "BatchNodeManagement.{region}" service tag and outbound TCP communication on port 443 to the "Storage.region" and "BatchNodeManagement.{region}" service tags.
    """
    SIMPLIFIED = "Simplified"
    """
    Nodes using the Simplified communication mode require outbound TCP communication on port 443 to the "BatchNodeManagement.{region}" service tag. No open inbound ports are required.
    """


class NodePlacementPolicyType(str, Enum):
    """
    Allocation policy used by Batch Service to provision the nodes. If not specified, Batch will use the regional policy.
    """
    REGIONAL = "Regional"
    """
    All nodes in the pool will be allocated in the same region.
    """
    ZONAL = "Zonal"
    """
    Nodes in the pool will be spread across different zones with best effort balancing.
    """


class PoolAllocationMode(str, Enum):
    """
    The pool allocation mode also affects how clients may authenticate to the Batch Service API. If the mode is BatchService, clients may authenticate using access keys or Azure Active Directory. If the mode is UserSubscription, clients must use Azure Active Directory. The default is BatchService.
    """
    BATCH_SERVICE = "BatchService"
    """
    Pools will be allocated in subscriptions owned by the Batch service.
    """
    USER_SUBSCRIPTION = "UserSubscription"
    """
    Pools will be allocated in a subscription owned by the user.
    """


class PoolIdentityType(str, Enum):
    """
    The type of identity used for the Batch Pool.
    """
    USER_ASSIGNED = "UserAssigned"
    """
    Batch pool has user assigned identities with it.
    """
    NONE = "None"
    """
    Batch pool has no identity associated with it. Setting `None` in update pool will remove existing identities.
    """


class PublicNetworkAccessType(str, Enum):
    """
    If not specified, the default value is 'enabled'.
    """
    ENABLED = "Enabled"
    """
    Enables connectivity to Azure Batch through public DNS.
    """
    DISABLED = "Disabled"
    """
    Disables public connectivity and enables private connectivity to Azure Batch Service through private endpoint resource.
    """


class ResourceIdentityType(str, Enum):
    """
    The type of identity used for the Batch account.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    """
    Batch account has a system assigned identity with it.
    """
    USER_ASSIGNED = "UserAssigned"
    """
    Batch account has user assigned identities with it.
    """
    NONE = "None"
    """
    Batch account has no identity associated with it. Setting `None` in update account will remove existing identities.
    """


class StorageAccountType(str, Enum):
    """
    If omitted, the default is "Standard_LRS". Values are:

     Standard_LRS - The data disk should use standard locally redundant storage.
     Premium_LRS - The data disk should use premium locally redundant storage.
    """
    STANDARD_LRS = "Standard_LRS"
    """
    The data disk should use standard locally redundant storage.
    """
    PREMIUM_LRS = "Premium_LRS"
    """
    The data disk should use premium locally redundant storage.
    """
