# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._inputs import *

__all__ = ['RaiBlocklistItemArgs', 'RaiBlocklistItem']

@pulumi.input_type
class RaiBlocklistItemArgs:
    def __init__(__self__, *,
                 account_name: pulumi.Input[str],
                 rai_blocklist_name: pulumi.Input[str],
                 resource_group_name: pulumi.Input[str],
                 properties: Optional[pulumi.Input['RaiBlocklistItemPropertiesArgs']] = None,
                 rai_blocklist_item_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a RaiBlocklistItem resource.
        :param pulumi.Input[str] account_name: The name of Cognitive Services account.
        :param pulumi.Input[str] rai_blocklist_name: The name of the RaiBlocklist associated with the Cognitive Services Account
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input['RaiBlocklistItemPropertiesArgs'] properties: Properties of Cognitive Services RaiBlocklist Item.
        :param pulumi.Input[str] rai_blocklist_item_name: The name of the RaiBlocklist Item associated with the custom blocklist
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        """
        pulumi.set(__self__, "account_name", account_name)
        pulumi.set(__self__, "rai_blocklist_name", rai_blocklist_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if properties is not None:
            pulumi.set(__self__, "properties", properties)
        if rai_blocklist_item_name is not None:
            pulumi.set(__self__, "rai_blocklist_item_name", rai_blocklist_item_name)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="accountName")
    def account_name(self) -> pulumi.Input[str]:
        """
        The name of Cognitive Services account.
        """
        return pulumi.get(self, "account_name")

    @account_name.setter
    def account_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "account_name", value)

    @property
    @pulumi.getter(name="raiBlocklistName")
    def rai_blocklist_name(self) -> pulumi.Input[str]:
        """
        The name of the RaiBlocklist associated with the Cognitive Services Account
        """
        return pulumi.get(self, "rai_blocklist_name")

    @rai_blocklist_name.setter
    def rai_blocklist_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "rai_blocklist_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter
    def properties(self) -> Optional[pulumi.Input['RaiBlocklistItemPropertiesArgs']]:
        """
        Properties of Cognitive Services RaiBlocklist Item.
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: Optional[pulumi.Input['RaiBlocklistItemPropertiesArgs']]):
        pulumi.set(self, "properties", value)

    @property
    @pulumi.getter(name="raiBlocklistItemName")
    def rai_blocklist_item_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the RaiBlocklist Item associated with the custom blocklist
        """
        return pulumi.get(self, "rai_blocklist_item_name")

    @rai_blocklist_item_name.setter
    def rai_blocklist_item_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rai_blocklist_item_name", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)


class RaiBlocklistItem(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_name: Optional[pulumi.Input[str]] = None,
                 properties: Optional[pulumi.Input[pulumi.InputType['RaiBlocklistItemPropertiesArgs']]] = None,
                 rai_blocklist_item_name: Optional[pulumi.Input[str]] = None,
                 rai_blocklist_name: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Cognitive Services RaiBlocklist Item.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account_name: The name of Cognitive Services account.
        :param pulumi.Input[pulumi.InputType['RaiBlocklistItemPropertiesArgs']] properties: Properties of Cognitive Services RaiBlocklist Item.
        :param pulumi.Input[str] rai_blocklist_item_name: The name of the RaiBlocklist Item associated with the custom blocklist
        :param pulumi.Input[str] rai_blocklist_name: The name of the RaiBlocklist associated with the Cognitive Services Account
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RaiBlocklistItemArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Cognitive Services RaiBlocklist Item.

        :param str resource_name: The name of the resource.
        :param RaiBlocklistItemArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RaiBlocklistItemArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_name: Optional[pulumi.Input[str]] = None,
                 properties: Optional[pulumi.Input[pulumi.InputType['RaiBlocklistItemPropertiesArgs']]] = None,
                 rai_blocklist_item_name: Optional[pulumi.Input[str]] = None,
                 rai_blocklist_name: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RaiBlocklistItemArgs.__new__(RaiBlocklistItemArgs)

            if account_name is None and not opts.urn:
                raise TypeError("Missing required property 'account_name'")
            __props__.__dict__["account_name"] = account_name
            __props__.__dict__["properties"] = properties
            __props__.__dict__["rai_blocklist_item_name"] = rai_blocklist_item_name
            if rai_blocklist_name is None and not opts.urn:
                raise TypeError("Missing required property 'rai_blocklist_name'")
            __props__.__dict__["rai_blocklist_name"] = rai_blocklist_name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["tags"] = tags
            __props__.__dict__["etag"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:cognitiveservices:RaiBlocklistItem")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(RaiBlocklistItem, __self__).__init__(
            'azure-native:cognitiveservices/v20231001preview:RaiBlocklistItem',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'RaiBlocklistItem':
        """
        Get an existing RaiBlocklistItem resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = RaiBlocklistItemArgs.__new__(RaiBlocklistItemArgs)

        __props__.__dict__["etag"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["properties"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        return RaiBlocklistItem(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def etag(self) -> pulumi.Output[str]:
        """
        Resource Etag.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Output['outputs.RaiBlocklistItemPropertiesResponse']:
        """
        Properties of Cognitive Services RaiBlocklist Item.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Metadata pertaining to creation and last modification of the resource.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

