# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetSuppressionListAddressResult',
    'AwaitableGetSuppressionListAddressResult',
    'get_suppression_list_address',
    'get_suppression_list_address_output',
]

@pulumi.output_type
class GetSuppressionListAddressResult:
    """
    A object that represents a SuppressionList record.
    """
    def __init__(__self__, data_location=None, email=None, first_name=None, id=None, last_modified=None, last_name=None, name=None, notes=None, system_data=None, type=None):
        if data_location and not isinstance(data_location, str):
            raise TypeError("Expected argument 'data_location' to be a str")
        pulumi.set(__self__, "data_location", data_location)
        if email and not isinstance(email, str):
            raise TypeError("Expected argument 'email' to be a str")
        pulumi.set(__self__, "email", email)
        if first_name and not isinstance(first_name, str):
            raise TypeError("Expected argument 'first_name' to be a str")
        pulumi.set(__self__, "first_name", first_name)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if last_modified and not isinstance(last_modified, str):
            raise TypeError("Expected argument 'last_modified' to be a str")
        pulumi.set(__self__, "last_modified", last_modified)
        if last_name and not isinstance(last_name, str):
            raise TypeError("Expected argument 'last_name' to be a str")
        pulumi.set(__self__, "last_name", last_name)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if notes and not isinstance(notes, str):
            raise TypeError("Expected argument 'notes' to be a str")
        pulumi.set(__self__, "notes", notes)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="dataLocation")
    def data_location(self) -> str:
        """
        The location where the SuppressionListAddress data is stored at rest. This value is inherited from the parent Domains resource.
        """
        return pulumi.get(self, "data_location")

    @property
    @pulumi.getter
    def email(self) -> str:
        """
        Email address of the recipient.
        """
        return pulumi.get(self, "email")

    @property
    @pulumi.getter(name="firstName")
    def first_name(self) -> Optional[str]:
        """
        The first name of the email recipient.
        """
        return pulumi.get(self, "first_name")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="lastModified")
    def last_modified(self) -> str:
        """
        The date the address was last updated in a suppression list.
        """
        return pulumi.get(self, "last_modified")

    @property
    @pulumi.getter(name="lastName")
    def last_name(self) -> Optional[str]:
        """
        The last name of the email recipient.
        """
        return pulumi.get(self, "last_name")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def notes(self) -> Optional[str]:
        """
        An optional property to provide contextual notes or a description for an address.
        """
        return pulumi.get(self, "notes")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetSuppressionListAddressResult(GetSuppressionListAddressResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSuppressionListAddressResult(
            data_location=self.data_location,
            email=self.email,
            first_name=self.first_name,
            id=self.id,
            last_modified=self.last_modified,
            last_name=self.last_name,
            name=self.name,
            notes=self.notes,
            system_data=self.system_data,
            type=self.type)


def get_suppression_list_address(address_id: Optional[str] = None,
                                 domain_name: Optional[str] = None,
                                 email_service_name: Optional[str] = None,
                                 resource_group_name: Optional[str] = None,
                                 suppression_list_name: Optional[str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSuppressionListAddressResult:
    """
    Get a SuppressionListAddress.
    Azure REST API version: 2023-06-01-preview.


    :param str address_id: The id of the address in a suppression list.
    :param str domain_name: The name of the Domains resource.
    :param str email_service_name: The name of the EmailService resource.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str suppression_list_name: The name of the suppression list.
    """
    __args__ = dict()
    __args__['addressId'] = address_id
    __args__['domainName'] = domain_name
    __args__['emailServiceName'] = email_service_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['suppressionListName'] = suppression_list_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:communication:getSuppressionListAddress', __args__, opts=opts, typ=GetSuppressionListAddressResult).value

    return AwaitableGetSuppressionListAddressResult(
        data_location=pulumi.get(__ret__, 'data_location'),
        email=pulumi.get(__ret__, 'email'),
        first_name=pulumi.get(__ret__, 'first_name'),
        id=pulumi.get(__ret__, 'id'),
        last_modified=pulumi.get(__ret__, 'last_modified'),
        last_name=pulumi.get(__ret__, 'last_name'),
        name=pulumi.get(__ret__, 'name'),
        notes=pulumi.get(__ret__, 'notes'),
        system_data=pulumi.get(__ret__, 'system_data'),
        type=pulumi.get(__ret__, 'type'))


@_utilities.lift_output_func(get_suppression_list_address)
def get_suppression_list_address_output(address_id: Optional[pulumi.Input[str]] = None,
                                        domain_name: Optional[pulumi.Input[str]] = None,
                                        email_service_name: Optional[pulumi.Input[str]] = None,
                                        resource_group_name: Optional[pulumi.Input[str]] = None,
                                        suppression_list_name: Optional[pulumi.Input[str]] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetSuppressionListAddressResult]:
    """
    Get a SuppressionListAddress.
    Azure REST API version: 2023-06-01-preview.


    :param str address_id: The id of the address in a suppression list.
    :param str domain_name: The name of the Domains resource.
    :param str email_service_name: The name of the EmailService resource.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str suppression_list_name: The name of the suppression list.
    """
    ...
