# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AccumulatedType',
    'BudgetNotificationOperatorType',
    'BudgetOperatorType',
    'CategoryType',
    'ChartType',
    'ConnectorBillingModel',
    'ConnectorStatus',
    'CostAllocationPolicyType',
    'CostAllocationResourceType',
    'CultureCode',
    'DaysOfWeek',
    'ExportType',
    'FileFormat',
    'FormatType',
    'Frequency',
    'FunctionType',
    'GranularityType',
    'KpiTypeType',
    'MetricType',
    'OperatorType',
    'PivotTypeType',
    'QueryColumnType',
    'RecurrenceType',
    'ReportColumnType',
    'ReportConfigSortingType',
    'ReportGranularityType',
    'ReportTimeframeType',
    'ReportType',
    'RuleStatus',
    'ScheduleFrequency',
    'ScheduledActionKind',
    'ScheduledActionStatus',
    'SettingsKind',
    'StatusType',
    'ThresholdType',
    'TimeGrainType',
    'TimeframeType',
    'WeeksOfMonth',
]


class AccumulatedType(str, Enum):
    """
    Show costs accumulated over time.
    """
    TRUE = "true"
    FALSE = "false"


class BudgetNotificationOperatorType(str, Enum):
    """
    The comparison operator.

     Supported for CategoryType(s): Cost, ReservationUtilization.

     Supported operators for **CategoryType: Cost**
    - GreaterThan
    - GreaterThanOrEqualTo

     Supported operators for **CategoryType: ReservationUtilization**
    - LessThan
    """
    EQUAL_TO = "EqualTo"
    """
    Notification will be triggered if the evaluated cost is the same as threshold value. Note: It’s not recommended to use this OperatorType as there’s low chance of cost being exactly the same as threshold value, leading to missing of your alert. This OperatorType will be deprecated in future.

     Supported for CategoryType(s): Cost.
    """
    GREATER_THAN = "GreaterThan"
    """
    Notification will be triggered if the evaluated cost is greater than the threshold value. Note: This is the recommended OperatorType while configuring Budget Alert.

     Supported for CategoryType(s): Cost.
    """
    GREATER_THAN_OR_EQUAL_TO = "GreaterThanOrEqualTo"
    """
    Notification will be triggered if the evaluated cost is greater than or equal to the threshold value.

     Supported for CategoryType(s): Cost.
    """
    LESS_THAN = "LessThan"
    """
    Notification will be triggered if any Reservations in the scope of the Reservation Utilization Alert Rule have a utilization less than the threshold percentage.

     Supported for CategoryType(s): ReservationUtilization.
    """


class BudgetOperatorType(str, Enum):
    """
    The operator to use for comparison.
    """
    IN_ = "In"


class CategoryType(str, Enum):
    """
    The category of the budget.
    - 'Cost' defines a Budget.
    - 'ReservationUtilization' defines a Reservation Utilization Alert Rule.
    """
    COST = "Cost"
    """
    A Budget that evaluates monetary cost of Azure resources against an amount, and alerts based on a configured notification threshold.
    """
    RESERVATION_UTILIZATION = "ReservationUtilization"
    """
    An Alert Rule that evaluates the utilization percentage of Azure Reservations, and alerts based on a configured notification threshold.
    """


class ChartType(str, Enum):
    """
    Chart type of the main view in Cost Analysis. Required.
    """
    AREA = "Area"
    LINE = "Line"
    STACKED_COLUMN = "StackedColumn"
    GROUPED_COLUMN = "GroupedColumn"
    TABLE = "Table"


class ConnectorBillingModel(str, Enum):
    """
    Connector billing model
    """
    TRIAL = "trial"
    AUTO_UPGRADE = "autoUpgrade"
    PREMIUM = "premium"
    EXPIRED = "expired"


class ConnectorStatus(str, Enum):
    """
    Connector status
    """
    ACTIVE = "active"
    ERROR = "error"
    SUSPENDED = "suspended"


class CostAllocationPolicyType(str, Enum):
    """
    Method of cost allocation for the rule
    """
    FIXED_PROPORTION = "FixedProportion"


class CostAllocationResourceType(str, Enum):
    """
    Type of resources contained in this cost allocation rule
    """
    DIMENSION = "Dimension"
    """
    Indicates an Azure dimension such as a subscription id or resource group name is being used for allocation.
    """
    TAG = "Tag"
    """
    Allocates cost based on Azure Tag key value pairs.
    """


class CultureCode(str, Enum):
    """
    Language in which the recipient will receive the notification, 

     Supported for CategoryType(s): Cost, ReservationUtilization.
    """
    EN_US = "en-us"
    JA_JP = "ja-jp"
    ZH_CN = "zh-cn"
    DE_DE = "de-de"
    ES_ES = "es-es"
    FR_FR = "fr-fr"
    IT_IT = "it-it"
    KO_KR = "ko-kr"
    PT_BR = "pt-br"
    RU_RU = "ru-ru"
    ZH_TW = "zh-tw"
    CS_CZ = "cs-cz"
    PL_PL = "pl-pl"
    TR_TR = "tr-tr"
    DA_DK = "da-dk"
    EN_GB = "en-gb"
    HU_HU = "hu-hu"
    NB_NO = "nb-no"
    NL_NL = "nl-nl"
    PT_PT = "pt-pt"
    SV_SE = "sv-se"


class DaysOfWeek(str, Enum):
    """
    Days of Week.
    """
    MONDAY = "Monday"
    TUESDAY = "Tuesday"
    WEDNESDAY = "Wednesday"
    THURSDAY = "Thursday"
    FRIDAY = "Friday"
    SATURDAY = "Saturday"
    SUNDAY = "Sunday"


class ExportType(str, Enum):
    """
    The type of the export. Note that 'Usage' is equivalent to 'ActualCost' and is applicable to exports that do not yet provide data for charges or amortization for service reservations.
    """
    USAGE = "Usage"
    ACTUAL_COST = "ActualCost"
    AMORTIZED_COST = "AmortizedCost"


class FileFormat(str, Enum):
    """
    Destination of the view data. Currently only CSV format is supported.
    """
    CSV = "Csv"


class FormatType(str, Enum):
    """
    The format of the report being delivered.
    """
    CSV = "Csv"


class Frequency(str, Enum):
    """
    Frequency of a notification. Represents how long the notification will be silent after triggering an alert for a threshold breach. If not specified, the frequency will be set by default based on the timeGrain (Weekly when timeGrain: Last7Days, Monthly when timeGrain: Last30Days).

     Supported for CategoryType(s): ReservationUtilization.
    """
    DAILY = "Daily"
    """
    After the threshold breaches and an Alert is fired, no further alerts will be sent until the next calendar day.
    """
    WEEKLY = "Weekly"
    """
    After the threshold breaches and an Alert is fired, no further alerts will be sent for 7 calendar days.
    """
    MONTHLY = "Monthly"
    """
    After the threshold breaches and an Alert is fired, no further alerts will be sent for 30 calendar days.
    """


class FunctionType(str, Enum):
    """
    The name of the aggregation function to use.
    """
    SUM = "Sum"


class GranularityType(str, Enum):
    """
    The granularity of rows in the report.
    """
    DAILY = "Daily"
    HOURLY = "Hourly"


class KpiTypeType(str, Enum):
    """
    KPI type (Forecast, Budget).
    """
    FORECAST = "Forecast"
    BUDGET = "Budget"


class MetricType(str, Enum):
    """
    Metric to use when displaying costs.
    """
    ACTUAL_COST = "ActualCost"
    AMORTIZED_COST = "AmortizedCost"
    AHUB = "AHUB"


class OperatorType(str, Enum):
    """
    The operator to use for comparison.
    """
    IN_ = "In"
    CONTAINS = "Contains"


class PivotTypeType(str, Enum):
    """
    Data type to show in view.
    """
    DIMENSION = "Dimension"
    TAG_KEY = "TagKey"


class QueryColumnType(str, Enum):
    """
    Has type of the column to group.
    """
    TAG_KEY = "TagKey"
    """
    The tag associated with the cost data.
    """
    DIMENSION = "Dimension"
    """
    The dimension of cost data.
    """


class RecurrenceType(str, Enum):
    """
    The schedule recurrence.
    """
    DAILY = "Daily"
    WEEKLY = "Weekly"
    MONTHLY = "Monthly"
    ANNUALLY = "Annually"


class ReportColumnType(str, Enum):
    """
    Has type of the column to group.
    """
    TAG = "Tag"
    DIMENSION = "Dimension"


class ReportConfigSortingType(str, Enum):
    """
    Direction of sort.
    """
    ASCENDING = "Ascending"
    DESCENDING = "Descending"


class ReportGranularityType(str, Enum):
    """
    The granularity of rows in the report.
    """
    DAILY = "Daily"
    MONTHLY = "Monthly"


class ReportTimeframeType(str, Enum):
    """
    The time frame for pulling data for the report. If custom, then a specific time period must be provided.
    """
    WEEK_TO_DATE = "WeekToDate"
    MONTH_TO_DATE = "MonthToDate"
    YEAR_TO_DATE = "YearToDate"
    CUSTOM = "Custom"


class ReportType(str, Enum):
    """
    The type of the report. Usage represents actual usage, forecast represents forecasted data and UsageAndForecast represents both usage and forecasted data. Actual usage and forecasted data can be differentiated based on dates.
    """
    USAGE = "Usage"


class RuleStatus(str, Enum):
    """
    Status of the rule
    """
    NOT_ACTIVE = "NotActive"
    """
    Rule is saved but not used to allocate costs.
    """
    ACTIVE = "Active"
    """
    Rule is saved and impacting cost allocation.
    """
    PROCESSING = "Processing"
    """
    Rule is saved and cost allocation is being updated. Readonly value that cannot be submitted in a put request.
    """


class ScheduleFrequency(str, Enum):
    """
    Frequency of the schedule.
    """
    DAILY = "Daily"
    """
    Cost analysis data will be emailed every day.
    """
    WEEKLY = "Weekly"
    """
    Cost analysis data will be emailed every week.
    """
    MONTHLY = "Monthly"
    """
    Cost analysis data will be emailed every month.
    """


class ScheduledActionKind(str, Enum):
    """
    Kind of the scheduled action.
    """
    EMAIL = "Email"
    """
    Cost analysis data will be emailed.
    """
    INSIGHT_ALERT = "InsightAlert"
    """
    Cost anomaly information will be emailed. Available only on subscription scope at daily frequency. If no anomaly is detected on the resource, an email won't be sent.
    """


class ScheduledActionStatus(str, Enum):
    """
    Status of the scheduled action.
    """
    DISABLED = "Disabled"
    """
    Scheduled action is saved but will not be run.
    """
    ENABLED = "Enabled"
    """
    Scheduled action is saved and will be run.
    """
    EXPIRED = "Expired"
    """
    Scheduled action is expired.
    """


class SettingsKind(str, Enum):
    """
    Specifies the kind of settings.
    """
    TAGINHERITANCE = "taginheritance"


class StatusType(str, Enum):
    """
    The status of the schedule. Whether active or not. If inactive, the report's scheduled execution is paused.
    """
    ACTIVE = "Active"
    INACTIVE = "Inactive"


class ThresholdType(str, Enum):
    """
    The type of threshold.

     Supported for CategoryType(s): Cost.
    """
    ACTUAL = "Actual"
    """
    Actual costs budget alerts notify when the actual accrued cost exceeds the allocated budget.
    """
    FORECASTED = "Forecasted"
    """
    Forecasted costs budget alerts provide advanced notification that your spending trends are likely to exceed your allocated budget, as it relies on forecasted cost predictions.
    """


class TimeGrainType(str, Enum):
    """
    The time covered by a budget. Tracking of the amount will be reset based on the time grain.

    Supported for CategoryType(s): Cost, ReservationUtilization.

     Supported timeGrainTypes for **CategoryType: Cost**

    - Monthly
    - Quarterly
    - Annually
    - BillingMonth*
    - BillingQuarter*
    - BillingAnnual*

      *only supported for Web Direct customers.

     Supported timeGrainTypes for **CategoryType: ReservationUtilization**
    - Last7Days
    - Last30Days

     Required for CategoryType(s): Cost, ReservationUtilization.
    """
    MONTHLY = "Monthly"
    """
    The budget will track costs in the current calendar month against the amount.

     Supported for CategoryType: Cost only.
    """
    QUARTERLY = "Quarterly"
    """
    The budget will track costs in the current calendar quarter against the amount.

     Supported for CategoryType: Cost only.
    """
    ANNUALLY = "Annually"
    """
    The budget will track costs in the current calendar year against the amount.

     Supported for CategoryType: Cost only.
    """
    BILLING_MONTH = "BillingMonth"
    """
    The budget will track costs in the current billing month against the amount.

     Supported for CategoryType: Cost and Web Direct customers only.
    """
    BILLING_QUARTER = "BillingQuarter"
    """
    The budget will track costs in the current billing quarter against the amount.

     Supported for CategoryType: Cost and Web Direct customers only.
    """
    BILLING_ANNUAL = "BillingAnnual"
    """
    The budget will track costs in the current billing year against the amount.

     Supported for CategoryType: Cost and Web Direct customers only.
    """
    LAST7_DAYS = "Last7Days"
    """
    The Reservation Utilization Alert Rule will evaluate reservations based on their 7-Day utilization percentage.

     Supported for CategoryType: ReservationUtilization only.
    """
    LAST30_DAYS = "Last30Days"
    """
    The Reservation Utilization Alert Rule will evaluate reservations based on their 30-Day utilization percentage.

     Supported for CategoryType: ReservationUtilization only.
    """


class TimeframeType(str, Enum):
    """
    The time frame for pulling data for the report. If custom, then a specific time period must be provided.
    """
    WEEK_TO_DATE = "WeekToDate"
    MONTH_TO_DATE = "MonthToDate"
    CUSTOM = "Custom"


class WeeksOfMonth(str, Enum):
    """
    Weeks of month.
    """
    FIRST = "First"
    SECOND = "Second"
    THIRD = "Third"
    FOURTH = "Fourth"
    LAST = "Last"
