# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from ._enums import *

__all__ = [
    'ADLSGen2StorageAccountPathResponse',
    'BlobStorageAccountPathResponse',
    'SystemDataResponse',
]

@pulumi.output_type
class ADLSGen2StorageAccountPathResponse(dict):
    """
    Defines a single ADLS Gen2 storage account path.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "containerName":
            suggest = "container_name"
        elif key == "consumerPath":
            suggest = "consumer_path"
        elif key == "providerPath":
            suggest = "provider_path"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ADLSGen2StorageAccountPathResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ADLSGen2StorageAccountPathResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ADLSGen2StorageAccountPathResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 container_name: str,
                 consumer_path: Optional[str] = None,
                 provider_path: Optional[str] = None):
        """
        Defines a single ADLS Gen2 storage account path.
        :param str container_name: Gets or sets the container name to share.
        :param str consumer_path: Gets or sets the path on the consumer side where the dataset is to be mapped.
        :param str provider_path: Gets or sets the path to file/folder within the container.
        """
        pulumi.set(__self__, "container_name", container_name)
        if consumer_path is not None:
            pulumi.set(__self__, "consumer_path", consumer_path)
        if provider_path is not None:
            pulumi.set(__self__, "provider_path", provider_path)

    @property
    @pulumi.getter(name="containerName")
    def container_name(self) -> str:
        """
        Gets or sets the container name to share.
        """
        return pulumi.get(self, "container_name")

    @property
    @pulumi.getter(name="consumerPath")
    def consumer_path(self) -> Optional[str]:
        """
        Gets or sets the path on the consumer side where the dataset is to be mapped.
        """
        return pulumi.get(self, "consumer_path")

    @property
    @pulumi.getter(name="providerPath")
    def provider_path(self) -> Optional[str]:
        """
        Gets or sets the path to file/folder within the container.
        """
        return pulumi.get(self, "provider_path")


@pulumi.output_type
class BlobStorageAccountPathResponse(dict):
    """
    Defines a single blob storage account path.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "containerName":
            suggest = "container_name"
        elif key == "consumerPath":
            suggest = "consumer_path"
        elif key == "providerPath":
            suggest = "provider_path"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in BlobStorageAccountPathResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        BlobStorageAccountPathResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        BlobStorageAccountPathResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 container_name: str,
                 consumer_path: Optional[str] = None,
                 provider_path: Optional[str] = None):
        """
        Defines a single blob storage account path.
        :param str container_name: Gets or sets the container name to share.
        :param str consumer_path: Gets or sets the path on the consumer side where the dataset is to be mapped.
        :param str provider_path: Gets or sets the path to file/folder within the container.
        """
        pulumi.set(__self__, "container_name", container_name)
        if consumer_path is not None:
            pulumi.set(__self__, "consumer_path", consumer_path)
        if provider_path is not None:
            pulumi.set(__self__, "provider_path", provider_path)

    @property
    @pulumi.getter(name="containerName")
    def container_name(self) -> str:
        """
        Gets or sets the container name to share.
        """
        return pulumi.get(self, "container_name")

    @property
    @pulumi.getter(name="consumerPath")
    def consumer_path(self) -> Optional[str]:
        """
        Gets or sets the path on the consumer side where the dataset is to be mapped.
        """
        return pulumi.get(self, "consumer_path")

    @property
    @pulumi.getter(name="providerPath")
    def provider_path(self) -> Optional[str]:
        """
        Gets or sets the path to file/folder within the container.
        """
        return pulumi.get(self, "provider_path")


@pulumi.output_type
class SystemDataResponse(dict):
    """
    Metadata pertaining to creation and last modification of the resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createdAt":
            suggest = "created_at"
        elif key == "createdBy":
            suggest = "created_by"
        elif key == "createdByType":
            suggest = "created_by_type"
        elif key == "lastModifiedAt":
            suggest = "last_modified_at"
        elif key == "lastModifiedBy":
            suggest = "last_modified_by"
        elif key == "lastModifiedByType":
            suggest = "last_modified_by_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SystemDataResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 created_at: Optional[str] = None,
                 created_by: Optional[str] = None,
                 created_by_type: Optional[str] = None,
                 last_modified_at: Optional[str] = None,
                 last_modified_by: Optional[str] = None,
                 last_modified_by_type: Optional[str] = None):
        """
        Metadata pertaining to creation and last modification of the resource.
        :param str created_at: The timestamp of resource creation (UTC).
        :param str created_by: The identity that created the resource.
        :param str created_by_type: The type of identity that created the resource.
        :param str last_modified_at: The type of identity that last modified the resource.
        :param str last_modified_by: The identity that last modified the resource.
        :param str last_modified_by_type: The type of identity that last modified the resource.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if created_by is not None:
            pulumi.set(__self__, "created_by", created_by)
        if created_by_type is not None:
            pulumi.set(__self__, "created_by_type", created_by_type)
        if last_modified_at is not None:
            pulumi.set(__self__, "last_modified_at", last_modified_at)
        if last_modified_by is not None:
            pulumi.set(__self__, "last_modified_by", last_modified_by)
        if last_modified_by_type is not None:
            pulumi.set(__self__, "last_modified_by_type", last_modified_by_type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[str]:
        """
        The timestamp of resource creation (UTC).
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> Optional[str]:
        """
        The identity that created the resource.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdByType")
    def created_by_type(self) -> Optional[str]:
        """
        The type of identity that created the resource.
        """
        return pulumi.get(self, "created_by_type")

    @property
    @pulumi.getter(name="lastModifiedAt")
    def last_modified_at(self) -> Optional[str]:
        """
        The type of identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_at")

    @property
    @pulumi.getter(name="lastModifiedBy")
    def last_modified_by(self) -> Optional[str]:
        """
        The identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by")

    @property
    @pulumi.getter(name="lastModifiedByType")
    def last_modified_by_type(self) -> Optional[str]:
        """
        The type of identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by_type")


