# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetCatalogSyncErrorDetailsResult',
    'AwaitableGetCatalogSyncErrorDetailsResult',
    'get_catalog_sync_error_details',
    'get_catalog_sync_error_details_output',
]

@pulumi.output_type
class GetCatalogSyncErrorDetailsResult:
    """
    Synchronization error details.
    """
    def __init__(__self__, conflicts=None, errors=None, operation_error=None):
        if conflicts and not isinstance(conflicts, list):
            raise TypeError("Expected argument 'conflicts' to be a list")
        pulumi.set(__self__, "conflicts", conflicts)
        if errors and not isinstance(errors, list):
            raise TypeError("Expected argument 'errors' to be a list")
        pulumi.set(__self__, "errors", errors)
        if operation_error and not isinstance(operation_error, dict):
            raise TypeError("Expected argument 'operation_error' to be a dict")
        pulumi.set(__self__, "operation_error", operation_error)

    @property
    @pulumi.getter
    def conflicts(self) -> Sequence['outputs.CatalogConflictErrorResponse']:
        """
        Catalog items that have conflicting names.
        """
        return pulumi.get(self, "conflicts")

    @property
    @pulumi.getter
    def errors(self) -> Sequence['outputs.CatalogSyncErrorResponse']:
        """
        Errors that occured during synchronization.
        """
        return pulumi.get(self, "errors")

    @property
    @pulumi.getter(name="operationError")
    def operation_error(self) -> 'outputs.CatalogErrorDetailsResponse':
        """
        Error information for the overall synchronization operation.
        """
        return pulumi.get(self, "operation_error")


class AwaitableGetCatalogSyncErrorDetailsResult(GetCatalogSyncErrorDetailsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCatalogSyncErrorDetailsResult(
            conflicts=self.conflicts,
            errors=self.errors,
            operation_error=self.operation_error)


def get_catalog_sync_error_details(catalog_name: Optional[str] = None,
                                   dev_center_name: Optional[str] = None,
                                   resource_group_name: Optional[str] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCatalogSyncErrorDetailsResult:
    """
    Gets catalog synchronization error details
    Azure REST API version: 2023-08-01-preview.

    Other available API versions: 2023-10-01-preview.


    :param str catalog_name: The name of the Catalog.
    :param str dev_center_name: The name of the devcenter.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['catalogName'] = catalog_name
    __args__['devCenterName'] = dev_center_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:devcenter:getCatalogSyncErrorDetails', __args__, opts=opts, typ=GetCatalogSyncErrorDetailsResult).value

    return AwaitableGetCatalogSyncErrorDetailsResult(
        conflicts=pulumi.get(__ret__, 'conflicts'),
        errors=pulumi.get(__ret__, 'errors'),
        operation_error=pulumi.get(__ret__, 'operation_error'))


@_utilities.lift_output_func(get_catalog_sync_error_details)
def get_catalog_sync_error_details_output(catalog_name: Optional[pulumi.Input[str]] = None,
                                          dev_center_name: Optional[pulumi.Input[str]] = None,
                                          resource_group_name: Optional[pulumi.Input[str]] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetCatalogSyncErrorDetailsResult]:
    """
    Gets catalog synchronization error details
    Azure REST API version: 2023-08-01-preview.

    Other available API versions: 2023-10-01-preview.


    :param str catalog_name: The name of the Catalog.
    :param str dev_center_name: The name of the devcenter.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    ...
