# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetIotDpsResourceResult',
    'AwaitableGetIotDpsResourceResult',
    'get_iot_dps_resource',
    'get_iot_dps_resource_output',
]

@pulumi.output_type
class GetIotDpsResourceResult:
    """
    The description of the provisioning service.
    """
    def __init__(__self__, etag=None, id=None, location=None, name=None, properties=None, resourcegroup=None, sku=None, subscriptionid=None, system_data=None, tags=None, type=None):
        if etag and not isinstance(etag, str):
            raise TypeError("Expected argument 'etag' to be a str")
        pulumi.set(__self__, "etag", etag)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if location and not isinstance(location, str):
            raise TypeError("Expected argument 'location' to be a str")
        pulumi.set(__self__, "location", location)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if properties and not isinstance(properties, dict):
            raise TypeError("Expected argument 'properties' to be a dict")
        pulumi.set(__self__, "properties", properties)
        if resourcegroup and not isinstance(resourcegroup, str):
            raise TypeError("Expected argument 'resourcegroup' to be a str")
        pulumi.set(__self__, "resourcegroup", resourcegroup)
        if sku and not isinstance(sku, dict):
            raise TypeError("Expected argument 'sku' to be a dict")
        pulumi.set(__self__, "sku", sku)
        if subscriptionid and not isinstance(subscriptionid, str):
            raise TypeError("Expected argument 'subscriptionid' to be a str")
        pulumi.set(__self__, "subscriptionid", subscriptionid)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def etag(self) -> Optional[str]:
        """
        The Etag field is *not* required. If it is provided in the response body, it must also be provided as a header per the normal ETag convention.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The resource identifier.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def location(self) -> str:
        """
        The resource location.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> 'outputs.IotDpsPropertiesDescriptionResponse':
        """
        Service specific properties for a provisioning service
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter
    def resourcegroup(self) -> Optional[str]:
        """
        The resource group of the resource.
        """
        return pulumi.get(self, "resourcegroup")

    @property
    @pulumi.getter
    def sku(self) -> 'outputs.IotDpsSkuInfoResponse':
        """
        Sku info for a provisioning Service.
        """
        return pulumi.get(self, "sku")

    @property
    @pulumi.getter
    def subscriptionid(self) -> Optional[str]:
        """
        The subscription id of the resource.
        """
        return pulumi.get(self, "subscriptionid")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Metadata pertaining to creation and last modification of the resource.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, str]]:
        """
        The resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The resource type.
        """
        return pulumi.get(self, "type")


class AwaitableGetIotDpsResourceResult(GetIotDpsResourceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetIotDpsResourceResult(
            etag=self.etag,
            id=self.id,
            location=self.location,
            name=self.name,
            properties=self.properties,
            resourcegroup=self.resourcegroup,
            sku=self.sku,
            subscriptionid=self.subscriptionid,
            system_data=self.system_data,
            tags=self.tags,
            type=self.type)


def get_iot_dps_resource(provisioning_service_name: Optional[str] = None,
                         resource_group_name: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetIotDpsResourceResult:
    """
    Get the metadata of the provisioning service without SAS keys.
    Azure REST API version: 2022-12-12.

    Other available API versions: 2020-09-01-preview, 2023-03-01-preview.


    :param str provisioning_service_name: Name of the provisioning service to retrieve.
    :param str resource_group_name: Resource group name.
    """
    __args__ = dict()
    __args__['provisioningServiceName'] = provisioning_service_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:devices:getIotDpsResource', __args__, opts=opts, typ=GetIotDpsResourceResult).value

    return AwaitableGetIotDpsResourceResult(
        etag=pulumi.get(__ret__, 'etag'),
        id=pulumi.get(__ret__, 'id'),
        location=pulumi.get(__ret__, 'location'),
        name=pulumi.get(__ret__, 'name'),
        properties=pulumi.get(__ret__, 'properties'),
        resourcegroup=pulumi.get(__ret__, 'resourcegroup'),
        sku=pulumi.get(__ret__, 'sku'),
        subscriptionid=pulumi.get(__ret__, 'subscriptionid'),
        system_data=pulumi.get(__ret__, 'system_data'),
        tags=pulumi.get(__ret__, 'tags'),
        type=pulumi.get(__ret__, 'type'))


@_utilities.lift_output_func(get_iot_dps_resource)
def get_iot_dps_resource_output(provisioning_service_name: Optional[pulumi.Input[str]] = None,
                                resource_group_name: Optional[pulumi.Input[str]] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetIotDpsResourceResult]:
    """
    Get the metadata of the provisioning service without SAS keys.
    Azure REST API version: 2022-12-12.

    Other available API versions: 2020-09-01-preview, 2023-03-01-preview.


    :param str provisioning_service_name: Name of the provisioning service to retrieve.
    :param str resource_group_name: Resource group name.
    """
    ...
