# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['CloudHsmClusterArgs', 'CloudHsmCluster']

@pulumi.input_type
class CloudHsmClusterArgs:
    def __init__(__self__, *,
                 resource_group_name: pulumi.Input[str],
                 auto_generated_domain_name_label_scope: Optional[pulumi.Input[str]] = None,
                 cloud_hsm_cluster_name: Optional[pulumi.Input[str]] = None,
                 hsms: Optional[pulumi.Input[Sequence[pulumi.Input['CloudHsmPropertiesArgs']]]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 private_endpoint_connections: Optional[pulumi.Input[Sequence[pulumi.Input['PrivateEndpointConnectionArgs']]]] = None,
                 provisioning_state: Optional[pulumi.Input[Union[str, 'ProvisioningState']]] = None,
                 public_network_access: Optional[pulumi.Input[str]] = None,
                 security_domain: Optional[pulumi.Input['CloudHsmClusterSecurityDomainPropertiesArgs']] = None,
                 sku: Optional[pulumi.Input['CloudHsmClusterSkuArgs']] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a CloudHsmCluster resource.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] auto_generated_domain_name_label_scope: The Cloud HSM Cluster's auto-generated Domain Name Label Scope
        :param pulumi.Input[str] cloud_hsm_cluster_name: The name of the Cloud HSM Cluster within the specified resource group. Cloud HSM Cluster names must be between 3 and 24 characters in length.
        :param pulumi.Input[Sequence[pulumi.Input['CloudHsmPropertiesArgs']]] hsms: An array of Cloud HSM Cluster's HSMs
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[Sequence[pulumi.Input['PrivateEndpointConnectionArgs']]] private_endpoint_connections: List of private endpoint connection resources
               These are also available as standalone resources. Do not mix inline and standalone resource as they will conflict with each other, leading to resources deletion.
        :param pulumi.Input[Union[str, 'ProvisioningState']] provisioning_state: The Cloud HSM Cluster's provisioningState
        :param pulumi.Input[str] public_network_access: The Cloud HSM Cluster public network access
        :param pulumi.Input['CloudHsmClusterSecurityDomainPropertiesArgs'] security_domain: Security domain properties information for Cloud HSM cluster
        :param pulumi.Input['CloudHsmClusterSkuArgs'] sku: SKU details
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        """
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if auto_generated_domain_name_label_scope is not None:
            pulumi.set(__self__, "auto_generated_domain_name_label_scope", auto_generated_domain_name_label_scope)
        if cloud_hsm_cluster_name is not None:
            pulumi.set(__self__, "cloud_hsm_cluster_name", cloud_hsm_cluster_name)
        if hsms is not None:
            pulumi.set(__self__, "hsms", hsms)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if private_endpoint_connections is not None:
            pulumi.set(__self__, "private_endpoint_connections", private_endpoint_connections)
        if provisioning_state is not None:
            pulumi.set(__self__, "provisioning_state", provisioning_state)
        if public_network_access is not None:
            pulumi.set(__self__, "public_network_access", public_network_access)
        if security_domain is not None:
            pulumi.set(__self__, "security_domain", security_domain)
        if sku is not None:
            pulumi.set(__self__, "sku", sku)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="autoGeneratedDomainNameLabelScope")
    def auto_generated_domain_name_label_scope(self) -> Optional[pulumi.Input[str]]:
        """
        The Cloud HSM Cluster's auto-generated Domain Name Label Scope
        """
        return pulumi.get(self, "auto_generated_domain_name_label_scope")

    @auto_generated_domain_name_label_scope.setter
    def auto_generated_domain_name_label_scope(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "auto_generated_domain_name_label_scope", value)

    @property
    @pulumi.getter(name="cloudHsmClusterName")
    def cloud_hsm_cluster_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the Cloud HSM Cluster within the specified resource group. Cloud HSM Cluster names must be between 3 and 24 characters in length.
        """
        return pulumi.get(self, "cloud_hsm_cluster_name")

    @cloud_hsm_cluster_name.setter
    def cloud_hsm_cluster_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cloud_hsm_cluster_name", value)

    @property
    @pulumi.getter
    def hsms(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['CloudHsmPropertiesArgs']]]]:
        """
        An array of Cloud HSM Cluster's HSMs
        """
        return pulumi.get(self, "hsms")

    @hsms.setter
    def hsms(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['CloudHsmPropertiesArgs']]]]):
        pulumi.set(self, "hsms", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="privateEndpointConnections")
    def private_endpoint_connections(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['PrivateEndpointConnectionArgs']]]]:
        """
        List of private endpoint connection resources
        These are also available as standalone resources. Do not mix inline and standalone resource as they will conflict with each other, leading to resources deletion.
        """
        return pulumi.get(self, "private_endpoint_connections")

    @private_endpoint_connections.setter
    def private_endpoint_connections(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['PrivateEndpointConnectionArgs']]]]):
        pulumi.set(self, "private_endpoint_connections", value)

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> Optional[pulumi.Input[Union[str, 'ProvisioningState']]]:
        """
        The Cloud HSM Cluster's provisioningState
        """
        return pulumi.get(self, "provisioning_state")

    @provisioning_state.setter
    def provisioning_state(self, value: Optional[pulumi.Input[Union[str, 'ProvisioningState']]]):
        pulumi.set(self, "provisioning_state", value)

    @property
    @pulumi.getter(name="publicNetworkAccess")
    def public_network_access(self) -> Optional[pulumi.Input[str]]:
        """
        The Cloud HSM Cluster public network access
        """
        return pulumi.get(self, "public_network_access")

    @public_network_access.setter
    def public_network_access(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "public_network_access", value)

    @property
    @pulumi.getter(name="securityDomain")
    def security_domain(self) -> Optional[pulumi.Input['CloudHsmClusterSecurityDomainPropertiesArgs']]:
        """
        Security domain properties information for Cloud HSM cluster
        """
        return pulumi.get(self, "security_domain")

    @security_domain.setter
    def security_domain(self, value: Optional[pulumi.Input['CloudHsmClusterSecurityDomainPropertiesArgs']]):
        pulumi.set(self, "security_domain", value)

    @property
    @pulumi.getter
    def sku(self) -> Optional[pulumi.Input['CloudHsmClusterSkuArgs']]:
        """
        SKU details
        """
        return pulumi.get(self, "sku")

    @sku.setter
    def sku(self, value: Optional[pulumi.Input['CloudHsmClusterSkuArgs']]):
        pulumi.set(self, "sku", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)


class CloudHsmCluster(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_generated_domain_name_label_scope: Optional[pulumi.Input[str]] = None,
                 cloud_hsm_cluster_name: Optional[pulumi.Input[str]] = None,
                 hsms: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['CloudHsmPropertiesArgs']]]]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 private_endpoint_connections: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PrivateEndpointConnectionArgs']]]]] = None,
                 provisioning_state: Optional[pulumi.Input[Union[str, 'ProvisioningState']]] = None,
                 public_network_access: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 security_domain: Optional[pulumi.Input[pulumi.InputType['CloudHsmClusterSecurityDomainPropertiesArgs']]] = None,
                 sku: Optional[pulumi.Input[pulumi.InputType['CloudHsmClusterSkuArgs']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Resource information with extended details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] auto_generated_domain_name_label_scope: The Cloud HSM Cluster's auto-generated Domain Name Label Scope
        :param pulumi.Input[str] cloud_hsm_cluster_name: The name of the Cloud HSM Cluster within the specified resource group. Cloud HSM Cluster names must be between 3 and 24 characters in length.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['CloudHsmPropertiesArgs']]]] hsms: An array of Cloud HSM Cluster's HSMs
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PrivateEndpointConnectionArgs']]]] private_endpoint_connections: List of private endpoint connection resources
               These are also available as standalone resources. Do not mix inline and standalone resource as they will conflict with each other, leading to resources deletion.
        :param pulumi.Input[Union[str, 'ProvisioningState']] provisioning_state: The Cloud HSM Cluster's provisioningState
        :param pulumi.Input[str] public_network_access: The Cloud HSM Cluster public network access
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[pulumi.InputType['CloudHsmClusterSecurityDomainPropertiesArgs']] security_domain: Security domain properties information for Cloud HSM cluster
        :param pulumi.Input[pulumi.InputType['CloudHsmClusterSkuArgs']] sku: SKU details
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CloudHsmClusterArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource information with extended details.

        :param str resource_name: The name of the resource.
        :param CloudHsmClusterArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CloudHsmClusterArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_generated_domain_name_label_scope: Optional[pulumi.Input[str]] = None,
                 cloud_hsm_cluster_name: Optional[pulumi.Input[str]] = None,
                 hsms: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['CloudHsmPropertiesArgs']]]]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 private_endpoint_connections: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PrivateEndpointConnectionArgs']]]]] = None,
                 provisioning_state: Optional[pulumi.Input[Union[str, 'ProvisioningState']]] = None,
                 public_network_access: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 security_domain: Optional[pulumi.Input[pulumi.InputType['CloudHsmClusterSecurityDomainPropertiesArgs']]] = None,
                 sku: Optional[pulumi.Input[pulumi.InputType['CloudHsmClusterSkuArgs']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CloudHsmClusterArgs.__new__(CloudHsmClusterArgs)

            __props__.__dict__["auto_generated_domain_name_label_scope"] = auto_generated_domain_name_label_scope
            __props__.__dict__["cloud_hsm_cluster_name"] = cloud_hsm_cluster_name
            __props__.__dict__["hsms"] = hsms
            __props__.__dict__["location"] = location
            __props__.__dict__["private_endpoint_connections"] = private_endpoint_connections
            __props__.__dict__["provisioning_state"] = provisioning_state
            __props__.__dict__["public_network_access"] = public_network_access
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["security_domain"] = security_domain
            __props__.__dict__["sku"] = sku
            __props__.__dict__["tags"] = tags
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:hardwaresecuritymodules:CloudHsmCluster"), pulumi.Alias(type_="azure-native:hardwaresecuritymodules/v20231210preview:CloudHsmCluster")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(CloudHsmCluster, __self__).__init__(
            'azure-native:hardwaresecuritymodules/v20220831preview:CloudHsmCluster',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'CloudHsmCluster':
        """
        Get an existing CloudHsmCluster resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = CloudHsmClusterArgs.__new__(CloudHsmClusterArgs)

        __props__.__dict__["auto_generated_domain_name_label_scope"] = None
        __props__.__dict__["hsms"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["private_endpoint_connections"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["public_network_access"] = None
        __props__.__dict__["security_domain"] = None
        __props__.__dict__["sku"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        return CloudHsmCluster(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="autoGeneratedDomainNameLabelScope")
    def auto_generated_domain_name_label_scope(self) -> pulumi.Output[Optional[str]]:
        """
        The Cloud HSM Cluster's auto-generated Domain Name Label Scope
        """
        return pulumi.get(self, "auto_generated_domain_name_label_scope")

    @property
    @pulumi.getter
    def hsms(self) -> pulumi.Output[Optional[Sequence['outputs.CloudHsmPropertiesResponse']]]:
        """
        An array of Cloud HSM Cluster's HSMs
        """
        return pulumi.get(self, "hsms")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="privateEndpointConnections")
    def private_endpoint_connections(self) -> pulumi.Output[Optional[Sequence['outputs.PrivateEndpointConnectionResponse']]]:
        """
        List of private endpoint connection resources
        """
        return pulumi.get(self, "private_endpoint_connections")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[Optional[str]]:
        """
        The Cloud HSM Cluster's provisioningState
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="publicNetworkAccess")
    def public_network_access(self) -> pulumi.Output[Optional[str]]:
        """
        The Cloud HSM Cluster public network access
        """
        return pulumi.get(self, "public_network_access")

    @property
    @pulumi.getter(name="securityDomain")
    def security_domain(self) -> pulumi.Output[Optional['outputs.CloudHsmClusterSecurityDomainPropertiesResponse']]:
        """
        Security domain properties information for Cloud HSM cluster
        """
        return pulumi.get(self, "security_domain")

    @property
    @pulumi.getter
    def sku(self) -> pulumi.Output[Optional['outputs.CloudHsmClusterSkuResponse']]:
        """
        SKU details
        """
        return pulumi.get(self, "sku")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

