# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._inputs import *

__all__ = ['CloudConnectionArgs', 'CloudConnection']

@pulumi.input_type
class CloudConnectionArgs:
    def __init__(__self__, *,
                 resource_group_name: pulumi.Input[str],
                 cloud_connection_name: Optional[pulumi.Input[str]] = None,
                 cloud_connector: Optional[pulumi.Input['ResourceReferenceArgs']] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 remote_resource_id: Optional[pulumi.Input[str]] = None,
                 shared_key: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 virtual_hub: Optional[pulumi.Input['ResourceReferenceArgs']] = None):
        """
        The set of arguments for constructing a CloudConnection resource.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] cloud_connection_name: The name of the cloud connection resource
        :param pulumi.Input['ResourceReferenceArgs'] cloud_connector: The cloud connector which discovered the remote resource.
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[str] remote_resource_id: Identifier for the remote cloud resource
        :param pulumi.Input[str] shared_key: Shared key of the cloud connection.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        :param pulumi.Input['ResourceReferenceArgs'] virtual_hub: The virtualHub to which the cloud connection belongs.
        """
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if cloud_connection_name is not None:
            pulumi.set(__self__, "cloud_connection_name", cloud_connection_name)
        if cloud_connector is not None:
            pulumi.set(__self__, "cloud_connector", cloud_connector)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if remote_resource_id is not None:
            pulumi.set(__self__, "remote_resource_id", remote_resource_id)
        if shared_key is not None:
            pulumi.set(__self__, "shared_key", shared_key)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if virtual_hub is not None:
            pulumi.set(__self__, "virtual_hub", virtual_hub)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="cloudConnectionName")
    def cloud_connection_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the cloud connection resource
        """
        return pulumi.get(self, "cloud_connection_name")

    @cloud_connection_name.setter
    def cloud_connection_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cloud_connection_name", value)

    @property
    @pulumi.getter(name="cloudConnector")
    def cloud_connector(self) -> Optional[pulumi.Input['ResourceReferenceArgs']]:
        """
        The cloud connector which discovered the remote resource.
        """
        return pulumi.get(self, "cloud_connector")

    @cloud_connector.setter
    def cloud_connector(self, value: Optional[pulumi.Input['ResourceReferenceArgs']]):
        pulumi.set(self, "cloud_connector", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="remoteResourceId")
    def remote_resource_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identifier for the remote cloud resource
        """
        return pulumi.get(self, "remote_resource_id")

    @remote_resource_id.setter
    def remote_resource_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "remote_resource_id", value)

    @property
    @pulumi.getter(name="sharedKey")
    def shared_key(self) -> Optional[pulumi.Input[str]]:
        """
        Shared key of the cloud connection.
        """
        return pulumi.get(self, "shared_key")

    @shared_key.setter
    def shared_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "shared_key", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="virtualHub")
    def virtual_hub(self) -> Optional[pulumi.Input['ResourceReferenceArgs']]:
        """
        The virtualHub to which the cloud connection belongs.
        """
        return pulumi.get(self, "virtual_hub")

    @virtual_hub.setter
    def virtual_hub(self, value: Optional[pulumi.Input['ResourceReferenceArgs']]):
        pulumi.set(self, "virtual_hub", value)


class CloudConnection(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cloud_connection_name: Optional[pulumi.Input[str]] = None,
                 cloud_connector: Optional[pulumi.Input[pulumi.InputType['ResourceReferenceArgs']]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 remote_resource_id: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 shared_key: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 virtual_hub: Optional[pulumi.Input[pulumi.InputType['ResourceReferenceArgs']]] = None,
                 __props__=None):
        """
        Resource which represents the managed network connection between Azure Gateways and remote cloud gateways.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cloud_connection_name: The name of the cloud connection resource
        :param pulumi.Input[pulumi.InputType['ResourceReferenceArgs']] cloud_connector: The cloud connector which discovered the remote resource.
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[str] remote_resource_id: Identifier for the remote cloud resource
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] shared_key: Shared key of the cloud connection.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        :param pulumi.Input[pulumi.InputType['ResourceReferenceArgs']] virtual_hub: The virtualHub to which the cloud connection belongs.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CloudConnectionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource which represents the managed network connection between Azure Gateways and remote cloud gateways.

        :param str resource_name: The name of the resource.
        :param CloudConnectionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CloudConnectionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cloud_connection_name: Optional[pulumi.Input[str]] = None,
                 cloud_connector: Optional[pulumi.Input[pulumi.InputType['ResourceReferenceArgs']]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 remote_resource_id: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 shared_key: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 virtual_hub: Optional[pulumi.Input[pulumi.InputType['ResourceReferenceArgs']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CloudConnectionArgs.__new__(CloudConnectionArgs)

            __props__.__dict__["cloud_connection_name"] = cloud_connection_name
            __props__.__dict__["cloud_connector"] = cloud_connector
            __props__.__dict__["location"] = location
            __props__.__dict__["remote_resource_id"] = remote_resource_id
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["shared_key"] = shared_key
            __props__.__dict__["tags"] = tags
            __props__.__dict__["virtual_hub"] = virtual_hub
            __props__.__dict__["etag"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:hybridcloud:CloudConnection")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(CloudConnection, __self__).__init__(
            'azure-native:hybridcloud/v20230101preview:CloudConnection',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'CloudConnection':
        """
        Get an existing CloudConnection resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = CloudConnectionArgs.__new__(CloudConnectionArgs)

        __props__.__dict__["cloud_connector"] = None
        __props__.__dict__["etag"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["remote_resource_id"] = None
        __props__.__dict__["shared_key"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        __props__.__dict__["virtual_hub"] = None
        return CloudConnection(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="cloudConnector")
    def cloud_connector(self) -> pulumi.Output[Optional['outputs.ResourceReferenceResponse']]:
        """
        The cloud connector which discovered the remote resource.
        """
        return pulumi.get(self, "cloud_connector")

    @property
    @pulumi.getter
    def etag(self) -> pulumi.Output[str]:
        """
        A unique read-only string that changes whenever the resource is updated.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        The provisioning state of the cloud collection resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="remoteResourceId")
    def remote_resource_id(self) -> pulumi.Output[Optional[str]]:
        """
        Identifier for the remote cloud resource
        """
        return pulumi.get(self, "remote_resource_id")

    @property
    @pulumi.getter(name="sharedKey")
    def shared_key(self) -> pulumi.Output[Optional[str]]:
        """
        Shared key of the cloud connection.
        """
        return pulumi.get(self, "shared_key")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="virtualHub")
    def virtual_hub(self) -> pulumi.Output[Optional['outputs.ResourceReferenceResponse']]:
        """
        The virtualHub to which the cloud connection belongs.
        """
        return pulumi.get(self, "virtual_hub")

