# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AzureHybridBenefit',
    'Expander',
    'ExtendedLocationTypes',
    'NetworkPolicy',
    'OSSKU',
    'OsType',
]


class AzureHybridBenefit(str, Enum):
    """
    Indicates whether Azure Hybrid Benefit is opted in. Default value is false
    """
    TRUE = "True"
    FALSE = "False"
    NOT_APPLICABLE = "NotApplicable"


class Expander(str, Enum):
    """
    If not specified, the default is 'random'. See [expanders](https://github.com/kubernetes/autoscaler/blob/master/cluster-autoscaler/FAQ.md#what-are-expanders) for more information.
    """
    LEAST_WASTE = "least-waste"
    """
    Selects the node group that will have the least idle CPU (if tied, unused memory) after scale-up. This is useful when you have different classes of nodes, for example, high CPU or high memory nodes, and only want to expand those when there are pending pods that need a lot of those resources.
    """
    MOST_PODS = "most-pods"
    """
    Selects the node group that would be able to schedule the most pods when scaling up. This is useful when you are using nodeSelector to make sure certain pods land on certain nodes. Note that this won't cause the autoscaler to select bigger nodes vs. smaller, as it can add multiple smaller nodes at once.
    """
    PRIORITY = "priority"
    """
    Selects the node group that has the highest priority assigned by the user. It's configuration is described in more details [here](https://github.com/kubernetes/autoscaler/blob/master/cluster-autoscaler/expander/priority/readme.md).
    """
    RANDOM = "random"
    """
    Used when you don't have a particular need for the node groups to scale differently.
    """


class ExtendedLocationTypes(str, Enum):
    """
    The extended location type. Allowed value: 'CustomLocation'
    """
    CUSTOM_LOCATION = "CustomLocation"


class NetworkPolicy(str, Enum):
    """
    Network policy used for building Kubernetes network. Possible values include: 'calico'.
    """
    CALICO = "calico"


class OSSKU(str, Enum):
    """
    Specifies the OS SKU used by the agent pool. The default is CBLMariner if OSType is Linux. The default is Windows2019 when OSType is Windows.
    """
    CBL_MARINER = "CBLMariner"
    """
    Use Mariner as the OS for node images.
    """
    WINDOWS2019 = "Windows2019"
    """
    Use Windows2019 as the OS for node images.
    """
    WINDOWS2022 = "Windows2022"
    """
    Use Windows2022 as the OS for node images.
    """


class OsType(str, Enum):
    """
    OSType to be used to specify OS type for the VMs. Choose from Linux and Windows. Default to Linux. Possible values include: 'Linux', 'Windows'
    """
    LINUX = "Linux"
    WINDOWS = "Windows"
