# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetApplicationBusinessProcessDevelopmentArtifactResult',
    'AwaitableGetApplicationBusinessProcessDevelopmentArtifactResult',
    'get_application_business_process_development_artifact',
    'get_application_business_process_development_artifact_output',
]

@pulumi.output_type
class GetApplicationBusinessProcessDevelopmentArtifactResult:
    """
    The business process development artifact save or get response.
    """
    def __init__(__self__, name=None, properties=None, system_data=None):
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if properties and not isinstance(properties, dict):
            raise TypeError("Expected argument 'properties' to be a dict")
        pulumi.set(__self__, "properties", properties)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the business process development artifact.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> 'outputs.BusinessProcessDevelopmentArtifactPropertiesResponse':
        """
        The properties of the business process development artifact.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        The system data of the business process development artifact.
        """
        return pulumi.get(self, "system_data")


class AwaitableGetApplicationBusinessProcessDevelopmentArtifactResult(GetApplicationBusinessProcessDevelopmentArtifactResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetApplicationBusinessProcessDevelopmentArtifactResult(
            name=self.name,
            properties=self.properties,
            system_data=self.system_data)


def get_application_business_process_development_artifact(application_name: Optional[str] = None,
                                                          name: Optional[str] = None,
                                                          resource_group_name: Optional[str] = None,
                                                          space_name: Optional[str] = None,
                                                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetApplicationBusinessProcessDevelopmentArtifactResult:
    """
    The get business process development artifact action.
    Azure REST API version: 2023-11-14-preview.


    :param str application_name: The name of the Application
    :param str name: The name of the business process development artifact.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str space_name: The name of the space
    """
    __args__ = dict()
    __args__['applicationName'] = application_name
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    __args__['spaceName'] = space_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:integrationspaces:getApplicationBusinessProcessDevelopmentArtifact', __args__, opts=opts, typ=GetApplicationBusinessProcessDevelopmentArtifactResult).value

    return AwaitableGetApplicationBusinessProcessDevelopmentArtifactResult(
        name=pulumi.get(__ret__, 'name'),
        properties=pulumi.get(__ret__, 'properties'),
        system_data=pulumi.get(__ret__, 'system_data'))


@_utilities.lift_output_func(get_application_business_process_development_artifact)
def get_application_business_process_development_artifact_output(application_name: Optional[pulumi.Input[str]] = None,
                                                                 name: Optional[pulumi.Input[str]] = None,
                                                                 resource_group_name: Optional[pulumi.Input[str]] = None,
                                                                 space_name: Optional[pulumi.Input[str]] = None,
                                                                 opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetApplicationBusinessProcessDevelopmentArtifactResult]:
    """
    The get business process development artifact action.
    Azure REST API version: 2023-11-14-preview.


    :param str application_name: The name of the Application
    :param str name: The name of the business process development artifact.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str space_name: The name of the space
    """
    ...
