# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._inputs import *

__all__ = ['BusinessProcessArgs', 'BusinessProcess']

@pulumi.input_type
class BusinessProcessArgs:
    def __init__(__self__, *,
                 application_name: pulumi.Input[str],
                 resource_group_name: pulumi.Input[str],
                 space_name: pulumi.Input[str],
                 business_process_mapping: Optional[pulumi.Input[Mapping[str, pulumi.Input['BusinessProcessMappingItemArgs']]]] = None,
                 business_process_name: Optional[pulumi.Input[str]] = None,
                 business_process_stages: Optional[pulumi.Input[Mapping[str, pulumi.Input['BusinessProcessStageArgs']]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 identifier: Optional[pulumi.Input['BusinessProcessIdentifierArgs']] = None,
                 table_name: Optional[pulumi.Input[str]] = None,
                 tracking_data_store_reference_name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a BusinessProcess resource.
        :param pulumi.Input[str] application_name: The name of the Application
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] space_name: The name of the space
        :param pulumi.Input[Mapping[str, pulumi.Input['BusinessProcessMappingItemArgs']]] business_process_mapping: The business process mapping.
        :param pulumi.Input[str] business_process_name: The name of the business process
        :param pulumi.Input[Mapping[str, pulumi.Input['BusinessProcessStageArgs']]] business_process_stages: The business process stages.
        :param pulumi.Input[str] description: The description of the business process.
        :param pulumi.Input['BusinessProcessIdentifierArgs'] identifier: The business process identifier.
        :param pulumi.Input[str] table_name: The table name of the business process.
        :param pulumi.Input[str] tracking_data_store_reference_name: The tracking data store reference name.
        """
        pulumi.set(__self__, "application_name", application_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "space_name", space_name)
        if business_process_mapping is not None:
            pulumi.set(__self__, "business_process_mapping", business_process_mapping)
        if business_process_name is not None:
            pulumi.set(__self__, "business_process_name", business_process_name)
        if business_process_stages is not None:
            pulumi.set(__self__, "business_process_stages", business_process_stages)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if identifier is not None:
            pulumi.set(__self__, "identifier", identifier)
        if table_name is not None:
            pulumi.set(__self__, "table_name", table_name)
        if tracking_data_store_reference_name is not None:
            pulumi.set(__self__, "tracking_data_store_reference_name", tracking_data_store_reference_name)

    @property
    @pulumi.getter(name="applicationName")
    def application_name(self) -> pulumi.Input[str]:
        """
        The name of the Application
        """
        return pulumi.get(self, "application_name")

    @application_name.setter
    def application_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "application_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="spaceName")
    def space_name(self) -> pulumi.Input[str]:
        """
        The name of the space
        """
        return pulumi.get(self, "space_name")

    @space_name.setter
    def space_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "space_name", value)

    @property
    @pulumi.getter(name="businessProcessMapping")
    def business_process_mapping(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input['BusinessProcessMappingItemArgs']]]]:
        """
        The business process mapping.
        """
        return pulumi.get(self, "business_process_mapping")

    @business_process_mapping.setter
    def business_process_mapping(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input['BusinessProcessMappingItemArgs']]]]):
        pulumi.set(self, "business_process_mapping", value)

    @property
    @pulumi.getter(name="businessProcessName")
    def business_process_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the business process
        """
        return pulumi.get(self, "business_process_name")

    @business_process_name.setter
    def business_process_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "business_process_name", value)

    @property
    @pulumi.getter(name="businessProcessStages")
    def business_process_stages(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input['BusinessProcessStageArgs']]]]:
        """
        The business process stages.
        """
        return pulumi.get(self, "business_process_stages")

    @business_process_stages.setter
    def business_process_stages(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input['BusinessProcessStageArgs']]]]):
        pulumi.set(self, "business_process_stages", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the business process.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def identifier(self) -> Optional[pulumi.Input['BusinessProcessIdentifierArgs']]:
        """
        The business process identifier.
        """
        return pulumi.get(self, "identifier")

    @identifier.setter
    def identifier(self, value: Optional[pulumi.Input['BusinessProcessIdentifierArgs']]):
        pulumi.set(self, "identifier", value)

    @property
    @pulumi.getter(name="tableName")
    def table_name(self) -> Optional[pulumi.Input[str]]:
        """
        The table name of the business process.
        """
        return pulumi.get(self, "table_name")

    @table_name.setter
    def table_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "table_name", value)

    @property
    @pulumi.getter(name="trackingDataStoreReferenceName")
    def tracking_data_store_reference_name(self) -> Optional[pulumi.Input[str]]:
        """
        The tracking data store reference name.
        """
        return pulumi.get(self, "tracking_data_store_reference_name")

    @tracking_data_store_reference_name.setter
    def tracking_data_store_reference_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "tracking_data_store_reference_name", value)


class BusinessProcess(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 application_name: Optional[pulumi.Input[str]] = None,
                 business_process_mapping: Optional[pulumi.Input[Mapping[str, pulumi.Input[pulumi.InputType['BusinessProcessMappingItemArgs']]]]] = None,
                 business_process_name: Optional[pulumi.Input[str]] = None,
                 business_process_stages: Optional[pulumi.Input[Mapping[str, pulumi.Input[pulumi.InputType['BusinessProcessStageArgs']]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 identifier: Optional[pulumi.Input[pulumi.InputType['BusinessProcessIdentifierArgs']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 space_name: Optional[pulumi.Input[str]] = None,
                 table_name: Optional[pulumi.Input[str]] = None,
                 tracking_data_store_reference_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        A business process under application.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] application_name: The name of the Application
        :param pulumi.Input[Mapping[str, pulumi.Input[pulumi.InputType['BusinessProcessMappingItemArgs']]]] business_process_mapping: The business process mapping.
        :param pulumi.Input[str] business_process_name: The name of the business process
        :param pulumi.Input[Mapping[str, pulumi.Input[pulumi.InputType['BusinessProcessStageArgs']]]] business_process_stages: The business process stages.
        :param pulumi.Input[str] description: The description of the business process.
        :param pulumi.Input[pulumi.InputType['BusinessProcessIdentifierArgs']] identifier: The business process identifier.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] space_name: The name of the space
        :param pulumi.Input[str] table_name: The table name of the business process.
        :param pulumi.Input[str] tracking_data_store_reference_name: The tracking data store reference name.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BusinessProcessArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        A business process under application.

        :param str resource_name: The name of the resource.
        :param BusinessProcessArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BusinessProcessArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 application_name: Optional[pulumi.Input[str]] = None,
                 business_process_mapping: Optional[pulumi.Input[Mapping[str, pulumi.Input[pulumi.InputType['BusinessProcessMappingItemArgs']]]]] = None,
                 business_process_name: Optional[pulumi.Input[str]] = None,
                 business_process_stages: Optional[pulumi.Input[Mapping[str, pulumi.Input[pulumi.InputType['BusinessProcessStageArgs']]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 identifier: Optional[pulumi.Input[pulumi.InputType['BusinessProcessIdentifierArgs']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 space_name: Optional[pulumi.Input[str]] = None,
                 table_name: Optional[pulumi.Input[str]] = None,
                 tracking_data_store_reference_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BusinessProcessArgs.__new__(BusinessProcessArgs)

            if application_name is None and not opts.urn:
                raise TypeError("Missing required property 'application_name'")
            __props__.__dict__["application_name"] = application_name
            __props__.__dict__["business_process_mapping"] = business_process_mapping
            __props__.__dict__["business_process_name"] = business_process_name
            __props__.__dict__["business_process_stages"] = business_process_stages
            __props__.__dict__["description"] = description
            __props__.__dict__["identifier"] = identifier
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            if space_name is None and not opts.urn:
                raise TypeError("Missing required property 'space_name'")
            __props__.__dict__["space_name"] = space_name
            __props__.__dict__["table_name"] = table_name
            __props__.__dict__["tracking_data_store_reference_name"] = tracking_data_store_reference_name
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
            __props__.__dict__["version"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:integrationspaces:BusinessProcess")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(BusinessProcess, __self__).__init__(
            'azure-native:integrationspaces/v20231114preview:BusinessProcess',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'BusinessProcess':
        """
        Get an existing BusinessProcess resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = BusinessProcessArgs.__new__(BusinessProcessArgs)

        __props__.__dict__["business_process_mapping"] = None
        __props__.__dict__["business_process_stages"] = None
        __props__.__dict__["description"] = None
        __props__.__dict__["identifier"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["table_name"] = None
        __props__.__dict__["tracking_data_store_reference_name"] = None
        __props__.__dict__["type"] = None
        __props__.__dict__["version"] = None
        return BusinessProcess(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="businessProcessMapping")
    def business_process_mapping(self) -> pulumi.Output[Optional[Mapping[str, 'outputs.BusinessProcessMappingItemResponse']]]:
        """
        The business process mapping.
        """
        return pulumi.get(self, "business_process_mapping")

    @property
    @pulumi.getter(name="businessProcessStages")
    def business_process_stages(self) -> pulumi.Output[Optional[Mapping[str, 'outputs.BusinessProcessStageResponse']]]:
        """
        The business process stages.
        """
        return pulumi.get(self, "business_process_stages")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        The description of the business process.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def identifier(self) -> pulumi.Output[Optional['outputs.BusinessProcessIdentifierResponse']]:
        """
        The business process identifier.
        """
        return pulumi.get(self, "identifier")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        The status of the last operation.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter(name="tableName")
    def table_name(self) -> pulumi.Output[Optional[str]]:
        """
        The table name of the business process.
        """
        return pulumi.get(self, "table_name")

    @property
    @pulumi.getter(name="trackingDataStoreReferenceName")
    def tracking_data_store_reference_name(self) -> pulumi.Output[Optional[str]]:
        """
        The tracking data store reference name.
        """
        return pulumi.get(self, "tracking_data_store_reference_name")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[str]:
        """
        The version of the business process.
        """
        return pulumi.get(self, "version")

