# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities

__all__ = [
    'DatasetPropertyKeyArgs',
    'ExtendedLocationArgs',
    'PipelineInputArgs',
    'PipelineStageArgs',
]

@pulumi.input_type
class DatasetPropertyKeyArgs:
    def __init__(__self__, *,
                 path: pulumi.Input[str],
                 primary_key: Optional[pulumi.Input[bool]] = None):
        """
        Key that can be used for joining on enrich.
        :param pulumi.Input[str] path: Path to the input value from the message.
        :param pulumi.Input[bool] primary_key: If true the property will be used as a primary key. At most one primary key can exists.
        """
        pulumi.set(__self__, "path", path)
        if primary_key is not None:
            pulumi.set(__self__, "primary_key", primary_key)

    @property
    @pulumi.getter
    def path(self) -> pulumi.Input[str]:
        """
        Path to the input value from the message.
        """
        return pulumi.get(self, "path")

    @path.setter
    def path(self, value: pulumi.Input[str]):
        pulumi.set(self, "path", value)

    @property
    @pulumi.getter(name="primaryKey")
    def primary_key(self) -> Optional[pulumi.Input[bool]]:
        """
        If true the property will be used as a primary key. At most one primary key can exists.
        """
        return pulumi.get(self, "primary_key")

    @primary_key.setter
    def primary_key(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "primary_key", value)


@pulumi.input_type
class ExtendedLocationArgs:
    def __init__(__self__, *,
                 name: pulumi.Input[str],
                 type: pulumi.Input[str]):
        """
        Extended location is an extension of Azure locations. They provide a way to use their Azure ARC enabled Kubernetes clusters as target locations for deploying Azure services instances.
        :param pulumi.Input[str] name: The name of the extended location.
        :param pulumi.Input[str] type: The type of the extended location.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        The name of the extended location.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        The type of the extended location.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)


@pulumi.input_type
class PipelineInputArgs:
    def __init__(__self__, *,
                 next: pulumi.Input[Sequence[pulumi.Input[str]]],
                 type: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None):
        """
        Stage configuration for Pipeline input stage.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] next: Next stage in the pipeline.
        :param pulumi.Input[str] type: ARM resource type.
        :param pulumi.Input[str] description: Description for stage.
        """
        pulumi.set(__self__, "next", next)
        pulumi.set(__self__, "type", type)
        if description is not None:
            pulumi.set(__self__, "description", description)

    @property
    @pulumi.getter
    def next(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Next stage in the pipeline.
        """
        return pulumi.get(self, "next")

    @next.setter
    def next(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "next", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        ARM resource type.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description for stage.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)


@pulumi.input_type
class PipelineStageArgs:
    def __init__(__self__, *,
                 type: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None,
                 next: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Stage configurations for all Pipeline processing and output stages.
        :param pulumi.Input[str] type: ARM resource type.
        :param pulumi.Input[str] description: Description for stage.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] next: Next stage in the pipeline. Not required if output stage.
        """
        pulumi.set(__self__, "type", type)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if next is not None:
            pulumi.set(__self__, "next", next)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        ARM resource type.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description for stage.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def next(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Next stage in the pipeline. Not required if output stage.
        """
        return pulumi.get(self, "next")

    @next.setter
    def next(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "next", value)


