# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['BrokerListenerArgs', 'BrokerListener']

@pulumi.input_type
class BrokerListenerArgs:
    def __init__(__self__, *,
                 broker_name: pulumi.Input[str],
                 broker_ref: pulumi.Input[str],
                 extended_location: pulumi.Input['ExtendedLocationPropertyArgs'],
                 mq_name: pulumi.Input[str],
                 port: pulumi.Input[int],
                 resource_group_name: pulumi.Input[str],
                 authentication_enabled: Optional[pulumi.Input[bool]] = None,
                 authorization_enabled: Optional[pulumi.Input[bool]] = None,
                 listener_name: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 node_port: Optional[pulumi.Input[int]] = None,
                 service_name: Optional[pulumi.Input[str]] = None,
                 service_type: Optional[pulumi.Input[Union[str, 'ServiceType']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 tls: Optional[pulumi.Input['TlsCertMethodArgs']] = None):
        """
        The set of arguments for constructing a BrokerListener resource.
        :param pulumi.Input[str] broker_name: Name of MQ broker resource
        :param pulumi.Input[str] broker_ref: The k8s cr/resource reference of mq/broker.
        :param pulumi.Input['ExtendedLocationPropertyArgs'] extended_location: Extended Location
        :param pulumi.Input[str] mq_name: Name of MQ resource
        :param pulumi.Input[int] port: The port to start Listening for connections on.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[bool] authentication_enabled: The flag for enabling Authentication rules on Listener Port.
        :param pulumi.Input[bool] authorization_enabled: The flag for enabling Authorization policies on Listener Port. false - AllowAll, true - Use Authorization resource rules if present.
        :param pulumi.Input[str] listener_name: Name of MQ broker/listener resource
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[int] node_port: The node port to use on the Host node.
        :param pulumi.Input[str] service_name: The service name to expose Listener port on.
        :param pulumi.Input[Union[str, 'ServiceType']] service_type: The Kubernetes Service type to deploy for Listener.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        :param pulumi.Input['TlsCertMethodArgs'] tls: Defines configuration of a TLS server certificate. NOTE Enum - Only one TLS Cert method is supported
        """
        pulumi.set(__self__, "broker_name", broker_name)
        pulumi.set(__self__, "broker_ref", broker_ref)
        pulumi.set(__self__, "extended_location", extended_location)
        pulumi.set(__self__, "mq_name", mq_name)
        pulumi.set(__self__, "port", port)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if authentication_enabled is None:
            authentication_enabled = False
        if authentication_enabled is not None:
            pulumi.set(__self__, "authentication_enabled", authentication_enabled)
        if authorization_enabled is None:
            authorization_enabled = False
        if authorization_enabled is not None:
            pulumi.set(__self__, "authorization_enabled", authorization_enabled)
        if listener_name is not None:
            pulumi.set(__self__, "listener_name", listener_name)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if node_port is not None:
            pulumi.set(__self__, "node_port", node_port)
        if service_name is None:
            service_name = 'aio-mq-dmqtt-frontend'
        if service_name is not None:
            pulumi.set(__self__, "service_name", service_name)
        if service_type is None:
            service_type = 'clusterIp'
        if service_type is not None:
            pulumi.set(__self__, "service_type", service_type)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if tls is not None:
            pulumi.set(__self__, "tls", tls)

    @property
    @pulumi.getter(name="brokerName")
    def broker_name(self) -> pulumi.Input[str]:
        """
        Name of MQ broker resource
        """
        return pulumi.get(self, "broker_name")

    @broker_name.setter
    def broker_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "broker_name", value)

    @property
    @pulumi.getter(name="brokerRef")
    def broker_ref(self) -> pulumi.Input[str]:
        """
        The k8s cr/resource reference of mq/broker.
        """
        return pulumi.get(self, "broker_ref")

    @broker_ref.setter
    def broker_ref(self, value: pulumi.Input[str]):
        pulumi.set(self, "broker_ref", value)

    @property
    @pulumi.getter(name="extendedLocation")
    def extended_location(self) -> pulumi.Input['ExtendedLocationPropertyArgs']:
        """
        Extended Location
        """
        return pulumi.get(self, "extended_location")

    @extended_location.setter
    def extended_location(self, value: pulumi.Input['ExtendedLocationPropertyArgs']):
        pulumi.set(self, "extended_location", value)

    @property
    @pulumi.getter(name="mqName")
    def mq_name(self) -> pulumi.Input[str]:
        """
        Name of MQ resource
        """
        return pulumi.get(self, "mq_name")

    @mq_name.setter
    def mq_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "mq_name", value)

    @property
    @pulumi.getter
    def port(self) -> pulumi.Input[int]:
        """
        The port to start Listening for connections on.
        """
        return pulumi.get(self, "port")

    @port.setter
    def port(self, value: pulumi.Input[int]):
        pulumi.set(self, "port", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="authenticationEnabled")
    def authentication_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        The flag for enabling Authentication rules on Listener Port.
        """
        return pulumi.get(self, "authentication_enabled")

    @authentication_enabled.setter
    def authentication_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "authentication_enabled", value)

    @property
    @pulumi.getter(name="authorizationEnabled")
    def authorization_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        The flag for enabling Authorization policies on Listener Port. false - AllowAll, true - Use Authorization resource rules if present.
        """
        return pulumi.get(self, "authorization_enabled")

    @authorization_enabled.setter
    def authorization_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "authorization_enabled", value)

    @property
    @pulumi.getter(name="listenerName")
    def listener_name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of MQ broker/listener resource
        """
        return pulumi.get(self, "listener_name")

    @listener_name.setter
    def listener_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "listener_name", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="nodePort")
    def node_port(self) -> Optional[pulumi.Input[int]]:
        """
        The node port to use on the Host node.
        """
        return pulumi.get(self, "node_port")

    @node_port.setter
    def node_port(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "node_port", value)

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> Optional[pulumi.Input[str]]:
        """
        The service name to expose Listener port on.
        """
        return pulumi.get(self, "service_name")

    @service_name.setter
    def service_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_name", value)

    @property
    @pulumi.getter(name="serviceType")
    def service_type(self) -> Optional[pulumi.Input[Union[str, 'ServiceType']]]:
        """
        The Kubernetes Service type to deploy for Listener.
        """
        return pulumi.get(self, "service_type")

    @service_type.setter
    def service_type(self, value: Optional[pulumi.Input[Union[str, 'ServiceType']]]):
        pulumi.set(self, "service_type", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def tls(self) -> Optional[pulumi.Input['TlsCertMethodArgs']]:
        """
        Defines configuration of a TLS server certificate. NOTE Enum - Only one TLS Cert method is supported
        """
        return pulumi.get(self, "tls")

    @tls.setter
    def tls(self, value: Optional[pulumi.Input['TlsCertMethodArgs']]):
        pulumi.set(self, "tls", value)


class BrokerListener(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 authentication_enabled: Optional[pulumi.Input[bool]] = None,
                 authorization_enabled: Optional[pulumi.Input[bool]] = None,
                 broker_name: Optional[pulumi.Input[str]] = None,
                 broker_ref: Optional[pulumi.Input[str]] = None,
                 extended_location: Optional[pulumi.Input[pulumi.InputType['ExtendedLocationPropertyArgs']]] = None,
                 listener_name: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 mq_name: Optional[pulumi.Input[str]] = None,
                 node_port: Optional[pulumi.Input[int]] = None,
                 port: Optional[pulumi.Input[int]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 service_name: Optional[pulumi.Input[str]] = None,
                 service_type: Optional[pulumi.Input[Union[str, 'ServiceType']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 tls: Optional[pulumi.Input[pulumi.InputType['TlsCertMethodArgs']]] = None,
                 __props__=None):
        """
        MQ broker/listener resource

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] authentication_enabled: The flag for enabling Authentication rules on Listener Port.
        :param pulumi.Input[bool] authorization_enabled: The flag for enabling Authorization policies on Listener Port. false - AllowAll, true - Use Authorization resource rules if present.
        :param pulumi.Input[str] broker_name: Name of MQ broker resource
        :param pulumi.Input[str] broker_ref: The k8s cr/resource reference of mq/broker.
        :param pulumi.Input[pulumi.InputType['ExtendedLocationPropertyArgs']] extended_location: Extended Location
        :param pulumi.Input[str] listener_name: Name of MQ broker/listener resource
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[str] mq_name: Name of MQ resource
        :param pulumi.Input[int] node_port: The node port to use on the Host node.
        :param pulumi.Input[int] port: The port to start Listening for connections on.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] service_name: The service name to expose Listener port on.
        :param pulumi.Input[Union[str, 'ServiceType']] service_type: The Kubernetes Service type to deploy for Listener.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        :param pulumi.Input[pulumi.InputType['TlsCertMethodArgs']] tls: Defines configuration of a TLS server certificate. NOTE Enum - Only one TLS Cert method is supported
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BrokerListenerArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        MQ broker/listener resource

        :param str resource_name: The name of the resource.
        :param BrokerListenerArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BrokerListenerArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 authentication_enabled: Optional[pulumi.Input[bool]] = None,
                 authorization_enabled: Optional[pulumi.Input[bool]] = None,
                 broker_name: Optional[pulumi.Input[str]] = None,
                 broker_ref: Optional[pulumi.Input[str]] = None,
                 extended_location: Optional[pulumi.Input[pulumi.InputType['ExtendedLocationPropertyArgs']]] = None,
                 listener_name: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 mq_name: Optional[pulumi.Input[str]] = None,
                 node_port: Optional[pulumi.Input[int]] = None,
                 port: Optional[pulumi.Input[int]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 service_name: Optional[pulumi.Input[str]] = None,
                 service_type: Optional[pulumi.Input[Union[str, 'ServiceType']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 tls: Optional[pulumi.Input[pulumi.InputType['TlsCertMethodArgs']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BrokerListenerArgs.__new__(BrokerListenerArgs)

            if authentication_enabled is None:
                authentication_enabled = False
            __props__.__dict__["authentication_enabled"] = authentication_enabled
            if authorization_enabled is None:
                authorization_enabled = False
            __props__.__dict__["authorization_enabled"] = authorization_enabled
            if broker_name is None and not opts.urn:
                raise TypeError("Missing required property 'broker_name'")
            __props__.__dict__["broker_name"] = broker_name
            if broker_ref is None and not opts.urn:
                raise TypeError("Missing required property 'broker_ref'")
            __props__.__dict__["broker_ref"] = broker_ref
            if extended_location is None and not opts.urn:
                raise TypeError("Missing required property 'extended_location'")
            __props__.__dict__["extended_location"] = extended_location
            __props__.__dict__["listener_name"] = listener_name
            __props__.__dict__["location"] = location
            if mq_name is None and not opts.urn:
                raise TypeError("Missing required property 'mq_name'")
            __props__.__dict__["mq_name"] = mq_name
            __props__.__dict__["node_port"] = node_port
            if port is None and not opts.urn:
                raise TypeError("Missing required property 'port'")
            __props__.__dict__["port"] = port
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            if service_name is None:
                service_name = 'aio-mq-dmqtt-frontend'
            __props__.__dict__["service_name"] = service_name
            if service_type is None:
                service_type = 'clusterIp'
            __props__.__dict__["service_type"] = service_type
            __props__.__dict__["tags"] = tags
            __props__.__dict__["tls"] = tls
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:iotoperationsmq:BrokerListener")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(BrokerListener, __self__).__init__(
            'azure-native:iotoperationsmq/v20231004preview:BrokerListener',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'BrokerListener':
        """
        Get an existing BrokerListener resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = BrokerListenerArgs.__new__(BrokerListenerArgs)

        __props__.__dict__["authentication_enabled"] = None
        __props__.__dict__["authorization_enabled"] = None
        __props__.__dict__["broker_ref"] = None
        __props__.__dict__["extended_location"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["node_port"] = None
        __props__.__dict__["port"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["service_name"] = None
        __props__.__dict__["service_type"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["tls"] = None
        __props__.__dict__["type"] = None
        return BrokerListener(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="authenticationEnabled")
    def authentication_enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        The flag for enabling Authentication rules on Listener Port.
        """
        return pulumi.get(self, "authentication_enabled")

    @property
    @pulumi.getter(name="authorizationEnabled")
    def authorization_enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        The flag for enabling Authorization policies on Listener Port. false - AllowAll, true - Use Authorization resource rules if present.
        """
        return pulumi.get(self, "authorization_enabled")

    @property
    @pulumi.getter(name="brokerRef")
    def broker_ref(self) -> pulumi.Output[str]:
        """
        The k8s cr/resource reference of mq/broker.
        """
        return pulumi.get(self, "broker_ref")

    @property
    @pulumi.getter(name="extendedLocation")
    def extended_location(self) -> pulumi.Output['outputs.ExtendedLocationPropertyResponse']:
        """
        Extended Location
        """
        return pulumi.get(self, "extended_location")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nodePort")
    def node_port(self) -> pulumi.Output[Optional[int]]:
        """
        The node port to use on the Host node.
        """
        return pulumi.get(self, "node_port")

    @property
    @pulumi.getter
    def port(self) -> pulumi.Output[int]:
        """
        The port to start Listening for connections on.
        """
        return pulumi.get(self, "port")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        The status of the last operation.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> pulumi.Output[Optional[str]]:
        """
        The service name to expose Listener port on.
        """
        return pulumi.get(self, "service_name")

    @property
    @pulumi.getter(name="serviceType")
    def service_type(self) -> pulumi.Output[Optional[str]]:
        """
        The Kubernetes Service type to deploy for Listener.
        """
        return pulumi.get(self, "service_type")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def tls(self) -> pulumi.Output[Optional['outputs.TlsCertMethodResponse']]:
        """
        Defines configuration of a TLS server certificate. NOTE Enum - Only one TLS Cert method is supported
        """
        return pulumi.get(self, "tls")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

