# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'GetDataLakeConnectorTopicMapResult',
    'AwaitableGetDataLakeConnectorTopicMapResult',
    'get_data_lake_connector_topic_map',
    'get_data_lake_connector_topic_map_output',
]

@pulumi.output_type
class GetDataLakeConnectorTopicMapResult:
    """
    MQ dataLakeConnector/topicMap resource
    """
    def __init__(__self__, data_lake_connector_ref=None, extended_location=None, id=None, location=None, mapping=None, name=None, provisioning_state=None, system_data=None, tags=None, type=None):
        if data_lake_connector_ref and not isinstance(data_lake_connector_ref, str):
            raise TypeError("Expected argument 'data_lake_connector_ref' to be a str")
        pulumi.set(__self__, "data_lake_connector_ref", data_lake_connector_ref)
        if extended_location and not isinstance(extended_location, dict):
            raise TypeError("Expected argument 'extended_location' to be a dict")
        pulumi.set(__self__, "extended_location", extended_location)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if location and not isinstance(location, str):
            raise TypeError("Expected argument 'location' to be a str")
        pulumi.set(__self__, "location", location)
        if mapping and not isinstance(mapping, dict):
            raise TypeError("Expected argument 'mapping' to be a dict")
        pulumi.set(__self__, "mapping", mapping)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="dataLakeConnectorRef")
    def data_lake_connector_ref(self) -> str:
        """
        DataLake Connector CRD to use.
        """
        return pulumi.get(self, "data_lake_connector_ref")

    @property
    @pulumi.getter(name="extendedLocation")
    def extended_location(self) -> 'outputs.ExtendedLocationPropertyResponse':
        """
        Extended Location
        """
        return pulumi.get(self, "extended_location")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def location(self) -> str:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def mapping(self) -> 'outputs.DataLakeConnectorMapResponse':
        """
        TopicMap for DataLake connector.
        """
        return pulumi.get(self, "mapping")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> str:
        """
        The status of the last operation.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, str]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetDataLakeConnectorTopicMapResult(GetDataLakeConnectorTopicMapResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDataLakeConnectorTopicMapResult(
            data_lake_connector_ref=self.data_lake_connector_ref,
            extended_location=self.extended_location,
            id=self.id,
            location=self.location,
            mapping=self.mapping,
            name=self.name,
            provisioning_state=self.provisioning_state,
            system_data=self.system_data,
            tags=self.tags,
            type=self.type)


def get_data_lake_connector_topic_map(data_lake_connector_name: Optional[str] = None,
                                      mq_name: Optional[str] = None,
                                      resource_group_name: Optional[str] = None,
                                      topic_map_name: Optional[str] = None,
                                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDataLakeConnectorTopicMapResult:
    """
    Get a DataLakeTopicMapResource


    :param str data_lake_connector_name: Name of MQ dataLakeConnector resource
    :param str mq_name: Name of MQ resource
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str topic_map_name: Name of MQ dataLakeConnector/topicMap resource
    """
    __args__ = dict()
    __args__['dataLakeConnectorName'] = data_lake_connector_name
    __args__['mqName'] = mq_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['topicMapName'] = topic_map_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:iotoperationsmq/v20231004preview:getDataLakeConnectorTopicMap', __args__, opts=opts, typ=GetDataLakeConnectorTopicMapResult).value

    return AwaitableGetDataLakeConnectorTopicMapResult(
        data_lake_connector_ref=pulumi.get(__ret__, 'data_lake_connector_ref'),
        extended_location=pulumi.get(__ret__, 'extended_location'),
        id=pulumi.get(__ret__, 'id'),
        location=pulumi.get(__ret__, 'location'),
        mapping=pulumi.get(__ret__, 'mapping'),
        name=pulumi.get(__ret__, 'name'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        system_data=pulumi.get(__ret__, 'system_data'),
        tags=pulumi.get(__ret__, 'tags'),
        type=pulumi.get(__ret__, 'type'))


@_utilities.lift_output_func(get_data_lake_connector_topic_map)
def get_data_lake_connector_topic_map_output(data_lake_connector_name: Optional[pulumi.Input[str]] = None,
                                             mq_name: Optional[pulumi.Input[str]] = None,
                                             resource_group_name: Optional[pulumi.Input[str]] = None,
                                             topic_map_name: Optional[pulumi.Input[str]] = None,
                                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDataLakeConnectorTopicMapResult]:
    """
    Get a DataLakeTopicMapResource


    :param str data_lake_connector_name: Name of MQ dataLakeConnector resource
    :param str mq_name: Name of MQ resource
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str topic_map_name: Name of MQ dataLakeConnector/topicMap resource
    """
    ...
