# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from ._enums import *

__all__ = [
    'BindingPropertiesArgs',
    'ComponentPropertiesArgs',
    'ExtendedLocationArgs',
    'ReconciliationPolicyArgs',
    'TargetSelectorPropertiesArgs',
    'TopologiesPropertiesArgs',
]

@pulumi.input_type
class BindingPropertiesArgs:
    def __init__(__self__, *,
                 config: Any,
                 provider: pulumi.Input[str],
                 role: pulumi.Input[str]):
        """
        Defines a component binding for a provider.
        :param Any config: Configuration values for the binding.
        :param pulumi.Input[str] provider: Name of the provider.
        :param pulumi.Input[str] role: Role that the provider binds to with the component.
        """
        pulumi.set(__self__, "config", config)
        pulumi.set(__self__, "provider", provider)
        pulumi.set(__self__, "role", role)

    @property
    @pulumi.getter
    def config(self) -> Any:
        """
        Configuration values for the binding.
        """
        return pulumi.get(self, "config")

    @config.setter
    def config(self, value: Any):
        pulumi.set(self, "config", value)

    @property
    @pulumi.getter
    def provider(self) -> pulumi.Input[str]:
        """
        Name of the provider.
        """
        return pulumi.get(self, "provider")

    @provider.setter
    def provider(self, value: pulumi.Input[str]):
        pulumi.set(self, "provider", value)

    @property
    @pulumi.getter
    def role(self) -> pulumi.Input[str]:
        """
        Role that the provider binds to with the component.
        """
        return pulumi.get(self, "role")

    @role.setter
    def role(self, value: pulumi.Input[str]):
        pulumi.set(self, "role", value)


@pulumi.input_type
class ComponentPropertiesArgs:
    def __init__(__self__, *,
                 name: pulumi.Input[str],
                 type: pulumi.Input[str],
                 dependencies: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 properties: Optional[Any] = None):
        """
        Defines a desired runtime component.
        :param pulumi.Input[str] name: Name of the component.
        :param pulumi.Input[str] type: Component type.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] dependencies: Component dependencies.
        :param Any properties: Properties of the component.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)
        if dependencies is not None:
            pulumi.set(__self__, "dependencies", dependencies)
        if properties is not None:
            pulumi.set(__self__, "properties", properties)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        Name of the component.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        Component type.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def dependencies(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Component dependencies.
        """
        return pulumi.get(self, "dependencies")

    @dependencies.setter
    def dependencies(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "dependencies", value)

    @property
    @pulumi.getter
    def properties(self) -> Optional[Any]:
        """
        Properties of the component.
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: Optional[Any]):
        pulumi.set(self, "properties", value)


@pulumi.input_type
class ExtendedLocationArgs:
    def __init__(__self__, *,
                 name: pulumi.Input[str],
                 type: pulumi.Input[str]):
        """
        Extended location is an extension of Azure locations. They provide a way to use their Azure ARC enabled Kubernetes clusters as target locations for deploying Azure services instances.
        :param pulumi.Input[str] name: The name of the extended location.
        :param pulumi.Input[str] type: The type of the extended location.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        The name of the extended location.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        The type of the extended location.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)


@pulumi.input_type
class ReconciliationPolicyArgs:
    def __init__(__self__, *,
                 type: pulumi.Input[Union[str, 'ReconciliationPolicies']],
                 interval: Optional[pulumi.Input[str]] = None):
        """
        Reconciliation Policy.
        :param pulumi.Input[Union[str, 'ReconciliationPolicies']] type: Policy type
        :param pulumi.Input[str] interval: Policy interval.
        """
        pulumi.set(__self__, "type", type)
        if interval is not None:
            pulumi.set(__self__, "interval", interval)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[Union[str, 'ReconciliationPolicies']]:
        """
        Policy type
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[Union[str, 'ReconciliationPolicies']]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def interval(self) -> Optional[pulumi.Input[str]]:
        """
        Policy interval.
        """
        return pulumi.get(self, "interval")

    @interval.setter
    def interval(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "interval", value)


@pulumi.input_type
class TargetSelectorPropertiesArgs:
    def __init__(__self__, *,
                 name: Optional[pulumi.Input[str]] = None):
        """
        Properties of the reference target.
        :param pulumi.Input[str] name: Name of the target.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the target.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class TopologiesPropertiesArgs:
    def __init__(__self__, *,
                 bindings: Optional[pulumi.Input[Sequence[pulumi.Input['BindingPropertiesArgs']]]] = None):
        """
        Defines a desired runtime component.
        :param pulumi.Input[Sequence[pulumi.Input['BindingPropertiesArgs']]] bindings: bindings description.
        """
        if bindings is not None:
            pulumi.set(__self__, "bindings", bindings)

    @property
    @pulumi.getter
    def bindings(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['BindingPropertiesArgs']]]]:
        """
        bindings description.
        """
        return pulumi.get(self, "bindings")

    @bindings.setter
    def bindings(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['BindingPropertiesArgs']]]]):
        pulumi.set(self, "bindings", value)


