# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'BindingPropertiesResponse',
    'ComponentPropertiesResponse',
    'ExtendedLocationResponse',
    'ReconciliationPolicyResponse',
    'SystemDataResponse',
    'TargetSelectorPropertiesResponse',
    'TopologiesPropertiesResponse',
]

@pulumi.output_type
class BindingPropertiesResponse(dict):
    """
    Defines a component binding for a provider.
    """
    def __init__(__self__, *,
                 config: Any,
                 provider: str,
                 role: str):
        """
        Defines a component binding for a provider.
        :param Any config: Configuration values for the binding.
        :param str provider: Name of the provider.
        :param str role: Role that the provider binds to with the component.
        """
        pulumi.set(__self__, "config", config)
        pulumi.set(__self__, "provider", provider)
        pulumi.set(__self__, "role", role)

    @property
    @pulumi.getter
    def config(self) -> Any:
        """
        Configuration values for the binding.
        """
        return pulumi.get(self, "config")

    @property
    @pulumi.getter
    def provider(self) -> str:
        """
        Name of the provider.
        """
        return pulumi.get(self, "provider")

    @property
    @pulumi.getter
    def role(self) -> str:
        """
        Role that the provider binds to with the component.
        """
        return pulumi.get(self, "role")


@pulumi.output_type
class ComponentPropertiesResponse(dict):
    """
    Defines a desired runtime component.
    """
    def __init__(__self__, *,
                 name: str,
                 type: str,
                 dependencies: Optional[Sequence[str]] = None,
                 properties: Optional[Any] = None):
        """
        Defines a desired runtime component.
        :param str name: Name of the component.
        :param str type: Component type.
        :param Sequence[str] dependencies: Component dependencies.
        :param Any properties: Properties of the component.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)
        if dependencies is not None:
            pulumi.set(__self__, "dependencies", dependencies)
        if properties is not None:
            pulumi.set(__self__, "properties", properties)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the component.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Component type.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def dependencies(self) -> Optional[Sequence[str]]:
        """
        Component dependencies.
        """
        return pulumi.get(self, "dependencies")

    @property
    @pulumi.getter
    def properties(self) -> Optional[Any]:
        """
        Properties of the component.
        """
        return pulumi.get(self, "properties")


@pulumi.output_type
class ExtendedLocationResponse(dict):
    """
    Extended location is an extension of Azure locations. They provide a way to use their Azure ARC enabled Kubernetes clusters as target locations for deploying Azure services instances.
    """
    def __init__(__self__, *,
                 name: str,
                 type: str):
        """
        Extended location is an extension of Azure locations. They provide a way to use their Azure ARC enabled Kubernetes clusters as target locations for deploying Azure services instances.
        :param str name: The name of the extended location.
        :param str type: The type of the extended location.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the extended location.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the extended location.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class ReconciliationPolicyResponse(dict):
    """
    Reconciliation Policy.
    """
    def __init__(__self__, *,
                 type: str,
                 interval: Optional[str] = None):
        """
        Reconciliation Policy.
        :param str type: Policy type
        :param str interval: Policy interval.
        """
        pulumi.set(__self__, "type", type)
        if interval is not None:
            pulumi.set(__self__, "interval", interval)

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Policy type
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def interval(self) -> Optional[str]:
        """
        Policy interval.
        """
        return pulumi.get(self, "interval")


@pulumi.output_type
class SystemDataResponse(dict):
    """
    Metadata pertaining to creation and last modification of the resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createdAt":
            suggest = "created_at"
        elif key == "createdBy":
            suggest = "created_by"
        elif key == "createdByType":
            suggest = "created_by_type"
        elif key == "lastModifiedAt":
            suggest = "last_modified_at"
        elif key == "lastModifiedBy":
            suggest = "last_modified_by"
        elif key == "lastModifiedByType":
            suggest = "last_modified_by_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SystemDataResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 created_at: Optional[str] = None,
                 created_by: Optional[str] = None,
                 created_by_type: Optional[str] = None,
                 last_modified_at: Optional[str] = None,
                 last_modified_by: Optional[str] = None,
                 last_modified_by_type: Optional[str] = None):
        """
        Metadata pertaining to creation and last modification of the resource.
        :param str created_at: The timestamp of resource creation (UTC).
        :param str created_by: The identity that created the resource.
        :param str created_by_type: The type of identity that created the resource.
        :param str last_modified_at: The timestamp of resource last modification (UTC)
        :param str last_modified_by: The identity that last modified the resource.
        :param str last_modified_by_type: The type of identity that last modified the resource.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if created_by is not None:
            pulumi.set(__self__, "created_by", created_by)
        if created_by_type is not None:
            pulumi.set(__self__, "created_by_type", created_by_type)
        if last_modified_at is not None:
            pulumi.set(__self__, "last_modified_at", last_modified_at)
        if last_modified_by is not None:
            pulumi.set(__self__, "last_modified_by", last_modified_by)
        if last_modified_by_type is not None:
            pulumi.set(__self__, "last_modified_by_type", last_modified_by_type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[str]:
        """
        The timestamp of resource creation (UTC).
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> Optional[str]:
        """
        The identity that created the resource.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdByType")
    def created_by_type(self) -> Optional[str]:
        """
        The type of identity that created the resource.
        """
        return pulumi.get(self, "created_by_type")

    @property
    @pulumi.getter(name="lastModifiedAt")
    def last_modified_at(self) -> Optional[str]:
        """
        The timestamp of resource last modification (UTC)
        """
        return pulumi.get(self, "last_modified_at")

    @property
    @pulumi.getter(name="lastModifiedBy")
    def last_modified_by(self) -> Optional[str]:
        """
        The identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by")

    @property
    @pulumi.getter(name="lastModifiedByType")
    def last_modified_by_type(self) -> Optional[str]:
        """
        The type of identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by_type")


@pulumi.output_type
class TargetSelectorPropertiesResponse(dict):
    """
    Properties of the reference target.
    """
    def __init__(__self__, *,
                 name: Optional[str] = None):
        """
        Properties of the reference target.
        :param str name: Name of the target.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Name of the target.
        """
        return pulumi.get(self, "name")


@pulumi.output_type
class TopologiesPropertiesResponse(dict):
    """
    Defines a desired runtime component.
    """
    def __init__(__self__, *,
                 bindings: Optional[Sequence['outputs.BindingPropertiesResponse']] = None):
        """
        Defines a desired runtime component.
        :param Sequence['BindingPropertiesResponse'] bindings: bindings description.
        """
        if bindings is not None:
            pulumi.set(__self__, "bindings", bindings)

    @property
    @pulumi.getter
    def bindings(self) -> Optional[Sequence['outputs.BindingPropertiesResponse']]:
        """
        bindings description.
        """
        return pulumi.get(self, "bindings")


