# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'BatchLoggingLevel',
    'BatchOutputAction',
    'ContentsType',
    'CredentialsType',
    'DataBindingMode',
    'DatasetType',
    'DistributionType',
    'DockerSpecificationType',
    'EarlyTerminationPolicyType',
    'EndpointAuthMode',
    'EndpointComputeType',
    'Goal',
    'IdentityConfigurationType',
    'ImageAnnotationType',
    'JobType',
    'MediaType',
    'OperatingSystemType',
    'OriginType',
    'ReferenceType',
    'ResourceIdentityAssignment',
    'SamplingAlgorithm',
    'ScaleType',
    'SecretsType',
    'TextAnnotationType',
]


class BatchLoggingLevel(str, Enum):
    """
    Logging level for batch inference operation.
    """
    INFO = "Info"
    WARNING = "Warning"
    DEBUG = "Debug"


class BatchOutputAction(str, Enum):
    """
    Indicates how the output will be organized.
    """
    SUMMARY_ONLY = "SummaryOnly"
    APPEND_ROW = "AppendRow"


class ContentsType(str, Enum):
    """
    [Required] Storage type backing the datastore.
    """
    AZURE_BLOB = "AzureBlob"
    AZURE_DATA_LAKE_GEN1 = "AzureDataLakeGen1"
    AZURE_DATA_LAKE_GEN2 = "AzureDataLakeGen2"
    AZURE_FILE = "AzureFile"
    AZURE_MY_SQL = "AzureMySql"
    AZURE_POSTGRE_SQL = "AzurePostgreSql"
    AZURE_SQL_DATABASE = "AzureSqlDatabase"
    GLUSTER_FS = "GlusterFs"


class CredentialsType(str, Enum):
    """
    [Required] Credential type used to authentication with storage.
    """
    ACCOUNT_KEY = "AccountKey"
    CERTIFICATE = "Certificate"
    NONE = "None"
    SAS = "Sas"
    SERVICE_PRINCIPAL = "ServicePrincipal"
    SQL_ADMIN = "SqlAdmin"


class DataBindingMode(str, Enum):
    """
    Mechanism for data movement to datastore.
    """
    MOUNT = "Mount"
    DOWNLOAD = "Download"
    UPLOAD = "Upload"
    READ_ONLY_MOUNT = "ReadOnlyMount"
    READ_WRITE_MOUNT = "ReadWriteMount"
    DIRECT = "Direct"
    EVAL_MOUNT = "EvalMount"
    EVAL_DOWNLOAD = "EvalDownload"


class DatasetType(str, Enum):
    """
    The Format of dataset.
    """
    SIMPLE = "Simple"
    DATAFLOW = "Dataflow"


class DistributionType(str, Enum):
    """
    [Required] Specifies the type of distribution framework.
    """
    PY_TORCH = "PyTorch"
    TENSOR_FLOW = "TensorFlow"
    MPI = "Mpi"


class DockerSpecificationType(str, Enum):
    """
    [Required] Docker specification must be either Build or Image
    """
    BUILD = "Build"
    IMAGE = "Image"


class EarlyTerminationPolicyType(str, Enum):
    """
    [Required] Name of policy configuration
    """
    BANDIT = "Bandit"
    MEDIAN_STOPPING = "MedianStopping"
    TRUNCATION_SELECTION = "TruncationSelection"


class EndpointAuthMode(str, Enum):
    """
    [Required] Inference endpoint authentication mode type
    """
    AML_TOKEN = "AMLToken"
    KEY = "Key"
    AAD_TOKEN = "AADToken"


class EndpointComputeType(str, Enum):
    """
    [Required] The compute type of the endpoint.
    """
    MANAGED = "Managed"
    K8_S = "K8S"
    AZURE_ML_COMPUTE = "AzureMLCompute"


class Goal(str, Enum):
    """
    [Required] Defines supported metric goals for hyperparameter tuning
    """
    MINIMIZE = "Minimize"
    MAXIMIZE = "Maximize"


class IdentityConfigurationType(str, Enum):
    """
    [Required] Specifies the type of identity framework.
    """
    MANAGED = "Managed"
    AML_TOKEN = "AMLToken"


class ImageAnnotationType(str, Enum):
    """
    Annotation type of image labeling job.
    """
    CLASSIFICATION = "Classification"
    BOUNDING_BOX = "BoundingBox"
    INSTANCE_SEGMENTATION = "InstanceSegmentation"


class JobType(str, Enum):
    """
    [Required] Specifies the type of job. This field should always be set to "Labeling".
    """
    COMMAND = "Command"
    SWEEP = "Sweep"
    LABELING = "Labeling"


class MediaType(str, Enum):
    """
    [Required] Media type of the job.
    """
    IMAGE = "Image"
    TEXT = "Text"


class OperatingSystemType(str, Enum):
    """
    The OS type the Environment.
    """
    LINUX = "Linux"
    WINDOWS = "Windows"


class OriginType(str, Enum):
    """
    Type of the linked service.
    """
    SYNAPSE = "Synapse"


class ReferenceType(str, Enum):
    """
    [Required] Specifies the type of asset reference.
    """
    ID = "Id"
    DATA_PATH = "DataPath"
    OUTPUT_PATH = "OutputPath"


class ResourceIdentityAssignment(str, Enum):
    """
    Defines values for a ResourceIdentity's type.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"
    NONE = "None"


class SamplingAlgorithm(str, Enum):
    """
    [Required] Type of the hyperparameter sampling algorithms
    """
    GRID = "Grid"
    RANDOM = "Random"
    BAYESIAN = "Bayesian"


class ScaleType(str, Enum):
    """
    [Required] Type of deployment scaling algorithm
    """
    AUTO = "Auto"
    MANUAL = "Manual"


class SecretsType(str, Enum):
    """
    [Required] Credential type used to authentication with storage.
    """
    ACCOUNT_KEY = "AccountKey"
    CERTIFICATE = "Certificate"
    NONE = "None"
    SAS = "Sas"
    SERVICE_PRINCIPAL = "ServicePrincipal"
    SQL_ADMIN = "SqlAdmin"


class TextAnnotationType(str, Enum):
    """
    Annotation type of text labeling job.
    """
    CLASSIFICATION = "Classification"
