# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'GetComputeAllowedResizeSizesResult',
    'AwaitableGetComputeAllowedResizeSizesResult',
    'get_compute_allowed_resize_sizes',
    'get_compute_allowed_resize_sizes_output',
]

@pulumi.output_type
class GetComputeAllowedResizeSizesResult:
    """
    The List Virtual Machine size operation response.
    """
    def __init__(__self__, value=None):
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.VirtualMachineSizeResponse']]:
        """
        The list of virtual machine sizes supported by AmlCompute.
        """
        return pulumi.get(self, "value")


class AwaitableGetComputeAllowedResizeSizesResult(GetComputeAllowedResizeSizesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetComputeAllowedResizeSizesResult(
            value=self.value)


def get_compute_allowed_resize_sizes(compute_name: Optional[str] = None,
                                     resource_group_name: Optional[str] = None,
                                     workspace_name: Optional[str] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetComputeAllowedResizeSizesResult:
    """
    Returns supported virtual machine sizes for resize


    :param str compute_name: Name of the Azure Machine Learning compute.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str workspace_name: Name of Azure Machine Learning workspace.
    """
    __args__ = dict()
    __args__['computeName'] = compute_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:machinelearningservices/v20230801preview:getComputeAllowedResizeSizes', __args__, opts=opts, typ=GetComputeAllowedResizeSizesResult).value

    return AwaitableGetComputeAllowedResizeSizesResult(
        value=pulumi.get(__ret__, 'value'))


@_utilities.lift_output_func(get_compute_allowed_resize_sizes)
def get_compute_allowed_resize_sizes_output(compute_name: Optional[pulumi.Input[str]] = None,
                                            resource_group_name: Optional[pulumi.Input[str]] = None,
                                            workspace_name: Optional[pulumi.Input[str]] = None,
                                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetComputeAllowedResizeSizesResult]:
    """
    Returns supported virtual machine sizes for resize


    :param str compute_name: Name of the Azure Machine Learning compute.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str workspace_name: Name of Azure Machine Learning workspace.
    """
    ...
