# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = ['InternetGatewayArgs', 'InternetGateway']

@pulumi.input_type
class InternetGatewayArgs:
    def __init__(__self__, *,
                 network_fabric_controller_id: pulumi.Input[str],
                 resource_group_name: pulumi.Input[str],
                 type: pulumi.Input[Union[str, 'GatewayType']],
                 annotation: Optional[pulumi.Input[str]] = None,
                 internet_gateway_name: Optional[pulumi.Input[str]] = None,
                 internet_gateway_rule_id: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a InternetGateway resource.
        :param pulumi.Input[str] network_fabric_controller_id: ARM Resource ID of the Network Fabric Controller.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Union[str, 'GatewayType']] type: Gateway Type of the resource.
        :param pulumi.Input[str] annotation: Switch configuration description.
        :param pulumi.Input[str] internet_gateway_name: Name of the Internet Gateway.
        :param pulumi.Input[str] internet_gateway_rule_id: ARM Resource ID of the Internet Gateway Rule.
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        """
        pulumi.set(__self__, "network_fabric_controller_id", network_fabric_controller_id)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "type", type)
        if annotation is not None:
            pulumi.set(__self__, "annotation", annotation)
        if internet_gateway_name is not None:
            pulumi.set(__self__, "internet_gateway_name", internet_gateway_name)
        if internet_gateway_rule_id is not None:
            pulumi.set(__self__, "internet_gateway_rule_id", internet_gateway_rule_id)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="networkFabricControllerId")
    def network_fabric_controller_id(self) -> pulumi.Input[str]:
        """
        ARM Resource ID of the Network Fabric Controller.
        """
        return pulumi.get(self, "network_fabric_controller_id")

    @network_fabric_controller_id.setter
    def network_fabric_controller_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "network_fabric_controller_id", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[Union[str, 'GatewayType']]:
        """
        Gateway Type of the resource.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[Union[str, 'GatewayType']]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def annotation(self) -> Optional[pulumi.Input[str]]:
        """
        Switch configuration description.
        """
        return pulumi.get(self, "annotation")

    @annotation.setter
    def annotation(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "annotation", value)

    @property
    @pulumi.getter(name="internetGatewayName")
    def internet_gateway_name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the Internet Gateway.
        """
        return pulumi.get(self, "internet_gateway_name")

    @internet_gateway_name.setter
    def internet_gateway_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "internet_gateway_name", value)

    @property
    @pulumi.getter(name="internetGatewayRuleId")
    def internet_gateway_rule_id(self) -> Optional[pulumi.Input[str]]:
        """
        ARM Resource ID of the Internet Gateway Rule.
        """
        return pulumi.get(self, "internet_gateway_rule_id")

    @internet_gateway_rule_id.setter
    def internet_gateway_rule_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "internet_gateway_rule_id", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)


class InternetGateway(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 annotation: Optional[pulumi.Input[str]] = None,
                 internet_gateway_name: Optional[pulumi.Input[str]] = None,
                 internet_gateway_rule_id: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 network_fabric_controller_id: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[Union[str, 'GatewayType']]] = None,
                 __props__=None):
        """
        The Internet Gateway resource definition.
        Azure REST API version: 2023-06-15.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] annotation: Switch configuration description.
        :param pulumi.Input[str] internet_gateway_name: Name of the Internet Gateway.
        :param pulumi.Input[str] internet_gateway_rule_id: ARM Resource ID of the Internet Gateway Rule.
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[str] network_fabric_controller_id: ARM Resource ID of the Network Fabric Controller.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        :param pulumi.Input[Union[str, 'GatewayType']] type: Gateway Type of the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InternetGatewayArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The Internet Gateway resource definition.
        Azure REST API version: 2023-06-15.

        :param str resource_name: The name of the resource.
        :param InternetGatewayArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InternetGatewayArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 annotation: Optional[pulumi.Input[str]] = None,
                 internet_gateway_name: Optional[pulumi.Input[str]] = None,
                 internet_gateway_rule_id: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 network_fabric_controller_id: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[Union[str, 'GatewayType']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InternetGatewayArgs.__new__(InternetGatewayArgs)

            __props__.__dict__["annotation"] = annotation
            __props__.__dict__["internet_gateway_name"] = internet_gateway_name
            __props__.__dict__["internet_gateway_rule_id"] = internet_gateway_rule_id
            __props__.__dict__["location"] = location
            if network_fabric_controller_id is None and not opts.urn:
                raise TypeError("Missing required property 'network_fabric_controller_id'")
            __props__.__dict__["network_fabric_controller_id"] = network_fabric_controller_id
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["tags"] = tags
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
            __props__.__dict__["ipv4_address"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["port"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:managednetworkfabric/v20230615:InternetGateway")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(InternetGateway, __self__).__init__(
            'azure-native:managednetworkfabric:InternetGateway',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'InternetGateway':
        """
        Get an existing InternetGateway resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = InternetGatewayArgs.__new__(InternetGatewayArgs)

        __props__.__dict__["annotation"] = None
        __props__.__dict__["internet_gateway_rule_id"] = None
        __props__.__dict__["ipv4_address"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["network_fabric_controller_id"] = None
        __props__.__dict__["port"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        return InternetGateway(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def annotation(self) -> pulumi.Output[Optional[str]]:
        """
        Switch configuration description.
        """
        return pulumi.get(self, "annotation")

    @property
    @pulumi.getter(name="internetGatewayRuleId")
    def internet_gateway_rule_id(self) -> pulumi.Output[Optional[str]]:
        """
        ARM Resource ID of the Internet Gateway Rule.
        """
        return pulumi.get(self, "internet_gateway_rule_id")

    @property
    @pulumi.getter(name="ipv4Address")
    def ipv4_address(self) -> pulumi.Output[str]:
        """
        IPv4 Address of Internet Gateway.
        """
        return pulumi.get(self, "ipv4_address")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkFabricControllerId")
    def network_fabric_controller_id(self) -> pulumi.Output[str]:
        """
        ARM Resource ID of the Network Fabric Controller.
        """
        return pulumi.get(self, "network_fabric_controller_id")

    @property
    @pulumi.getter
    def port(self) -> pulumi.Output[int]:
        """
        Port number of Internet Gateway.
        """
        return pulumi.get(self, "port")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        Provisioning state of resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

