# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'GetAccessControlListResult',
    'AwaitableGetAccessControlListResult',
    'get_access_control_list',
    'get_access_control_list_output',
]

@pulumi.output_type
class GetAccessControlListResult:
    """
    The Access Control List resource definition.
    """
    def __init__(__self__, acls_url=None, administrative_state=None, annotation=None, configuration_state=None, configuration_type=None, default_action=None, dynamic_match_configurations=None, id=None, last_synced_time=None, location=None, match_configurations=None, name=None, provisioning_state=None, system_data=None, tags=None, type=None):
        if acls_url and not isinstance(acls_url, str):
            raise TypeError("Expected argument 'acls_url' to be a str")
        pulumi.set(__self__, "acls_url", acls_url)
        if administrative_state and not isinstance(administrative_state, str):
            raise TypeError("Expected argument 'administrative_state' to be a str")
        pulumi.set(__self__, "administrative_state", administrative_state)
        if annotation and not isinstance(annotation, str):
            raise TypeError("Expected argument 'annotation' to be a str")
        pulumi.set(__self__, "annotation", annotation)
        if configuration_state and not isinstance(configuration_state, str):
            raise TypeError("Expected argument 'configuration_state' to be a str")
        pulumi.set(__self__, "configuration_state", configuration_state)
        if configuration_type and not isinstance(configuration_type, str):
            raise TypeError("Expected argument 'configuration_type' to be a str")
        pulumi.set(__self__, "configuration_type", configuration_type)
        if default_action and not isinstance(default_action, str):
            raise TypeError("Expected argument 'default_action' to be a str")
        pulumi.set(__self__, "default_action", default_action)
        if dynamic_match_configurations and not isinstance(dynamic_match_configurations, list):
            raise TypeError("Expected argument 'dynamic_match_configurations' to be a list")
        pulumi.set(__self__, "dynamic_match_configurations", dynamic_match_configurations)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if last_synced_time and not isinstance(last_synced_time, str):
            raise TypeError("Expected argument 'last_synced_time' to be a str")
        pulumi.set(__self__, "last_synced_time", last_synced_time)
        if location and not isinstance(location, str):
            raise TypeError("Expected argument 'location' to be a str")
        pulumi.set(__self__, "location", location)
        if match_configurations and not isinstance(match_configurations, list):
            raise TypeError("Expected argument 'match_configurations' to be a list")
        pulumi.set(__self__, "match_configurations", match_configurations)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="aclsUrl")
    def acls_url(self) -> Optional[str]:
        """
        Access Control List file URL.
        """
        return pulumi.get(self, "acls_url")

    @property
    @pulumi.getter(name="administrativeState")
    def administrative_state(self) -> str:
        """
        Administrative state of the resource.
        """
        return pulumi.get(self, "administrative_state")

    @property
    @pulumi.getter
    def annotation(self) -> Optional[str]:
        """
        Switch configuration description.
        """
        return pulumi.get(self, "annotation")

    @property
    @pulumi.getter(name="configurationState")
    def configuration_state(self) -> str:
        """
        Configuration state of the resource.
        """
        return pulumi.get(self, "configuration_state")

    @property
    @pulumi.getter(name="configurationType")
    def configuration_type(self) -> str:
        """
        Input method to configure Access Control List.
        """
        return pulumi.get(self, "configuration_type")

    @property
    @pulumi.getter(name="defaultAction")
    def default_action(self) -> Optional[str]:
        """
        Default action that needs to be applied when no condition is matched. Example: Permit | Deny.
        """
        return pulumi.get(self, "default_action")

    @property
    @pulumi.getter(name="dynamicMatchConfigurations")
    def dynamic_match_configurations(self) -> Optional[Sequence['outputs.CommonDynamicMatchConfigurationResponse']]:
        """
        List of dynamic match configurations.
        """
        return pulumi.get(self, "dynamic_match_configurations")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="lastSyncedTime")
    def last_synced_time(self) -> str:
        """
        The last synced timestamp.
        """
        return pulumi.get(self, "last_synced_time")

    @property
    @pulumi.getter
    def location(self) -> str:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter(name="matchConfigurations")
    def match_configurations(self) -> Optional[Sequence['outputs.AccessControlListMatchConfigurationResponse']]:
        """
        List of match configurations.
        """
        return pulumi.get(self, "match_configurations")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> str:
        """
        Provisioning state of the resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, str]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetAccessControlListResult(GetAccessControlListResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAccessControlListResult(
            acls_url=self.acls_url,
            administrative_state=self.administrative_state,
            annotation=self.annotation,
            configuration_state=self.configuration_state,
            configuration_type=self.configuration_type,
            default_action=self.default_action,
            dynamic_match_configurations=self.dynamic_match_configurations,
            id=self.id,
            last_synced_time=self.last_synced_time,
            location=self.location,
            match_configurations=self.match_configurations,
            name=self.name,
            provisioning_state=self.provisioning_state,
            system_data=self.system_data,
            tags=self.tags,
            type=self.type)


def get_access_control_list(access_control_list_name: Optional[str] = None,
                            resource_group_name: Optional[str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAccessControlListResult:
    """
    Implements Access Control List GET method.


    :param str access_control_list_name: Name of the Access Control List.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['accessControlListName'] = access_control_list_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:managednetworkfabric/v20230615:getAccessControlList', __args__, opts=opts, typ=GetAccessControlListResult).value

    return AwaitableGetAccessControlListResult(
        acls_url=pulumi.get(__ret__, 'acls_url'),
        administrative_state=pulumi.get(__ret__, 'administrative_state'),
        annotation=pulumi.get(__ret__, 'annotation'),
        configuration_state=pulumi.get(__ret__, 'configuration_state'),
        configuration_type=pulumi.get(__ret__, 'configuration_type'),
        default_action=pulumi.get(__ret__, 'default_action'),
        dynamic_match_configurations=pulumi.get(__ret__, 'dynamic_match_configurations'),
        id=pulumi.get(__ret__, 'id'),
        last_synced_time=pulumi.get(__ret__, 'last_synced_time'),
        location=pulumi.get(__ret__, 'location'),
        match_configurations=pulumi.get(__ret__, 'match_configurations'),
        name=pulumi.get(__ret__, 'name'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        system_data=pulumi.get(__ret__, 'system_data'),
        tags=pulumi.get(__ret__, 'tags'),
        type=pulumi.get(__ret__, 'type'))


@_utilities.lift_output_func(get_access_control_list)
def get_access_control_list_output(access_control_list_name: Optional[pulumi.Input[str]] = None,
                                   resource_group_name: Optional[pulumi.Input[str]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAccessControlListResult]:
    """
    Implements Access Control List GET method.


    :param str access_control_list_name: Name of the Access Control List.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    ...
