# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *

__all__ = ['AvsAssessmentsOperationArgs', 'AvsAssessmentsOperation']

@pulumi.input_type
class AvsAssessmentsOperationArgs:
    def __init__(__self__, *,
                 group_name: pulumi.Input[str],
                 project_name: pulumi.Input[str],
                 resource_group_name: pulumi.Input[str],
                 assessment_name: Optional[pulumi.Input[str]] = None,
                 azure_location: Optional[pulumi.Input[Union[str, 'AzureLocation']]] = None,
                 azure_offer_code: Optional[pulumi.Input[Union[str, 'AzureOfferCode']]] = None,
                 currency: Optional[pulumi.Input[Union[str, 'AzureCurrency']]] = None,
                 dedupe_compression: Optional[pulumi.Input[float]] = None,
                 discount_percentage: Optional[pulumi.Input[float]] = None,
                 failures_to_tolerate_and_raid_level: Optional[pulumi.Input[Union[str, 'FttAndRaidLevel']]] = None,
                 is_stretch_cluster_enabled: Optional[pulumi.Input[bool]] = None,
                 mem_overcommit: Optional[pulumi.Input[float]] = None,
                 node_type: Optional[pulumi.Input[Union[str, 'AzureAvsNodeType']]] = None,
                 percentile: Optional[pulumi.Input[Union[str, 'Percentile']]] = None,
                 perf_data_end_time: Optional[pulumi.Input[str]] = None,
                 perf_data_start_time: Optional[pulumi.Input[str]] = None,
                 provisioning_state: Optional[pulumi.Input[Union[str, 'ProvisioningState']]] = None,
                 reserved_instance: Optional[pulumi.Input[Union[str, 'AzureReservedInstance']]] = None,
                 scaling_factor: Optional[pulumi.Input[float]] = None,
                 sizing_criterion: Optional[pulumi.Input[Union[str, 'AssessmentSizingCriterion']]] = None,
                 time_range: Optional[pulumi.Input[Union[str, 'TimeRange']]] = None,
                 vcpu_oversubscription: Optional[pulumi.Input[float]] = None):
        """
        The set of arguments for constructing a AvsAssessmentsOperation resource.
        :param pulumi.Input[str] group_name: Group ARM name
        :param pulumi.Input[str] project_name: Assessment Project Name
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] assessment_name: AVS Assessment ARM name
        :param pulumi.Input[Union[str, 'AzureLocation']] azure_location: Azure Location or Azure region where to which the machines will be migrated.
        :param pulumi.Input[Union[str, 'AzureOfferCode']] azure_offer_code: Azure Offer code according to which cost estimation is done.
        :param pulumi.Input[Union[str, 'AzureCurrency']] currency: Currency in which prices should be reported.
        :param pulumi.Input[float] dedupe_compression: De-duplication compression.
        :param pulumi.Input[float] discount_percentage: Custom discount percentage.
        :param pulumi.Input[Union[str, 'FttAndRaidLevel']] failures_to_tolerate_and_raid_level: Failures to tolerate and RAID level in a common property.
        :param pulumi.Input[bool] is_stretch_cluster_enabled: Is Stretch Cluster Enabled.
        :param pulumi.Input[float] mem_overcommit: Memory overcommit.
        :param pulumi.Input[Union[str, 'AzureAvsNodeType']] node_type: AVS node type.
        :param pulumi.Input[Union[str, 'Percentile']] percentile: Percentile of the utilization data values to be considered while assessing
               machines.
        :param pulumi.Input[str] perf_data_end_time: Gets or sets the end time to consider performance data for assessment.
        :param pulumi.Input[str] perf_data_start_time: Gets or sets the start time to consider performance data for assessment.
        :param pulumi.Input[Union[str, 'ProvisioningState']] provisioning_state: The status of the last operation.
        :param pulumi.Input[Union[str, 'AzureReservedInstance']] reserved_instance: Reserved instance.
        :param pulumi.Input[float] scaling_factor: Percentage of buffer that user wants on performance metrics when recommending
               Azure sizes.
        :param pulumi.Input[Union[str, 'AssessmentSizingCriterion']] sizing_criterion: Assessment sizing criterion.
        :param pulumi.Input[Union[str, 'TimeRange']] time_range: Time Range for which the historic utilization data should be considered for
               assessment.
        :param pulumi.Input[float] vcpu_oversubscription: VCPU over subscription.
        """
        pulumi.set(__self__, "group_name", group_name)
        pulumi.set(__self__, "project_name", project_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if assessment_name is not None:
            pulumi.set(__self__, "assessment_name", assessment_name)
        if azure_location is not None:
            pulumi.set(__self__, "azure_location", azure_location)
        if azure_offer_code is not None:
            pulumi.set(__self__, "azure_offer_code", azure_offer_code)
        if currency is not None:
            pulumi.set(__self__, "currency", currency)
        if dedupe_compression is not None:
            pulumi.set(__self__, "dedupe_compression", dedupe_compression)
        if discount_percentage is not None:
            pulumi.set(__self__, "discount_percentage", discount_percentage)
        if failures_to_tolerate_and_raid_level is not None:
            pulumi.set(__self__, "failures_to_tolerate_and_raid_level", failures_to_tolerate_and_raid_level)
        if is_stretch_cluster_enabled is not None:
            pulumi.set(__self__, "is_stretch_cluster_enabled", is_stretch_cluster_enabled)
        if mem_overcommit is not None:
            pulumi.set(__self__, "mem_overcommit", mem_overcommit)
        if node_type is not None:
            pulumi.set(__self__, "node_type", node_type)
        if percentile is not None:
            pulumi.set(__self__, "percentile", percentile)
        if perf_data_end_time is not None:
            pulumi.set(__self__, "perf_data_end_time", perf_data_end_time)
        if perf_data_start_time is not None:
            pulumi.set(__self__, "perf_data_start_time", perf_data_start_time)
        if provisioning_state is not None:
            pulumi.set(__self__, "provisioning_state", provisioning_state)
        if reserved_instance is not None:
            pulumi.set(__self__, "reserved_instance", reserved_instance)
        if scaling_factor is not None:
            pulumi.set(__self__, "scaling_factor", scaling_factor)
        if sizing_criterion is not None:
            pulumi.set(__self__, "sizing_criterion", sizing_criterion)
        if time_range is not None:
            pulumi.set(__self__, "time_range", time_range)
        if vcpu_oversubscription is not None:
            pulumi.set(__self__, "vcpu_oversubscription", vcpu_oversubscription)

    @property
    @pulumi.getter(name="groupName")
    def group_name(self) -> pulumi.Input[str]:
        """
        Group ARM name
        """
        return pulumi.get(self, "group_name")

    @group_name.setter
    def group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "group_name", value)

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> pulumi.Input[str]:
        """
        Assessment Project Name
        """
        return pulumi.get(self, "project_name")

    @project_name.setter
    def project_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "project_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="assessmentName")
    def assessment_name(self) -> Optional[pulumi.Input[str]]:
        """
        AVS Assessment ARM name
        """
        return pulumi.get(self, "assessment_name")

    @assessment_name.setter
    def assessment_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "assessment_name", value)

    @property
    @pulumi.getter(name="azureLocation")
    def azure_location(self) -> Optional[pulumi.Input[Union[str, 'AzureLocation']]]:
        """
        Azure Location or Azure region where to which the machines will be migrated.
        """
        return pulumi.get(self, "azure_location")

    @azure_location.setter
    def azure_location(self, value: Optional[pulumi.Input[Union[str, 'AzureLocation']]]):
        pulumi.set(self, "azure_location", value)

    @property
    @pulumi.getter(name="azureOfferCode")
    def azure_offer_code(self) -> Optional[pulumi.Input[Union[str, 'AzureOfferCode']]]:
        """
        Azure Offer code according to which cost estimation is done.
        """
        return pulumi.get(self, "azure_offer_code")

    @azure_offer_code.setter
    def azure_offer_code(self, value: Optional[pulumi.Input[Union[str, 'AzureOfferCode']]]):
        pulumi.set(self, "azure_offer_code", value)

    @property
    @pulumi.getter
    def currency(self) -> Optional[pulumi.Input[Union[str, 'AzureCurrency']]]:
        """
        Currency in which prices should be reported.
        """
        return pulumi.get(self, "currency")

    @currency.setter
    def currency(self, value: Optional[pulumi.Input[Union[str, 'AzureCurrency']]]):
        pulumi.set(self, "currency", value)

    @property
    @pulumi.getter(name="dedupeCompression")
    def dedupe_compression(self) -> Optional[pulumi.Input[float]]:
        """
        De-duplication compression.
        """
        return pulumi.get(self, "dedupe_compression")

    @dedupe_compression.setter
    def dedupe_compression(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "dedupe_compression", value)

    @property
    @pulumi.getter(name="discountPercentage")
    def discount_percentage(self) -> Optional[pulumi.Input[float]]:
        """
        Custom discount percentage.
        """
        return pulumi.get(self, "discount_percentage")

    @discount_percentage.setter
    def discount_percentage(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "discount_percentage", value)

    @property
    @pulumi.getter(name="failuresToTolerateAndRaidLevel")
    def failures_to_tolerate_and_raid_level(self) -> Optional[pulumi.Input[Union[str, 'FttAndRaidLevel']]]:
        """
        Failures to tolerate and RAID level in a common property.
        """
        return pulumi.get(self, "failures_to_tolerate_and_raid_level")

    @failures_to_tolerate_and_raid_level.setter
    def failures_to_tolerate_and_raid_level(self, value: Optional[pulumi.Input[Union[str, 'FttAndRaidLevel']]]):
        pulumi.set(self, "failures_to_tolerate_and_raid_level", value)

    @property
    @pulumi.getter(name="isStretchClusterEnabled")
    def is_stretch_cluster_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Is Stretch Cluster Enabled.
        """
        return pulumi.get(self, "is_stretch_cluster_enabled")

    @is_stretch_cluster_enabled.setter
    def is_stretch_cluster_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_stretch_cluster_enabled", value)

    @property
    @pulumi.getter(name="memOvercommit")
    def mem_overcommit(self) -> Optional[pulumi.Input[float]]:
        """
        Memory overcommit.
        """
        return pulumi.get(self, "mem_overcommit")

    @mem_overcommit.setter
    def mem_overcommit(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "mem_overcommit", value)

    @property
    @pulumi.getter(name="nodeType")
    def node_type(self) -> Optional[pulumi.Input[Union[str, 'AzureAvsNodeType']]]:
        """
        AVS node type.
        """
        return pulumi.get(self, "node_type")

    @node_type.setter
    def node_type(self, value: Optional[pulumi.Input[Union[str, 'AzureAvsNodeType']]]):
        pulumi.set(self, "node_type", value)

    @property
    @pulumi.getter
    def percentile(self) -> Optional[pulumi.Input[Union[str, 'Percentile']]]:
        """
        Percentile of the utilization data values to be considered while assessing
        machines.
        """
        return pulumi.get(self, "percentile")

    @percentile.setter
    def percentile(self, value: Optional[pulumi.Input[Union[str, 'Percentile']]]):
        pulumi.set(self, "percentile", value)

    @property
    @pulumi.getter(name="perfDataEndTime")
    def perf_data_end_time(self) -> Optional[pulumi.Input[str]]:
        """
        Gets or sets the end time to consider performance data for assessment.
        """
        return pulumi.get(self, "perf_data_end_time")

    @perf_data_end_time.setter
    def perf_data_end_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "perf_data_end_time", value)

    @property
    @pulumi.getter(name="perfDataStartTime")
    def perf_data_start_time(self) -> Optional[pulumi.Input[str]]:
        """
        Gets or sets the start time to consider performance data for assessment.
        """
        return pulumi.get(self, "perf_data_start_time")

    @perf_data_start_time.setter
    def perf_data_start_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "perf_data_start_time", value)

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> Optional[pulumi.Input[Union[str, 'ProvisioningState']]]:
        """
        The status of the last operation.
        """
        return pulumi.get(self, "provisioning_state")

    @provisioning_state.setter
    def provisioning_state(self, value: Optional[pulumi.Input[Union[str, 'ProvisioningState']]]):
        pulumi.set(self, "provisioning_state", value)

    @property
    @pulumi.getter(name="reservedInstance")
    def reserved_instance(self) -> Optional[pulumi.Input[Union[str, 'AzureReservedInstance']]]:
        """
        Reserved instance.
        """
        return pulumi.get(self, "reserved_instance")

    @reserved_instance.setter
    def reserved_instance(self, value: Optional[pulumi.Input[Union[str, 'AzureReservedInstance']]]):
        pulumi.set(self, "reserved_instance", value)

    @property
    @pulumi.getter(name="scalingFactor")
    def scaling_factor(self) -> Optional[pulumi.Input[float]]:
        """
        Percentage of buffer that user wants on performance metrics when recommending
        Azure sizes.
        """
        return pulumi.get(self, "scaling_factor")

    @scaling_factor.setter
    def scaling_factor(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "scaling_factor", value)

    @property
    @pulumi.getter(name="sizingCriterion")
    def sizing_criterion(self) -> Optional[pulumi.Input[Union[str, 'AssessmentSizingCriterion']]]:
        """
        Assessment sizing criterion.
        """
        return pulumi.get(self, "sizing_criterion")

    @sizing_criterion.setter
    def sizing_criterion(self, value: Optional[pulumi.Input[Union[str, 'AssessmentSizingCriterion']]]):
        pulumi.set(self, "sizing_criterion", value)

    @property
    @pulumi.getter(name="timeRange")
    def time_range(self) -> Optional[pulumi.Input[Union[str, 'TimeRange']]]:
        """
        Time Range for which the historic utilization data should be considered for
        assessment.
        """
        return pulumi.get(self, "time_range")

    @time_range.setter
    def time_range(self, value: Optional[pulumi.Input[Union[str, 'TimeRange']]]):
        pulumi.set(self, "time_range", value)

    @property
    @pulumi.getter(name="vcpuOversubscription")
    def vcpu_oversubscription(self) -> Optional[pulumi.Input[float]]:
        """
        VCPU over subscription.
        """
        return pulumi.get(self, "vcpu_oversubscription")

    @vcpu_oversubscription.setter
    def vcpu_oversubscription(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "vcpu_oversubscription", value)


class AvsAssessmentsOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 assessment_name: Optional[pulumi.Input[str]] = None,
                 azure_location: Optional[pulumi.Input[Union[str, 'AzureLocation']]] = None,
                 azure_offer_code: Optional[pulumi.Input[Union[str, 'AzureOfferCode']]] = None,
                 currency: Optional[pulumi.Input[Union[str, 'AzureCurrency']]] = None,
                 dedupe_compression: Optional[pulumi.Input[float]] = None,
                 discount_percentage: Optional[pulumi.Input[float]] = None,
                 failures_to_tolerate_and_raid_level: Optional[pulumi.Input[Union[str, 'FttAndRaidLevel']]] = None,
                 group_name: Optional[pulumi.Input[str]] = None,
                 is_stretch_cluster_enabled: Optional[pulumi.Input[bool]] = None,
                 mem_overcommit: Optional[pulumi.Input[float]] = None,
                 node_type: Optional[pulumi.Input[Union[str, 'AzureAvsNodeType']]] = None,
                 percentile: Optional[pulumi.Input[Union[str, 'Percentile']]] = None,
                 perf_data_end_time: Optional[pulumi.Input[str]] = None,
                 perf_data_start_time: Optional[pulumi.Input[str]] = None,
                 project_name: Optional[pulumi.Input[str]] = None,
                 provisioning_state: Optional[pulumi.Input[Union[str, 'ProvisioningState']]] = None,
                 reserved_instance: Optional[pulumi.Input[Union[str, 'AzureReservedInstance']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 scaling_factor: Optional[pulumi.Input[float]] = None,
                 sizing_criterion: Optional[pulumi.Input[Union[str, 'AssessmentSizingCriterion']]] = None,
                 time_range: Optional[pulumi.Input[Union[str, 'TimeRange']]] = None,
                 vcpu_oversubscription: Optional[pulumi.Input[float]] = None,
                 __props__=None):
        """
        AVS assessment resource.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] assessment_name: AVS Assessment ARM name
        :param pulumi.Input[Union[str, 'AzureLocation']] azure_location: Azure Location or Azure region where to which the machines will be migrated.
        :param pulumi.Input[Union[str, 'AzureOfferCode']] azure_offer_code: Azure Offer code according to which cost estimation is done.
        :param pulumi.Input[Union[str, 'AzureCurrency']] currency: Currency in which prices should be reported.
        :param pulumi.Input[float] dedupe_compression: De-duplication compression.
        :param pulumi.Input[float] discount_percentage: Custom discount percentage.
        :param pulumi.Input[Union[str, 'FttAndRaidLevel']] failures_to_tolerate_and_raid_level: Failures to tolerate and RAID level in a common property.
        :param pulumi.Input[str] group_name: Group ARM name
        :param pulumi.Input[bool] is_stretch_cluster_enabled: Is Stretch Cluster Enabled.
        :param pulumi.Input[float] mem_overcommit: Memory overcommit.
        :param pulumi.Input[Union[str, 'AzureAvsNodeType']] node_type: AVS node type.
        :param pulumi.Input[Union[str, 'Percentile']] percentile: Percentile of the utilization data values to be considered while assessing
               machines.
        :param pulumi.Input[str] perf_data_end_time: Gets or sets the end time to consider performance data for assessment.
        :param pulumi.Input[str] perf_data_start_time: Gets or sets the start time to consider performance data for assessment.
        :param pulumi.Input[str] project_name: Assessment Project Name
        :param pulumi.Input[Union[str, 'ProvisioningState']] provisioning_state: The status of the last operation.
        :param pulumi.Input[Union[str, 'AzureReservedInstance']] reserved_instance: Reserved instance.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[float] scaling_factor: Percentage of buffer that user wants on performance metrics when recommending
               Azure sizes.
        :param pulumi.Input[Union[str, 'AssessmentSizingCriterion']] sizing_criterion: Assessment sizing criterion.
        :param pulumi.Input[Union[str, 'TimeRange']] time_range: Time Range for which the historic utilization data should be considered for
               assessment.
        :param pulumi.Input[float] vcpu_oversubscription: VCPU over subscription.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AvsAssessmentsOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        AVS assessment resource.

        :param str resource_name: The name of the resource.
        :param AvsAssessmentsOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AvsAssessmentsOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 assessment_name: Optional[pulumi.Input[str]] = None,
                 azure_location: Optional[pulumi.Input[Union[str, 'AzureLocation']]] = None,
                 azure_offer_code: Optional[pulumi.Input[Union[str, 'AzureOfferCode']]] = None,
                 currency: Optional[pulumi.Input[Union[str, 'AzureCurrency']]] = None,
                 dedupe_compression: Optional[pulumi.Input[float]] = None,
                 discount_percentage: Optional[pulumi.Input[float]] = None,
                 failures_to_tolerate_and_raid_level: Optional[pulumi.Input[Union[str, 'FttAndRaidLevel']]] = None,
                 group_name: Optional[pulumi.Input[str]] = None,
                 is_stretch_cluster_enabled: Optional[pulumi.Input[bool]] = None,
                 mem_overcommit: Optional[pulumi.Input[float]] = None,
                 node_type: Optional[pulumi.Input[Union[str, 'AzureAvsNodeType']]] = None,
                 percentile: Optional[pulumi.Input[Union[str, 'Percentile']]] = None,
                 perf_data_end_time: Optional[pulumi.Input[str]] = None,
                 perf_data_start_time: Optional[pulumi.Input[str]] = None,
                 project_name: Optional[pulumi.Input[str]] = None,
                 provisioning_state: Optional[pulumi.Input[Union[str, 'ProvisioningState']]] = None,
                 reserved_instance: Optional[pulumi.Input[Union[str, 'AzureReservedInstance']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 scaling_factor: Optional[pulumi.Input[float]] = None,
                 sizing_criterion: Optional[pulumi.Input[Union[str, 'AssessmentSizingCriterion']]] = None,
                 time_range: Optional[pulumi.Input[Union[str, 'TimeRange']]] = None,
                 vcpu_oversubscription: Optional[pulumi.Input[float]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AvsAssessmentsOperationArgs.__new__(AvsAssessmentsOperationArgs)

            __props__.__dict__["assessment_name"] = assessment_name
            __props__.__dict__["azure_location"] = azure_location
            __props__.__dict__["azure_offer_code"] = azure_offer_code
            __props__.__dict__["currency"] = currency
            __props__.__dict__["dedupe_compression"] = dedupe_compression
            __props__.__dict__["discount_percentage"] = discount_percentage
            __props__.__dict__["failures_to_tolerate_and_raid_level"] = failures_to_tolerate_and_raid_level
            if group_name is None and not opts.urn:
                raise TypeError("Missing required property 'group_name'")
            __props__.__dict__["group_name"] = group_name
            __props__.__dict__["is_stretch_cluster_enabled"] = is_stretch_cluster_enabled
            __props__.__dict__["mem_overcommit"] = mem_overcommit
            __props__.__dict__["node_type"] = node_type
            __props__.__dict__["percentile"] = percentile
            __props__.__dict__["perf_data_end_time"] = perf_data_end_time
            __props__.__dict__["perf_data_start_time"] = perf_data_start_time
            if project_name is None and not opts.urn:
                raise TypeError("Missing required property 'project_name'")
            __props__.__dict__["project_name"] = project_name
            __props__.__dict__["provisioning_state"] = provisioning_state
            __props__.__dict__["reserved_instance"] = reserved_instance
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["scaling_factor"] = scaling_factor
            __props__.__dict__["sizing_criterion"] = sizing_criterion
            __props__.__dict__["time_range"] = time_range
            __props__.__dict__["vcpu_oversubscription"] = vcpu_oversubscription
            __props__.__dict__["assessment_error_summary"] = None
            __props__.__dict__["assessment_type"] = None
            __props__.__dict__["confidence_rating_in_percentage"] = None
            __props__.__dict__["cpu_utilization"] = None
            __props__.__dict__["created_timestamp"] = None
            __props__.__dict__["group_type"] = None
            __props__.__dict__["limiting_factor"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["number_of_machines"] = None
            __props__.__dict__["number_of_nodes"] = None
            __props__.__dict__["prices_timestamp"] = None
            __props__.__dict__["ram_utilization"] = None
            __props__.__dict__["schema_version"] = None
            __props__.__dict__["stage"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["storage_utilization"] = None
            __props__.__dict__["suitability"] = None
            __props__.__dict__["suitability_explanation"] = None
            __props__.__dict__["suitability_summary"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["total_cpu_cores"] = None
            __props__.__dict__["total_monthly_cost"] = None
            __props__.__dict__["total_ram_in_gb"] = None
            __props__.__dict__["total_storage_in_gb"] = None
            __props__.__dict__["type"] = None
            __props__.__dict__["updated_timestamp"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:migrate:AvsAssessmentsOperation")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(AvsAssessmentsOperation, __self__).__init__(
            'azure-native:migrate/v20230315:AvsAssessmentsOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'AvsAssessmentsOperation':
        """
        Get an existing AvsAssessmentsOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = AvsAssessmentsOperationArgs.__new__(AvsAssessmentsOperationArgs)

        __props__.__dict__["assessment_error_summary"] = None
        __props__.__dict__["assessment_type"] = None
        __props__.__dict__["azure_location"] = None
        __props__.__dict__["azure_offer_code"] = None
        __props__.__dict__["confidence_rating_in_percentage"] = None
        __props__.__dict__["cpu_utilization"] = None
        __props__.__dict__["created_timestamp"] = None
        __props__.__dict__["currency"] = None
        __props__.__dict__["dedupe_compression"] = None
        __props__.__dict__["discount_percentage"] = None
        __props__.__dict__["failures_to_tolerate_and_raid_level"] = None
        __props__.__dict__["group_type"] = None
        __props__.__dict__["is_stretch_cluster_enabled"] = None
        __props__.__dict__["limiting_factor"] = None
        __props__.__dict__["mem_overcommit"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["node_type"] = None
        __props__.__dict__["number_of_machines"] = None
        __props__.__dict__["number_of_nodes"] = None
        __props__.__dict__["percentile"] = None
        __props__.__dict__["perf_data_end_time"] = None
        __props__.__dict__["perf_data_start_time"] = None
        __props__.__dict__["prices_timestamp"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["ram_utilization"] = None
        __props__.__dict__["reserved_instance"] = None
        __props__.__dict__["scaling_factor"] = None
        __props__.__dict__["schema_version"] = None
        __props__.__dict__["sizing_criterion"] = None
        __props__.__dict__["stage"] = None
        __props__.__dict__["status"] = None
        __props__.__dict__["storage_utilization"] = None
        __props__.__dict__["suitability"] = None
        __props__.__dict__["suitability_explanation"] = None
        __props__.__dict__["suitability_summary"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["time_range"] = None
        __props__.__dict__["total_cpu_cores"] = None
        __props__.__dict__["total_monthly_cost"] = None
        __props__.__dict__["total_ram_in_gb"] = None
        __props__.__dict__["total_storage_in_gb"] = None
        __props__.__dict__["type"] = None
        __props__.__dict__["updated_timestamp"] = None
        __props__.__dict__["vcpu_oversubscription"] = None
        return AvsAssessmentsOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="assessmentErrorSummary")
    def assessment_error_summary(self) -> pulumi.Output[Mapping[str, int]]:
        """
        Gets the assessment error summary.
                    This is the number of machines
        affected by each type of error in this assessment.
        """
        return pulumi.get(self, "assessment_error_summary")

    @property
    @pulumi.getter(name="assessmentType")
    def assessment_type(self) -> pulumi.Output[str]:
        """
        Assessment type of the assessment.
        """
        return pulumi.get(self, "assessment_type")

    @property
    @pulumi.getter(name="azureLocation")
    def azure_location(self) -> pulumi.Output[Optional[str]]:
        """
        Azure Location or Azure region where to which the machines will be migrated.
        """
        return pulumi.get(self, "azure_location")

    @property
    @pulumi.getter(name="azureOfferCode")
    def azure_offer_code(self) -> pulumi.Output[Optional[str]]:
        """
        Azure Offer code according to which cost estimation is done.
        """
        return pulumi.get(self, "azure_offer_code")

    @property
    @pulumi.getter(name="confidenceRatingInPercentage")
    def confidence_rating_in_percentage(self) -> pulumi.Output[float]:
        """
        Confidence Rating in Percentage.
        """
        return pulumi.get(self, "confidence_rating_in_percentage")

    @property
    @pulumi.getter(name="cpuUtilization")
    def cpu_utilization(self) -> pulumi.Output[float]:
        """
        Predicted CPU utilization.
        """
        return pulumi.get(self, "cpu_utilization")

    @property
    @pulumi.getter(name="createdTimestamp")
    def created_timestamp(self) -> pulumi.Output[str]:
        """
        Date and Time when assessment was created.
        """
        return pulumi.get(self, "created_timestamp")

    @property
    @pulumi.getter
    def currency(self) -> pulumi.Output[Optional[str]]:
        """
        Currency in which prices should be reported.
        """
        return pulumi.get(self, "currency")

    @property
    @pulumi.getter(name="dedupeCompression")
    def dedupe_compression(self) -> pulumi.Output[Optional[float]]:
        """
        De-duplication compression.
        """
        return pulumi.get(self, "dedupe_compression")

    @property
    @pulumi.getter(name="discountPercentage")
    def discount_percentage(self) -> pulumi.Output[Optional[float]]:
        """
        Custom discount percentage.
        """
        return pulumi.get(self, "discount_percentage")

    @property
    @pulumi.getter(name="failuresToTolerateAndRaidLevel")
    def failures_to_tolerate_and_raid_level(self) -> pulumi.Output[Optional[str]]:
        """
        Failures to tolerate and RAID level in a common property.
        """
        return pulumi.get(self, "failures_to_tolerate_and_raid_level")

    @property
    @pulumi.getter(name="groupType")
    def group_type(self) -> pulumi.Output[str]:
        """
        Gets the group type for the assessment.
        """
        return pulumi.get(self, "group_type")

    @property
    @pulumi.getter(name="isStretchClusterEnabled")
    def is_stretch_cluster_enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Is Stretch Cluster Enabled.
        """
        return pulumi.get(self, "is_stretch_cluster_enabled")

    @property
    @pulumi.getter(name="limitingFactor")
    def limiting_factor(self) -> pulumi.Output[str]:
        """
        Limiting factor.
        """
        return pulumi.get(self, "limiting_factor")

    @property
    @pulumi.getter(name="memOvercommit")
    def mem_overcommit(self) -> pulumi.Output[Optional[float]]:
        """
        Memory overcommit.
        """
        return pulumi.get(self, "mem_overcommit")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nodeType")
    def node_type(self) -> pulumi.Output[Optional[str]]:
        """
        AVS node type.
        """
        return pulumi.get(self, "node_type")

    @property
    @pulumi.getter(name="numberOfMachines")
    def number_of_machines(self) -> pulumi.Output[int]:
        """
        Number of machines part of the assessment.
        """
        return pulumi.get(self, "number_of_machines")

    @property
    @pulumi.getter(name="numberOfNodes")
    def number_of_nodes(self) -> pulumi.Output[int]:
        """
        Recommended number of nodes.
        """
        return pulumi.get(self, "number_of_nodes")

    @property
    @pulumi.getter
    def percentile(self) -> pulumi.Output[Optional[str]]:
        """
        Percentile of the utilization data values to be considered while assessing
        machines.
        """
        return pulumi.get(self, "percentile")

    @property
    @pulumi.getter(name="perfDataEndTime")
    def perf_data_end_time(self) -> pulumi.Output[Optional[str]]:
        """
        Gets or sets the end time to consider performance data for assessment.
        """
        return pulumi.get(self, "perf_data_end_time")

    @property
    @pulumi.getter(name="perfDataStartTime")
    def perf_data_start_time(self) -> pulumi.Output[Optional[str]]:
        """
        Gets or sets the start time to consider performance data for assessment.
        """
        return pulumi.get(self, "perf_data_start_time")

    @property
    @pulumi.getter(name="pricesTimestamp")
    def prices_timestamp(self) -> pulumi.Output[str]:
        """
        Time when the Azure Prices were queried. Date-Time represented in ISO-8601
        format.
        """
        return pulumi.get(self, "prices_timestamp")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[Optional[str]]:
        """
        The status of the last operation.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="ramUtilization")
    def ram_utilization(self) -> pulumi.Output[float]:
        """
        Predicted RAM utilization.
        """
        return pulumi.get(self, "ram_utilization")

    @property
    @pulumi.getter(name="reservedInstance")
    def reserved_instance(self) -> pulumi.Output[Optional[str]]:
        """
        Reserved instance.
        """
        return pulumi.get(self, "reserved_instance")

    @property
    @pulumi.getter(name="scalingFactor")
    def scaling_factor(self) -> pulumi.Output[Optional[float]]:
        """
        Percentage of buffer that user wants on performance metrics when recommending
        Azure sizes.
        """
        return pulumi.get(self, "scaling_factor")

    @property
    @pulumi.getter(name="schemaVersion")
    def schema_version(self) -> pulumi.Output[str]:
        """
        Schema version.
        """
        return pulumi.get(self, "schema_version")

    @property
    @pulumi.getter(name="sizingCriterion")
    def sizing_criterion(self) -> pulumi.Output[Optional[str]]:
        """
        Assessment sizing criterion.
        """
        return pulumi.get(self, "sizing_criterion")

    @property
    @pulumi.getter
    def stage(self) -> pulumi.Output[str]:
        """
        User configurable setting to display the Stage of Assessment.
        """
        return pulumi.get(self, "stage")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        Whether assessment is in valid state and all machines have been assessed.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="storageUtilization")
    def storage_utilization(self) -> pulumi.Output[float]:
        """
        Predicted storage utilization.
        """
        return pulumi.get(self, "storage_utilization")

    @property
    @pulumi.getter
    def suitability(self) -> pulumi.Output[str]:
        """
        Gets or sets the Assessment cloud suitability.
        """
        return pulumi.get(self, "suitability")

    @property
    @pulumi.getter(name="suitabilityExplanation")
    def suitability_explanation(self) -> pulumi.Output[str]:
        """
        Gets or sets the Assessment suitability explanation.
        """
        return pulumi.get(self, "suitability_explanation")

    @property
    @pulumi.getter(name="suitabilitySummary")
    def suitability_summary(self) -> pulumi.Output[Mapping[str, int]]:
        """
        Cloud suitability summary for all the machines in the assessment.
        """
        return pulumi.get(self, "suitability_summary")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter(name="timeRange")
    def time_range(self) -> pulumi.Output[Optional[str]]:
        """
        Time Range for which the historic utilization data should be considered for
        assessment.
        """
        return pulumi.get(self, "time_range")

    @property
    @pulumi.getter(name="totalCpuCores")
    def total_cpu_cores(self) -> pulumi.Output[float]:
        """
        Predicted total CPU cores used.
        """
        return pulumi.get(self, "total_cpu_cores")

    @property
    @pulumi.getter(name="totalMonthlyCost")
    def total_monthly_cost(self) -> pulumi.Output[float]:
        """
        Total monthly cost.
        """
        return pulumi.get(self, "total_monthly_cost")

    @property
    @pulumi.getter(name="totalRamInGB")
    def total_ram_in_gb(self) -> pulumi.Output[float]:
        """
        Predicted total RAM used in GB.
        """
        return pulumi.get(self, "total_ram_in_gb")

    @property
    @pulumi.getter(name="totalStorageInGB")
    def total_storage_in_gb(self) -> pulumi.Output[float]:
        """
        Predicted total Storage used in GB.
        """
        return pulumi.get(self, "total_storage_in_gb")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="updatedTimestamp")
    def updated_timestamp(self) -> pulumi.Output[str]:
        """
        Date and Time when assessment was last updated.
        """
        return pulumi.get(self, "updated_timestamp")

    @property
    @pulumi.getter(name="vcpuOversubscription")
    def vcpu_oversubscription(self) -> pulumi.Output[Optional[float]]:
        """
        VCPU over subscription.
        """
        return pulumi.get(self, "vcpu_oversubscription")

