# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'BillingSku',
    'CoreNetworkType',
    'CreatedByType',
    'ManagedServiceIdentityType',
    'NaptEnabled',
    'PduSessionType',
    'PlatformType',
    'PreemptionCapability',
    'PreemptionVulnerability',
    'SdfDirection',
    'TrafficControlPermission',
]


class BillingSku(str, Enum):
    """
    The SKU defining the throughput and SIM allowances for this packet core control plane deployment.
    """
    EVALUATION_PACKAGE = "EvaluationPackage"
    """
    Evaluation package plan
    """
    FLAGSHIP_STARTER_PACKAGE = "FlagshipStarterPackage"
    """
    Flagship starter package plan
    """
    EDGE_SITE2_GBPS = "EdgeSite2GBPS"
    """
    Edge site 2Gbps plan
    """
    EDGE_SITE3_GBPS = "EdgeSite3GBPS"
    """
    Edge site 3Gbps plan
    """
    EDGE_SITE4_GBPS = "EdgeSite4GBPS"
    """
    Edge site 4Gbps plan
    """
    MEDIUM_PACKAGE = "MediumPackage"
    """
    Medium package plan
    """
    LARGE_PACKAGE = "LargePackage"
    """
    Large package plan
    """


class CoreNetworkType(str, Enum):
    """
    The core network technology generation (5G core or EPC / 4G core).
    """
    CORE_NETWORK_TYPE_5_GC = "5GC"
    """
    5G core
    """
    EPC = "EPC"
    """
    EPC / 4G core
    """


class CreatedByType(str, Enum):
    """
    The type of identity that last modified the resource.
    """
    USER = "User"
    APPLICATION = "Application"
    MANAGED_IDENTITY = "ManagedIdentity"
    KEY = "Key"


class ManagedServiceIdentityType(str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


class NaptEnabled(str, Enum):
    """
    Whether NAPT is enabled for connections to this attached data network.
    """
    ENABLED = "Enabled"
    """
    NAPT is enabled
    """
    DISABLED = "Disabled"
    """
    NAPT is disabled
    """


class PduSessionType(str, Enum):
    """
    The default PDU session type, which is used if the UE does not request a specific session type.
    """
    I_PV4 = "IPv4"
    I_PV6 = "IPv6"


class PlatformType(str, Enum):
    """
    The platform type where packet core is deployed.
    """
    AK_S_HCI = "AKS-HCI"
    """
    If this option is chosen, you must set one of "azureStackEdgeDevice", "connectedCluster" or "customLocation". If multiple are set then "customLocation" will take precedence over "connectedCluster" which takes precedence over "azureStackEdgeDevice".
    """
    BASE_VM = "BaseVM"
    """
    If this option is chosen, you must set one of "connectedCluster" or "customLocation". If multiple are set then "customLocation" will take precedence over "connectedCluster".
    """


class PreemptionCapability(str, Enum):
    """
    Default QoS Flow preemption capability. The preemption capability of a QoS Flow controls whether it can preempt another QoS Flow with a lower priority level. See 3GPP TS23.501 section 5.7.2.2 for a full description of the ARP parameters.
    """
    NOT_PREEMPT = "NotPreempt"
    """
    Cannot preempt
    """
    MAY_PREEMPT = "MayPreempt"
    """
    May preempt
    """


class PreemptionVulnerability(str, Enum):
    """
    Default QoS Flow preemption vulnerability. The preemption vulnerability of a QoS Flow controls whether it can be preempted by a QoS Flow with a higher priority level. See 3GPP TS23.501 section 5.7.2.2 for a full description of the ARP parameters.
    """
    NOT_PREEMPTABLE = "NotPreemptable"
    """
    Cannot be preempted
    """
    PREEMPTABLE = "Preemptable"
    """
    May be preempted
    """


class SdfDirection(str, Enum):
    """
    The direction of this flow.
    """
    UPLINK = "Uplink"
    """
    Traffic flowing from the UE to the data network.
    """
    DOWNLINK = "Downlink"
    """
    Traffic flowing from the data network to the UE.
    """
    BIDIRECTIONAL = "Bidirectional"
    """
    Traffic flowing both to and from the UE.
    """


class TrafficControlPermission(str, Enum):
    """
    Determines whether flows that match this data flow policy rule are permitted.
    """
    ENABLED = "Enabled"
    """
    Traffic matching this rule is allowed to flow.
    """
    BLOCKED = "Blocked"
    """
    Traffic matching this rule is not allowed to flow.
    """
