# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'GetUserSettingsWithLocationResult',
    'AwaitableGetUserSettingsWithLocationResult',
    'get_user_settings_with_location',
    'get_user_settings_with_location_output',
]

@pulumi.output_type
class GetUserSettingsWithLocationResult:
    """
    Response to get user settings
    """
    def __init__(__self__, properties=None):
        if properties and not isinstance(properties, dict):
            raise TypeError("Expected argument 'properties' to be a dict")
        pulumi.set(__self__, "properties", properties)

    @property
    @pulumi.getter
    def properties(self) -> 'outputs.UserPropertiesResponse':
        """
        The cloud shell user settings properties.
        """
        return pulumi.get(self, "properties")


class AwaitableGetUserSettingsWithLocationResult(GetUserSettingsWithLocationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetUserSettingsWithLocationResult(
            properties=self.properties)


def get_user_settings_with_location(location: Optional[str] = None,
                                    user_settings_name: Optional[str] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetUserSettingsWithLocationResult:
    """
    Get current user settings for current signed in user. This operation returns settings for the user's cloud shell preferences including preferred location, storage profile, shell type, font and size settings.


    :param str location: The provider location
    :param str user_settings_name: The name of the user settings
    """
    __args__ = dict()
    __args__['location'] = location
    __args__['userSettingsName'] = user_settings_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:portal/v20181001:getUserSettingsWithLocation', __args__, opts=opts, typ=GetUserSettingsWithLocationResult).value

    return AwaitableGetUserSettingsWithLocationResult(
        properties=pulumi.get(__ret__, 'properties'))


@_utilities.lift_output_func(get_user_settings_with_location)
def get_user_settings_with_location_output(location: Optional[pulumi.Input[str]] = None,
                                           user_settings_name: Optional[pulumi.Input[str]] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetUserSettingsWithLocationResult]:
    """
    Get current user settings for current signed in user. This operation returns settings for the user's cloud shell preferences including preferred location, storage profile, shell type, font and size settings.


    :param str location: The provider location
    :param str user_settings_name: The name of the user settings
    """
    ...
