# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'ListWorkspaceCollectionAccessKeysResult',
    'AwaitableListWorkspaceCollectionAccessKeysResult',
    'list_workspace_collection_access_keys',
    'list_workspace_collection_access_keys_output',
]

@pulumi.output_type
class ListWorkspaceCollectionAccessKeysResult:
    def __init__(__self__, key1=None, key2=None):
        if key1 and not isinstance(key1, str):
            raise TypeError("Expected argument 'key1' to be a str")
        pulumi.set(__self__, "key1", key1)
        if key2 and not isinstance(key2, str):
            raise TypeError("Expected argument 'key2' to be a str")
        pulumi.set(__self__, "key2", key2)

    @property
    @pulumi.getter
    def key1(self) -> Optional[str]:
        """
        Access key 1
        """
        return pulumi.get(self, "key1")

    @property
    @pulumi.getter
    def key2(self) -> Optional[str]:
        """
        Access key 2
        """
        return pulumi.get(self, "key2")


class AwaitableListWorkspaceCollectionAccessKeysResult(ListWorkspaceCollectionAccessKeysResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListWorkspaceCollectionAccessKeysResult(
            key1=self.key1,
            key2=self.key2)


def list_workspace_collection_access_keys(resource_group_name: Optional[str] = None,
                                          workspace_collection_name: Optional[str] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListWorkspaceCollectionAccessKeysResult:
    """
    Retrieves the primary and secondary access keys for the specified Power BI Workspace Collection.
    Azure REST API version: 2016-01-29.


    :param str resource_group_name: Azure resource group
    :param str workspace_collection_name: Power BI Embedded Workspace Collection name
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['workspaceCollectionName'] = workspace_collection_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:powerbi:listWorkspaceCollectionAccessKeys', __args__, opts=opts, typ=ListWorkspaceCollectionAccessKeysResult).value

    return AwaitableListWorkspaceCollectionAccessKeysResult(
        key1=pulumi.get(__ret__, 'key1'),
        key2=pulumi.get(__ret__, 'key2'))


@_utilities.lift_output_func(list_workspace_collection_access_keys)
def list_workspace_collection_access_keys_output(resource_group_name: Optional[pulumi.Input[str]] = None,
                                                 workspace_collection_name: Optional[pulumi.Input[str]] = None,
                                                 opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[ListWorkspaceCollectionAccessKeysResult]:
    """
    Retrieves the primary and secondary access keys for the specified Power BI Workspace Collection.
    Azure REST API version: 2016-01-29.


    :param str resource_group_name: Azure resource group
    :param str workspace_collection_name: Power BI Embedded Workspace Collection name
    """
    ...
