# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AlertNotifications',
    'AlertsToAdmins',
    'DataSource',
    'ExportData',
    'RecommendationConfigStatus',
    'RecommendationType',
    'SecuritySolutionStatus',
]


class AlertNotifications(str, Enum):
    """
    Whether to send security alerts notifications to the security contact
    """
    ON = "On"
    """
    Get notifications on new alerts
    """
    OFF = "Off"
    """
    Don't get notifications on new alerts
    """


class AlertsToAdmins(str, Enum):
    """
    Whether to send security alerts notifications to subscription admins
    """
    ON = "On"
    """
    Send notification on new alerts to the subscription's admins
    """
    OFF = "Off"
    """
    Don't send notification on new alerts to the subscription's admins
    """


class DataSource(str, Enum):
    TWIN_DATA = "TwinData"
    """
    Devices twin data
    """


class ExportData(str, Enum):
    RAW_EVENTS = "RawEvents"
    """
    Agent raw events
    """


class RecommendationConfigStatus(str, Enum):
    """
    Recommendation status. The recommendation is not generated when the status is disabled
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


class RecommendationType(str, Enum):
    """
    The recommendation type.
    """
    IO_T_ACR_AUTHENTICATION = "IoT_ACRAuthentication"
    """
    Authentication schema used for pull an edge module from an ACR repository does not use Service Principal Authentication.
    """
    IO_T_AGENT_SENDS_UNUTILIZED_MESSAGES = "IoT_AgentSendsUnutilizedMessages"
    """
    IoT agent message size capacity is currently underutilized, causing an increase in the number of sent messages. Adjust message intervals for better utilization.
    """
    IO_T_BASELINE = "IoT_Baseline"
    """
    Identified security related system configuration issues.
    """
    IO_T_EDGE_HUB_MEM_OPTIMIZE = "IoT_EdgeHubMemOptimize"
    """
    You can optimize Edge Hub memory usage by turning off protocol heads for any protocols not used by Edge modules in your solution.
    """
    IO_T_EDGE_LOGGING_OPTIONS = "IoT_EdgeLoggingOptions"
    """
    Logging is disabled for this edge module.
    """
    IO_T_INCONSISTENT_MODULE_SETTINGS = "IoT_InconsistentModuleSettings"
    """
    A minority within a device security group has inconsistent Edge Module settings with the rest of their group.
    """
    IO_T_INSTALL_AGENT = "IoT_InstallAgent"
    """
    Install the Azure Security of Things Agent.
    """
    IO_T_IP_FILTER_DENY_ALL = "IoT_IPFilter_DenyAll"
    """
    IP Filter Configuration should have rules defined for allowed traffic and should deny all other traffic by default.
    """
    IO_T_IP_FILTER_PERMISSIVE_RULE = "IoT_IPFilter_PermissiveRule"
    """
    An Allow IP Filter rules source IP range is too large. Overly permissive rules might expose your IoT hub to malicious intenders.
    """
    IO_T_OPEN_PORTS = "IoT_OpenPorts"
    """
    A listening endpoint was found on the device.
    """
    IO_T_PERMISSIVE_FIREWALL_POLICY = "IoT_PermissiveFirewallPolicy"
    """
    An Allowed firewall policy was found (INPUT/OUTPUT). The policy should Deny all traffic by default and define rules to allow necessary communication to/from the device.
    """
    IO_T_PERMISSIVE_INPUT_FIREWALL_RULES = "IoT_PermissiveInputFirewallRules"
    """
    A rule in the firewall has been found that contains a permissive pattern for a wide range of IP addresses or Ports.
    """
    IO_T_PERMISSIVE_OUTPUT_FIREWALL_RULES = "IoT_PermissiveOutputFirewallRules"
    """
    A rule in the firewall has been found that contains a permissive pattern for a wide range of IP addresses or Ports.
    """
    IO_T_PRIVILEGED_DOCKER_OPTIONS = "IoT_PrivilegedDockerOptions"
    """
    Edge module is configured to run in privileged mode, with extensive Linux capabilities or with host-level network access (send/receive data to host machine).
    """
    IO_T_SHARED_CREDENTIALS = "IoT_SharedCredentials"
    """
    Same authentication credentials to the IoT Hub used by multiple devices. This could indicate an illegitimate device impersonating a legitimate device. It also exposes the risk of device impersonation by an attacker.
    """
    IO_T_VULNERABLE_TLS_CIPHER_SUITE = "IoT_VulnerableTLSCipherSuite"
    """
    Insecure TLS configurations detected. Immediate upgrade recommended.
    """


class SecuritySolutionStatus(str, Enum):
    """
    Security solution status
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"
