# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AutomationRuleActionType',
    'AutomationRuleConditionType',
    'AutomationRulePropertyConditionSupportedOperator',
    'AutomationRulePropertyConditionSupportedProperty',
    'EntityTimelineKind',
    'IncidentClassification',
    'IncidentClassificationReason',
    'IncidentSeverity',
    'IncidentStatus',
    'SettingKind',
    'Source',
    'TriggersOn',
    'TriggersWhen',
]


class AutomationRuleActionType(str, Enum):
    """
    The type of the automation rule action
    """
    MODIFY_PROPERTIES = "ModifyProperties"
    """
    Modify an object's properties
    """
    RUN_PLAYBOOK = "RunPlaybook"
    """
    Run a playbook on an object
    """


class AutomationRuleConditionType(str, Enum):
    """
    The type of the automation rule condition
    """
    PROPERTY = "Property"
    """
    Evaluate an object property value
    """


class AutomationRulePropertyConditionSupportedOperator(str, Enum):
    """
    The operator to use for evaluation the condition
    """
    EQUALS = "Equals"
    """
    Evaluates if the property equals at least one of the condition values
    """
    NOT_EQUALS = "NotEquals"
    """
    Evaluates if the property does not equal any of the condition values
    """
    CONTAINS = "Contains"
    """
    Evaluates if the property contains at least one of the condition values
    """
    NOT_CONTAINS = "NotContains"
    """
    Evaluates if the property does not contain any of the condition values
    """
    STARTS_WITH = "StartsWith"
    """
    Evaluates if the property starts with any of the condition values
    """
    NOT_STARTS_WITH = "NotStartsWith"
    """
    Evaluates if the property does not start with any of the condition values
    """
    ENDS_WITH = "EndsWith"
    """
    Evaluates if the property ends with any of the condition values
    """
    NOT_ENDS_WITH = "NotEndsWith"
    """
    Evaluates if the property does not end with any of the condition values
    """


class AutomationRulePropertyConditionSupportedProperty(str, Enum):
    """
    The property to evaluate
    """
    INCIDENT_TITLE = "IncidentTitle"
    """
    The title of the incident
    """
    INCIDENT_DESCRIPTION = "IncidentDescription"
    """
    The description of the incident
    """
    INCIDENT_SEVERITY = "IncidentSeverity"
    """
    The severity of the incident
    """
    INCIDENT_STATUS = "IncidentStatus"
    """
    The status of the incident
    """
    INCIDENT_TACTICS = "IncidentTactics"
    """
    The tactics of the incident
    """
    INCIDENT_RELATED_ANALYTIC_RULE_IDS = "IncidentRelatedAnalyticRuleIds"
    """
    The related Analytic rule ids of the incident
    """
    INCIDENT_PROVIDER_NAME = "IncidentProviderName"
    """
    The provider name of the incident
    """
    ACCOUNT_AAD_TENANT_ID = "AccountAadTenantId"
    """
    The account Azure Active Directory tenant id
    """
    ACCOUNT_AAD_USER_ID = "AccountAadUserId"
    """
    The account Azure Active Directory user id.
    """
    ACCOUNT_NAME = "AccountName"
    """
    The account name
    """
    ACCOUNT_NT_DOMAIN = "AccountNTDomain"
    """
    The account NetBIOS domain name
    """
    ACCOUNT_PUID = "AccountPUID"
    """
    The account Azure Active Directory Passport User ID
    """
    ACCOUNT_SID = "AccountSid"
    """
    The account security identifier
    """
    ACCOUNT_OBJECT_GUID = "AccountObjectGuid"
    """
    The account unique identifier
    """
    ACCOUNT_UPN_SUFFIX = "AccountUPNSuffix"
    """
    The account user principal name suffix
    """
    AZURE_RESOURCE_RESOURCE_ID = "AzureResourceResourceId"
    """
    The Azure resource id
    """
    AZURE_RESOURCE_SUBSCRIPTION_ID = "AzureResourceSubscriptionId"
    """
    The Azure resource subscription id
    """
    CLOUD_APPLICATION_APP_ID = "CloudApplicationAppId"
    """
    The cloud application identifier
    """
    CLOUD_APPLICATION_APP_NAME = "CloudApplicationAppName"
    """
    The cloud application name
    """
    DNS_DOMAIN_NAME = "DNSDomainName"
    """
    The dns record domain name
    """
    FILE_DIRECTORY = "FileDirectory"
    """
    The file directory full path
    """
    FILE_NAME = "FileName"
    """
    The file name without path
    """
    FILE_HASH_VALUE = "FileHashValue"
    """
    The file hash value
    """
    HOST_AZURE_ID = "HostAzureID"
    """
    The host Azure resource id
    """
    HOST_NAME = "HostName"
    """
    The host name without domain
    """
    HOST_NET_BIOS_NAME = "HostNetBiosName"
    """
    The host NetBIOS name
    """
    HOST_NT_DOMAIN = "HostNTDomain"
    """
    The host NT domain
    """
    HOST_OS_VERSION = "HostOSVersion"
    """
    The host operating system
    """
    IO_T_DEVICE_ID = "IoTDeviceId"
    """
    The IoT device id
    """
    IO_T_DEVICE_NAME = "IoTDeviceName"
    """
    The IoT device name
    """
    IO_T_DEVICE_TYPE = "IoTDeviceType"
    """
    The IoT device type
    """
    IO_T_DEVICE_VENDOR = "IoTDeviceVendor"
    """
    The IoT device vendor
    """
    IO_T_DEVICE_MODEL = "IoTDeviceModel"
    """
    The IoT device model
    """
    IO_T_DEVICE_OPERATING_SYSTEM = "IoTDeviceOperatingSystem"
    """
    The IoT device operating system
    """
    IP_ADDRESS = "IPAddress"
    """
    The IP address
    """
    MAILBOX_DISPLAY_NAME = "MailboxDisplayName"
    """
    The mailbox display name
    """
    MAILBOX_PRIMARY_ADDRESS = "MailboxPrimaryAddress"
    """
    The mailbox primary address
    """
    MAILBOX_UPN = "MailboxUPN"
    """
    The mailbox user principal name
    """
    MAIL_MESSAGE_DELIVERY_ACTION = "MailMessageDeliveryAction"
    """
    The mail message delivery action
    """
    MAIL_MESSAGE_DELIVERY_LOCATION = "MailMessageDeliveryLocation"
    """
    The mail message delivery location
    """
    MAIL_MESSAGE_RECIPIENT = "MailMessageRecipient"
    """
    The mail message recipient
    """
    MAIL_MESSAGE_SENDER_IP = "MailMessageSenderIP"
    """
    The mail message sender IP address
    """
    MAIL_MESSAGE_SUBJECT = "MailMessageSubject"
    """
    The mail message subject
    """
    MAIL_MESSAGE_P1_SENDER = "MailMessageP1Sender"
    """
    The mail message P1 sender
    """
    MAIL_MESSAGE_P2_SENDER = "MailMessageP2Sender"
    """
    The mail message P2 sender
    """
    MALWARE_CATEGORY = "MalwareCategory"
    """
    The malware category
    """
    MALWARE_NAME = "MalwareName"
    """
    The malware name
    """
    PROCESS_COMMAND_LINE = "ProcessCommandLine"
    """
    The process execution command line
    """
    PROCESS_ID = "ProcessId"
    """
    The process id
    """
    REGISTRY_KEY = "RegistryKey"
    """
    The registry key path
    """
    REGISTRY_VALUE_DATA = "RegistryValueData"
    """
    The registry key value in string formatted representation
    """
    URL = "Url"
    """
    The url
    """


class EntityTimelineKind(str, Enum):
    """
    The entity query kind
    """
    ACTIVITY = "Activity"
    """
    activity
    """
    BOOKMARK = "Bookmark"
    """
    bookmarks
    """
    SECURITY_ALERT = "SecurityAlert"
    """
    security alerts
    """


class IncidentClassification(str, Enum):
    """
    The reason the incident was closed
    """
    UNDETERMINED = "Undetermined"
    """
    Incident classification was undetermined
    """
    TRUE_POSITIVE = "TruePositive"
    """
    Incident was true positive
    """
    BENIGN_POSITIVE = "BenignPositive"
    """
    Incident was benign positive
    """
    FALSE_POSITIVE = "FalsePositive"
    """
    Incident was false positive
    """


class IncidentClassificationReason(str, Enum):
    """
    The classification reason to close the incident with
    """
    SUSPICIOUS_ACTIVITY = "SuspiciousActivity"
    """
    Classification reason was suspicious activity
    """
    SUSPICIOUS_BUT_EXPECTED = "SuspiciousButExpected"
    """
    Classification reason was suspicious but expected
    """
    INCORRECT_ALERT_LOGIC = "IncorrectAlertLogic"
    """
    Classification reason was incorrect alert logic
    """
    INACCURATE_DATA = "InaccurateData"
    """
    Classification reason was inaccurate data
    """


class IncidentSeverity(str, Enum):
    """
    The severity of the incident
    """
    HIGH = "High"
    """
    High severity
    """
    MEDIUM = "Medium"
    """
    Medium severity
    """
    LOW = "Low"
    """
    Low severity
    """
    INFORMATIONAL = "Informational"
    """
    Informational severity
    """


class IncidentStatus(str, Enum):
    """
    The status of the incident
    """
    NEW = "New"
    """
    An active incident which isn't being handled currently
    """
    ACTIVE = "Active"
    """
    An active incident which is being handled
    """
    CLOSED = "Closed"
    """
    A non-active incident
    """


class SettingKind(str, Enum):
    """
    The kind of the setting
    """
    ANOMALIES = "Anomalies"
    EYES_ON = "EyesOn"
    ENTITY_ANALYTICS = "EntityAnalytics"
    UEBA = "Ueba"


class Source(str, Enum):
    """
    The source of the watchlist
    """
    LOCAL_FILE = "Local file"
    REMOTE_STORAGE = "Remote storage"


class TriggersOn(str, Enum):
    """
    The type of object the automation rule triggers on
    """
    INCIDENTS = "Incidents"
    """
    Trigger on Incidents
    """


class TriggersWhen(str, Enum):
    """
    The type of event the automation rule triggers on
    """
    CREATED = "Created"
    """
    Trigger on created objects
    """
