# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'Access',
    'ClusterUpgradeCadence',
    'ClusterUpgradeMode',
    'Direction',
    'ManagedClusterAddOnFeature',
    'NsgProtocol',
    'PrivateEndpointNetworkPolicies',
    'PrivateLinkServiceNetworkPolicies',
    'ProbeProtocol',
    'Protocol',
    'SkuName',
    'ZonalUpdateMode',
]


class Access(str, Enum):
    """
    The network traffic is allowed or denied.
    """
    ALLOW = "allow"
    DENY = "deny"


class ClusterUpgradeCadence(str, Enum):
    """
    Indicates when new cluster runtime version upgrades will be applied after they are released. By default is Wave0. Only applies when **clusterUpgradeMode** is set to 'Automatic'.
    """
    WAVE0 = "Wave0"
    """
    Cluster upgrade starts immediately after a new version is rolled out. Recommended for Test/Dev clusters.
    """
    WAVE1 = "Wave1"
    """
    Cluster upgrade starts 7 days after a new version is rolled out. Recommended for Pre-prod clusters.
    """
    WAVE2 = "Wave2"
    """
    Cluster upgrade starts 14 days after a new version is rolled out. Recommended for Production clusters.
    """


class ClusterUpgradeMode(str, Enum):
    """
    The upgrade mode of the cluster when new Service Fabric runtime version is available.
    """
    AUTOMATIC = "Automatic"
    """
    The cluster will be automatically upgraded to the latest Service Fabric runtime version, **clusterUpgradeCadence** will determine when the upgrade starts after the new version becomes available.
    """
    MANUAL = "Manual"
    """
    The cluster will not be automatically upgraded to the latest Service Fabric runtime version. The cluster is upgraded by setting the **clusterCodeVersion** property in the cluster resource.
    """


class Direction(str, Enum):
    """
    Network security rule direction.
    """
    INBOUND = "inbound"
    OUTBOUND = "outbound"


class ManagedClusterAddOnFeature(str, Enum):
    """
    Available cluster add-on features
    """
    DNS_SERVICE = "DnsService"
    """
    Dns service
    """
    BACKUP_RESTORE_SERVICE = "BackupRestoreService"
    """
    Backup and restore service
    """
    RESOURCE_MONITOR_SERVICE = "ResourceMonitorService"
    """
    Resource monitor service
    """


class NsgProtocol(str, Enum):
    """
    Network protocol this rule applies to.
    """
    HTTP = "http"
    HTTPS = "https"
    TCP = "tcp"
    UDP = "udp"
    ICMP = "icmp"
    AH = "ah"
    ESP = "esp"


class PrivateEndpointNetworkPolicies(str, Enum):
    """
    Enable or Disable apply network policies on private end point in the subnet.
    """
    ENABLED = "enabled"
    DISABLED = "disabled"


class PrivateLinkServiceNetworkPolicies(str, Enum):
    """
    Enable or Disable apply network policies on private link service in the subnet.
    """
    ENABLED = "enabled"
    DISABLED = "disabled"


class ProbeProtocol(str, Enum):
    """
    the reference to the load balancer probe used by the load balancing rule.
    """
    TCP = "tcp"
    HTTP = "http"
    HTTPS = "https"


class Protocol(str, Enum):
    """
    The reference to the transport protocol used by the load balancing rule.
    """
    TCP = "tcp"
    UDP = "udp"


class SkuName(str, Enum):
    """
    Sku Name.
    """
    BASIC = "Basic"
    """
    Basic requires a minimum of 3 nodes and allows only 1 node type.
    """
    STANDARD = "Standard"
    """
    Requires a minimum of 5 nodes and allows 1 or more node type.
    """


class ZonalUpdateMode(str, Enum):
    """
    Indicates the update mode for Cross Az clusters.
    """
    STANDARD = "Standard"
    """
    The cluster will use 5 upgrade domains for Cross Az Node types.
    """
    FAST = "Fast"
    """
    The cluster will use a maximum of 3 upgrade domains per zone instead of 5 for Cross Az Node types for faster deployments.
    """
