# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['NodeTypeArgs', 'NodeType']

@pulumi.input_type
class NodeTypeArgs:
    def __init__(__self__, *,
                 cluster_name: pulumi.Input[str],
                 is_primary: pulumi.Input[bool],
                 resource_group_name: pulumi.Input[str],
                 vm_instance_count: pulumi.Input[int],
                 additional_data_disks: Optional[pulumi.Input[Sequence[pulumi.Input['VmssDataDiskArgs']]]] = None,
                 additional_network_interface_configurations: Optional[pulumi.Input[Sequence[pulumi.Input['AdditionalNetworkInterfaceConfigurationArgs']]]] = None,
                 application_ports: Optional[pulumi.Input['EndpointRangeDescriptionArgs']] = None,
                 capacities: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 data_disk_letter: Optional[pulumi.Input[str]] = None,
                 data_disk_size_gb: Optional[pulumi.Input[int]] = None,
                 data_disk_type: Optional[pulumi.Input[Union[str, 'DiskType']]] = None,
                 dscp_configuration_id: Optional[pulumi.Input[str]] = None,
                 enable_accelerated_networking: Optional[pulumi.Input[bool]] = None,
                 enable_encryption_at_host: Optional[pulumi.Input[bool]] = None,
                 enable_node_public_ip: Optional[pulumi.Input[bool]] = None,
                 enable_node_public_i_pv6: Optional[pulumi.Input[bool]] = None,
                 enable_over_provisioning: Optional[pulumi.Input[bool]] = None,
                 ephemeral_ports: Optional[pulumi.Input['EndpointRangeDescriptionArgs']] = None,
                 eviction_policy: Optional[pulumi.Input[Union[str, 'EvictionPolicyType']]] = None,
                 frontend_configurations: Optional[pulumi.Input[Sequence[pulumi.Input['FrontendConfigurationArgs']]]] = None,
                 host_group_id: Optional[pulumi.Input[str]] = None,
                 is_spot_vm: Optional[pulumi.Input[bool]] = None,
                 is_stateless: Optional[pulumi.Input[bool]] = None,
                 multiple_placement_groups: Optional[pulumi.Input[bool]] = None,
                 nat_gateway_id: Optional[pulumi.Input[str]] = None,
                 network_security_rules: Optional[pulumi.Input[Sequence[pulumi.Input['NetworkSecurityRuleArgs']]]] = None,
                 node_type_name: Optional[pulumi.Input[str]] = None,
                 placement_properties: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 secure_boot_enabled: Optional[pulumi.Input[bool]] = None,
                 security_type: Optional[pulumi.Input[Union[str, 'SecurityType']]] = None,
                 service_artifact_reference_id: Optional[pulumi.Input[str]] = None,
                 sku: Optional[pulumi.Input['NodeTypeSkuArgs']] = None,
                 spot_restore_timeout: Optional[pulumi.Input[str]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 use_default_public_load_balancer: Optional[pulumi.Input[bool]] = None,
                 use_ephemeral_os_disk: Optional[pulumi.Input[bool]] = None,
                 use_temp_data_disk: Optional[pulumi.Input[bool]] = None,
                 vm_extensions: Optional[pulumi.Input[Sequence[pulumi.Input['VMSSExtensionArgs']]]] = None,
                 vm_image_offer: Optional[pulumi.Input[str]] = None,
                 vm_image_plan: Optional[pulumi.Input['VmImagePlanArgs']] = None,
                 vm_image_publisher: Optional[pulumi.Input[str]] = None,
                 vm_image_resource_id: Optional[pulumi.Input[str]] = None,
                 vm_image_sku: Optional[pulumi.Input[str]] = None,
                 vm_image_version: Optional[pulumi.Input[str]] = None,
                 vm_managed_identity: Optional[pulumi.Input['VmManagedIdentityArgs']] = None,
                 vm_secrets: Optional[pulumi.Input[Sequence[pulumi.Input['VaultSecretGroupArgs']]]] = None,
                 vm_setup_actions: Optional[pulumi.Input[Sequence[pulumi.Input[Union[str, 'VmSetupAction']]]]] = None,
                 vm_shared_gallery_image_id: Optional[pulumi.Input[str]] = None,
                 vm_size: Optional[pulumi.Input[str]] = None,
                 zones: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a NodeType resource.
        :param pulumi.Input[str] cluster_name: The name of the cluster resource.
        :param pulumi.Input[bool] is_primary: Indicates the Service Fabric system services for the cluster will run on this node type. This setting cannot be changed once the node type is created.
        :param pulumi.Input[str] resource_group_name: The name of the resource group.
        :param pulumi.Input[int] vm_instance_count: The number of nodes in the node type. <br /><br />**Values:** <br />-1 - Use when auto scale rules are configured or sku.capacity is defined <br /> 0 - Not supported <br /> >0 - Use for manual scale.
        :param pulumi.Input[Sequence[pulumi.Input['VmssDataDiskArgs']]] additional_data_disks: Additional managed data disks.
        :param pulumi.Input[Sequence[pulumi.Input['AdditionalNetworkInterfaceConfigurationArgs']]] additional_network_interface_configurations: Specifies the settings for any additional secondary network interfaces to attach to the node type.
        :param pulumi.Input['EndpointRangeDescriptionArgs'] application_ports: The range of ports from which cluster assigned port to Service Fabric applications.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] capacities: The capacity tags applied to the nodes in the node type, the cluster resource manager uses these tags to understand how much resource a node has.
        :param pulumi.Input[str] data_disk_letter: Managed data disk letter. It can not use the reserved letter C or D and it can not change after created.
        :param pulumi.Input[int] data_disk_size_gb: Disk size for the managed disk attached to the vms on the node type in GBs.
        :param pulumi.Input[Union[str, 'DiskType']] data_disk_type: Managed data disk type. Specifies the storage account type for the managed disk
        :param pulumi.Input[str] dscp_configuration_id: Specifies the resource id of the DSCP configuration to apply to the node type network interface.
        :param pulumi.Input[bool] enable_accelerated_networking: Specifies whether the network interface is accelerated networking-enabled.
        :param pulumi.Input[bool] enable_encryption_at_host: Enable or disable the Host Encryption for the virtual machines on the node type. This will enable the encryption for all the disks including Resource/Temp disk at host itself. Default: The Encryption at host will be disabled unless this property is set to true for the resource.
        :param pulumi.Input[bool] enable_node_public_ip: Specifies whether each node is allocated its own public IPv4 address. This is only supported on secondary node types with custom Load Balancers.
        :param pulumi.Input[bool] enable_node_public_i_pv6: Specifies whether each node is allocated its own public IPv6 address. This is only supported on secondary node types with custom Load Balancers.
        :param pulumi.Input[bool] enable_over_provisioning: Specifies whether the node type should be overprovisioned. It is only allowed for stateless node types.
        :param pulumi.Input['EndpointRangeDescriptionArgs'] ephemeral_ports: The range of ephemeral ports that nodes in this node type should be configured with.
        :param pulumi.Input[Union[str, 'EvictionPolicyType']] eviction_policy: Specifies the eviction policy for virtual machines in a SPOT node type. Default is Delete.
        :param pulumi.Input[Sequence[pulumi.Input['FrontendConfigurationArgs']]] frontend_configurations: Indicates the node type uses its own frontend configurations instead of the default one for the cluster. This setting can only be specified for non-primary node types and can not be added or removed after the node type is created.
        :param pulumi.Input[str] host_group_id: Specifies the full host group resource Id. This property is used for deploying on azure dedicated hosts.
        :param pulumi.Input[bool] is_spot_vm: Indicates whether the node type will be Spot Virtual Machines. Azure will allocate the VMs if there is capacity available and the VMs can be evicted at any time.
        :param pulumi.Input[bool] is_stateless: Indicates if the node type can only host Stateless workloads.
        :param pulumi.Input[bool] multiple_placement_groups: Indicates if scale set associated with the node type can be composed of multiple placement groups.
        :param pulumi.Input[str] nat_gateway_id: Specifies the resource id of a NAT Gateway to attach to the subnet of this node type. Node type must use custom load balancer.
        :param pulumi.Input[Sequence[pulumi.Input['NetworkSecurityRuleArgs']]] network_security_rules: The Network Security Rules for this node type. This setting can only be specified for node types that are configured with frontend configurations.
        :param pulumi.Input[str] node_type_name: The name of the node type.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] placement_properties: The placement tags applied to nodes in the node type, which can be used to indicate where certain services (workload) should run.
        :param pulumi.Input[bool] secure_boot_enabled: Specifies whether secure boot should be enabled on the nodeType. Can only be used with TrustedLaunch SecurityType
        :param pulumi.Input[Union[str, 'SecurityType']] security_type: Specifies the security type of the nodeType. Only TrustedLaunch is currently supported
        :param pulumi.Input[str] service_artifact_reference_id: Specifies the service artifact reference id used to set same image version for all virtual machines in the scale set when using 'latest' image version.
        :param pulumi.Input['NodeTypeSkuArgs'] sku: The node type sku.
        :param pulumi.Input[str] spot_restore_timeout: Indicates the time duration after which the platform will not try to restore the VMSS SPOT instances specified as ISO 8601.
        :param pulumi.Input[str] subnet_id: Indicates the resource id of the subnet for the node type.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Azure resource tags.
        :param pulumi.Input[bool] use_default_public_load_balancer: Specifies whether the use public load balancer. If not specified and the node type doesn't have its own frontend configuration, it will be attached to the default load balancer. If the node type uses its own Load balancer and useDefaultPublicLoadBalancer is true, then the frontend has to be an Internal Load Balancer. If the node type uses its own Load balancer and useDefaultPublicLoadBalancer is false or not set, then the custom load balancer must include a public load balancer to provide outbound connectivity.
        :param pulumi.Input[bool] use_ephemeral_os_disk: Indicates whether to use ephemeral os disk. The sku selected on the vmSize property needs to support this feature.
        :param pulumi.Input[bool] use_temp_data_disk: Specifies whether to use the temporary disk for the service fabric data root, in which case no managed data disk will be attached and the temporary disk will be used. It is only allowed for stateless node types.
        :param pulumi.Input[Sequence[pulumi.Input['VMSSExtensionArgs']]] vm_extensions: Set of extensions that should be installed onto the virtual machines.
        :param pulumi.Input[str] vm_image_offer: The offer type of the Azure Virtual Machines Marketplace image. For example, UbuntuServer or WindowsServer.
        :param pulumi.Input['VmImagePlanArgs'] vm_image_plan: Specifies information about the marketplace image used to create the virtual machine. This element is only used for marketplace images. Before you can use a marketplace image from an API, you must enable the image for programmatic use. In the Azure portal, find the marketplace image that you want to use and then click Want to deploy programmatically, Get Started ->. Enter any required information and then click Save.
        :param pulumi.Input[str] vm_image_publisher: The publisher of the Azure Virtual Machines Marketplace image. For example, Canonical or MicrosoftWindowsServer.
        :param pulumi.Input[str] vm_image_resource_id: Indicates the resource id of the vm image. This parameter is used for custom vm image.
        :param pulumi.Input[str] vm_image_sku: The SKU of the Azure Virtual Machines Marketplace image. For example, 14.04.0-LTS or 2012-R2-Datacenter.
        :param pulumi.Input[str] vm_image_version: The version of the Azure Virtual Machines Marketplace image. A value of 'latest' can be specified to select the latest version of an image. If omitted, the default is 'latest'.
        :param pulumi.Input['VmManagedIdentityArgs'] vm_managed_identity: Identities to assign to the virtual machine scale set under the node type.
        :param pulumi.Input[Sequence[pulumi.Input['VaultSecretGroupArgs']]] vm_secrets: The secrets to install in the virtual machines.
        :param pulumi.Input[Sequence[pulumi.Input[Union[str, 'VmSetupAction']]]] vm_setup_actions: Specifies the actions to be performed on the vms before bootstrapping the service fabric runtime.
        :param pulumi.Input[str] vm_shared_gallery_image_id: Indicates the resource id of the vm shared galleries image. This parameter is used for custom vm image.
        :param pulumi.Input[str] vm_size: The size of virtual machines in the pool. All virtual machines in a pool are the same size. For example, Standard_D3.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] zones: Specifies the availability zones where the node type would span across. If the cluster is not spanning across availability zones, initiates az migration for the cluster.
        """
        pulumi.set(__self__, "cluster_name", cluster_name)
        pulumi.set(__self__, "is_primary", is_primary)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "vm_instance_count", vm_instance_count)
        if additional_data_disks is not None:
            pulumi.set(__self__, "additional_data_disks", additional_data_disks)
        if additional_network_interface_configurations is not None:
            pulumi.set(__self__, "additional_network_interface_configurations", additional_network_interface_configurations)
        if application_ports is not None:
            pulumi.set(__self__, "application_ports", application_ports)
        if capacities is not None:
            pulumi.set(__self__, "capacities", capacities)
        if data_disk_letter is not None:
            pulumi.set(__self__, "data_disk_letter", data_disk_letter)
        if data_disk_size_gb is not None:
            pulumi.set(__self__, "data_disk_size_gb", data_disk_size_gb)
        if data_disk_type is not None:
            pulumi.set(__self__, "data_disk_type", data_disk_type)
        if dscp_configuration_id is not None:
            pulumi.set(__self__, "dscp_configuration_id", dscp_configuration_id)
        if enable_accelerated_networking is not None:
            pulumi.set(__self__, "enable_accelerated_networking", enable_accelerated_networking)
        if enable_encryption_at_host is None:
            enable_encryption_at_host = False
        if enable_encryption_at_host is not None:
            pulumi.set(__self__, "enable_encryption_at_host", enable_encryption_at_host)
        if enable_node_public_ip is not None:
            pulumi.set(__self__, "enable_node_public_ip", enable_node_public_ip)
        if enable_node_public_i_pv6 is not None:
            pulumi.set(__self__, "enable_node_public_i_pv6", enable_node_public_i_pv6)
        if enable_over_provisioning is not None:
            pulumi.set(__self__, "enable_over_provisioning", enable_over_provisioning)
        if ephemeral_ports is not None:
            pulumi.set(__self__, "ephemeral_ports", ephemeral_ports)
        if eviction_policy is not None:
            pulumi.set(__self__, "eviction_policy", eviction_policy)
        if frontend_configurations is not None:
            pulumi.set(__self__, "frontend_configurations", frontend_configurations)
        if host_group_id is not None:
            pulumi.set(__self__, "host_group_id", host_group_id)
        if is_spot_vm is not None:
            pulumi.set(__self__, "is_spot_vm", is_spot_vm)
        if is_stateless is None:
            is_stateless = False
        if is_stateless is not None:
            pulumi.set(__self__, "is_stateless", is_stateless)
        if multiple_placement_groups is None:
            multiple_placement_groups = False
        if multiple_placement_groups is not None:
            pulumi.set(__self__, "multiple_placement_groups", multiple_placement_groups)
        if nat_gateway_id is not None:
            pulumi.set(__self__, "nat_gateway_id", nat_gateway_id)
        if network_security_rules is not None:
            pulumi.set(__self__, "network_security_rules", network_security_rules)
        if node_type_name is not None:
            pulumi.set(__self__, "node_type_name", node_type_name)
        if placement_properties is not None:
            pulumi.set(__self__, "placement_properties", placement_properties)
        if secure_boot_enabled is not None:
            pulumi.set(__self__, "secure_boot_enabled", secure_boot_enabled)
        if security_type is not None:
            pulumi.set(__self__, "security_type", security_type)
        if service_artifact_reference_id is not None:
            pulumi.set(__self__, "service_artifact_reference_id", service_artifact_reference_id)
        if sku is not None:
            pulumi.set(__self__, "sku", sku)
        if spot_restore_timeout is not None:
            pulumi.set(__self__, "spot_restore_timeout", spot_restore_timeout)
        if subnet_id is not None:
            pulumi.set(__self__, "subnet_id", subnet_id)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if use_default_public_load_balancer is not None:
            pulumi.set(__self__, "use_default_public_load_balancer", use_default_public_load_balancer)
        if use_ephemeral_os_disk is not None:
            pulumi.set(__self__, "use_ephemeral_os_disk", use_ephemeral_os_disk)
        if use_temp_data_disk is not None:
            pulumi.set(__self__, "use_temp_data_disk", use_temp_data_disk)
        if vm_extensions is not None:
            pulumi.set(__self__, "vm_extensions", vm_extensions)
        if vm_image_offer is not None:
            pulumi.set(__self__, "vm_image_offer", vm_image_offer)
        if vm_image_plan is not None:
            pulumi.set(__self__, "vm_image_plan", vm_image_plan)
        if vm_image_publisher is not None:
            pulumi.set(__self__, "vm_image_publisher", vm_image_publisher)
        if vm_image_resource_id is not None:
            pulumi.set(__self__, "vm_image_resource_id", vm_image_resource_id)
        if vm_image_sku is not None:
            pulumi.set(__self__, "vm_image_sku", vm_image_sku)
        if vm_image_version is not None:
            pulumi.set(__self__, "vm_image_version", vm_image_version)
        if vm_managed_identity is not None:
            pulumi.set(__self__, "vm_managed_identity", vm_managed_identity)
        if vm_secrets is not None:
            pulumi.set(__self__, "vm_secrets", vm_secrets)
        if vm_setup_actions is not None:
            pulumi.set(__self__, "vm_setup_actions", vm_setup_actions)
        if vm_shared_gallery_image_id is not None:
            pulumi.set(__self__, "vm_shared_gallery_image_id", vm_shared_gallery_image_id)
        if vm_size is not None:
            pulumi.set(__self__, "vm_size", vm_size)
        if zones is not None:
            pulumi.set(__self__, "zones", zones)

    @property
    @pulumi.getter(name="clusterName")
    def cluster_name(self) -> pulumi.Input[str]:
        """
        The name of the cluster resource.
        """
        return pulumi.get(self, "cluster_name")

    @cluster_name.setter
    def cluster_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "cluster_name", value)

    @property
    @pulumi.getter(name="isPrimary")
    def is_primary(self) -> pulumi.Input[bool]:
        """
        Indicates the Service Fabric system services for the cluster will run on this node type. This setting cannot be changed once the node type is created.
        """
        return pulumi.get(self, "is_primary")

    @is_primary.setter
    def is_primary(self, value: pulumi.Input[bool]):
        pulumi.set(self, "is_primary", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="vmInstanceCount")
    def vm_instance_count(self) -> pulumi.Input[int]:
        """
        The number of nodes in the node type. <br /><br />**Values:** <br />-1 - Use when auto scale rules are configured or sku.capacity is defined <br /> 0 - Not supported <br /> >0 - Use for manual scale.
        """
        return pulumi.get(self, "vm_instance_count")

    @vm_instance_count.setter
    def vm_instance_count(self, value: pulumi.Input[int]):
        pulumi.set(self, "vm_instance_count", value)

    @property
    @pulumi.getter(name="additionalDataDisks")
    def additional_data_disks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VmssDataDiskArgs']]]]:
        """
        Additional managed data disks.
        """
        return pulumi.get(self, "additional_data_disks")

    @additional_data_disks.setter
    def additional_data_disks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VmssDataDiskArgs']]]]):
        pulumi.set(self, "additional_data_disks", value)

    @property
    @pulumi.getter(name="additionalNetworkInterfaceConfigurations")
    def additional_network_interface_configurations(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AdditionalNetworkInterfaceConfigurationArgs']]]]:
        """
        Specifies the settings for any additional secondary network interfaces to attach to the node type.
        """
        return pulumi.get(self, "additional_network_interface_configurations")

    @additional_network_interface_configurations.setter
    def additional_network_interface_configurations(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AdditionalNetworkInterfaceConfigurationArgs']]]]):
        pulumi.set(self, "additional_network_interface_configurations", value)

    @property
    @pulumi.getter(name="applicationPorts")
    def application_ports(self) -> Optional[pulumi.Input['EndpointRangeDescriptionArgs']]:
        """
        The range of ports from which cluster assigned port to Service Fabric applications.
        """
        return pulumi.get(self, "application_ports")

    @application_ports.setter
    def application_ports(self, value: Optional[pulumi.Input['EndpointRangeDescriptionArgs']]):
        pulumi.set(self, "application_ports", value)

    @property
    @pulumi.getter
    def capacities(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        The capacity tags applied to the nodes in the node type, the cluster resource manager uses these tags to understand how much resource a node has.
        """
        return pulumi.get(self, "capacities")

    @capacities.setter
    def capacities(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "capacities", value)

    @property
    @pulumi.getter(name="dataDiskLetter")
    def data_disk_letter(self) -> Optional[pulumi.Input[str]]:
        """
        Managed data disk letter. It can not use the reserved letter C or D and it can not change after created.
        """
        return pulumi.get(self, "data_disk_letter")

    @data_disk_letter.setter
    def data_disk_letter(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "data_disk_letter", value)

    @property
    @pulumi.getter(name="dataDiskSizeGB")
    def data_disk_size_gb(self) -> Optional[pulumi.Input[int]]:
        """
        Disk size for the managed disk attached to the vms on the node type in GBs.
        """
        return pulumi.get(self, "data_disk_size_gb")

    @data_disk_size_gb.setter
    def data_disk_size_gb(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "data_disk_size_gb", value)

    @property
    @pulumi.getter(name="dataDiskType")
    def data_disk_type(self) -> Optional[pulumi.Input[Union[str, 'DiskType']]]:
        """
        Managed data disk type. Specifies the storage account type for the managed disk
        """
        return pulumi.get(self, "data_disk_type")

    @data_disk_type.setter
    def data_disk_type(self, value: Optional[pulumi.Input[Union[str, 'DiskType']]]):
        pulumi.set(self, "data_disk_type", value)

    @property
    @pulumi.getter(name="dscpConfigurationId")
    def dscp_configuration_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the resource id of the DSCP configuration to apply to the node type network interface.
        """
        return pulumi.get(self, "dscp_configuration_id")

    @dscp_configuration_id.setter
    def dscp_configuration_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dscp_configuration_id", value)

    @property
    @pulumi.getter(name="enableAcceleratedNetworking")
    def enable_accelerated_networking(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether the network interface is accelerated networking-enabled.
        """
        return pulumi.get(self, "enable_accelerated_networking")

    @enable_accelerated_networking.setter
    def enable_accelerated_networking(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_accelerated_networking", value)

    @property
    @pulumi.getter(name="enableEncryptionAtHost")
    def enable_encryption_at_host(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable or disable the Host Encryption for the virtual machines on the node type. This will enable the encryption for all the disks including Resource/Temp disk at host itself. Default: The Encryption at host will be disabled unless this property is set to true for the resource.
        """
        return pulumi.get(self, "enable_encryption_at_host")

    @enable_encryption_at_host.setter
    def enable_encryption_at_host(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_encryption_at_host", value)

    @property
    @pulumi.getter(name="enableNodePublicIP")
    def enable_node_public_ip(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether each node is allocated its own public IPv4 address. This is only supported on secondary node types with custom Load Balancers.
        """
        return pulumi.get(self, "enable_node_public_ip")

    @enable_node_public_ip.setter
    def enable_node_public_ip(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_node_public_ip", value)

    @property
    @pulumi.getter(name="enableNodePublicIPv6")
    def enable_node_public_i_pv6(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether each node is allocated its own public IPv6 address. This is only supported on secondary node types with custom Load Balancers.
        """
        return pulumi.get(self, "enable_node_public_i_pv6")

    @enable_node_public_i_pv6.setter
    def enable_node_public_i_pv6(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_node_public_i_pv6", value)

    @property
    @pulumi.getter(name="enableOverProvisioning")
    def enable_over_provisioning(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether the node type should be overprovisioned. It is only allowed for stateless node types.
        """
        return pulumi.get(self, "enable_over_provisioning")

    @enable_over_provisioning.setter
    def enable_over_provisioning(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_over_provisioning", value)

    @property
    @pulumi.getter(name="ephemeralPorts")
    def ephemeral_ports(self) -> Optional[pulumi.Input['EndpointRangeDescriptionArgs']]:
        """
        The range of ephemeral ports that nodes in this node type should be configured with.
        """
        return pulumi.get(self, "ephemeral_ports")

    @ephemeral_ports.setter
    def ephemeral_ports(self, value: Optional[pulumi.Input['EndpointRangeDescriptionArgs']]):
        pulumi.set(self, "ephemeral_ports", value)

    @property
    @pulumi.getter(name="evictionPolicy")
    def eviction_policy(self) -> Optional[pulumi.Input[Union[str, 'EvictionPolicyType']]]:
        """
        Specifies the eviction policy for virtual machines in a SPOT node type. Default is Delete.
        """
        return pulumi.get(self, "eviction_policy")

    @eviction_policy.setter
    def eviction_policy(self, value: Optional[pulumi.Input[Union[str, 'EvictionPolicyType']]]):
        pulumi.set(self, "eviction_policy", value)

    @property
    @pulumi.getter(name="frontendConfigurations")
    def frontend_configurations(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['FrontendConfigurationArgs']]]]:
        """
        Indicates the node type uses its own frontend configurations instead of the default one for the cluster. This setting can only be specified for non-primary node types and can not be added or removed after the node type is created.
        """
        return pulumi.get(self, "frontend_configurations")

    @frontend_configurations.setter
    def frontend_configurations(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['FrontendConfigurationArgs']]]]):
        pulumi.set(self, "frontend_configurations", value)

    @property
    @pulumi.getter(name="hostGroupId")
    def host_group_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the full host group resource Id. This property is used for deploying on azure dedicated hosts.
        """
        return pulumi.get(self, "host_group_id")

    @host_group_id.setter
    def host_group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "host_group_id", value)

    @property
    @pulumi.getter(name="isSpotVM")
    def is_spot_vm(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether the node type will be Spot Virtual Machines. Azure will allocate the VMs if there is capacity available and the VMs can be evicted at any time.
        """
        return pulumi.get(self, "is_spot_vm")

    @is_spot_vm.setter
    def is_spot_vm(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_spot_vm", value)

    @property
    @pulumi.getter(name="isStateless")
    def is_stateless(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates if the node type can only host Stateless workloads.
        """
        return pulumi.get(self, "is_stateless")

    @is_stateless.setter
    def is_stateless(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_stateless", value)

    @property
    @pulumi.getter(name="multiplePlacementGroups")
    def multiple_placement_groups(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates if scale set associated with the node type can be composed of multiple placement groups.
        """
        return pulumi.get(self, "multiple_placement_groups")

    @multiple_placement_groups.setter
    def multiple_placement_groups(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "multiple_placement_groups", value)

    @property
    @pulumi.getter(name="natGatewayId")
    def nat_gateway_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the resource id of a NAT Gateway to attach to the subnet of this node type. Node type must use custom load balancer.
        """
        return pulumi.get(self, "nat_gateway_id")

    @nat_gateway_id.setter
    def nat_gateway_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "nat_gateway_id", value)

    @property
    @pulumi.getter(name="networkSecurityRules")
    def network_security_rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NetworkSecurityRuleArgs']]]]:
        """
        The Network Security Rules for this node type. This setting can only be specified for node types that are configured with frontend configurations.
        """
        return pulumi.get(self, "network_security_rules")

    @network_security_rules.setter
    def network_security_rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NetworkSecurityRuleArgs']]]]):
        pulumi.set(self, "network_security_rules", value)

    @property
    @pulumi.getter(name="nodeTypeName")
    def node_type_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the node type.
        """
        return pulumi.get(self, "node_type_name")

    @node_type_name.setter
    def node_type_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "node_type_name", value)

    @property
    @pulumi.getter(name="placementProperties")
    def placement_properties(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        The placement tags applied to nodes in the node type, which can be used to indicate where certain services (workload) should run.
        """
        return pulumi.get(self, "placement_properties")

    @placement_properties.setter
    def placement_properties(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "placement_properties", value)

    @property
    @pulumi.getter(name="secureBootEnabled")
    def secure_boot_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether secure boot should be enabled on the nodeType. Can only be used with TrustedLaunch SecurityType
        """
        return pulumi.get(self, "secure_boot_enabled")

    @secure_boot_enabled.setter
    def secure_boot_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "secure_boot_enabled", value)

    @property
    @pulumi.getter(name="securityType")
    def security_type(self) -> Optional[pulumi.Input[Union[str, 'SecurityType']]]:
        """
        Specifies the security type of the nodeType. Only TrustedLaunch is currently supported
        """
        return pulumi.get(self, "security_type")

    @security_type.setter
    def security_type(self, value: Optional[pulumi.Input[Union[str, 'SecurityType']]]):
        pulumi.set(self, "security_type", value)

    @property
    @pulumi.getter(name="serviceArtifactReferenceId")
    def service_artifact_reference_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the service artifact reference id used to set same image version for all virtual machines in the scale set when using 'latest' image version.
        """
        return pulumi.get(self, "service_artifact_reference_id")

    @service_artifact_reference_id.setter
    def service_artifact_reference_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_artifact_reference_id", value)

    @property
    @pulumi.getter
    def sku(self) -> Optional[pulumi.Input['NodeTypeSkuArgs']]:
        """
        The node type sku.
        """
        return pulumi.get(self, "sku")

    @sku.setter
    def sku(self, value: Optional[pulumi.Input['NodeTypeSkuArgs']]):
        pulumi.set(self, "sku", value)

    @property
    @pulumi.getter(name="spotRestoreTimeout")
    def spot_restore_timeout(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates the time duration after which the platform will not try to restore the VMSS SPOT instances specified as ISO 8601.
        """
        return pulumi.get(self, "spot_restore_timeout")

    @spot_restore_timeout.setter
    def spot_restore_timeout(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "spot_restore_timeout", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates the resource id of the subnet for the node type.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Azure resource tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="useDefaultPublicLoadBalancer")
    def use_default_public_load_balancer(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether the use public load balancer. If not specified and the node type doesn't have its own frontend configuration, it will be attached to the default load balancer. If the node type uses its own Load balancer and useDefaultPublicLoadBalancer is true, then the frontend has to be an Internal Load Balancer. If the node type uses its own Load balancer and useDefaultPublicLoadBalancer is false or not set, then the custom load balancer must include a public load balancer to provide outbound connectivity.
        """
        return pulumi.get(self, "use_default_public_load_balancer")

    @use_default_public_load_balancer.setter
    def use_default_public_load_balancer(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "use_default_public_load_balancer", value)

    @property
    @pulumi.getter(name="useEphemeralOSDisk")
    def use_ephemeral_os_disk(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether to use ephemeral os disk. The sku selected on the vmSize property needs to support this feature.
        """
        return pulumi.get(self, "use_ephemeral_os_disk")

    @use_ephemeral_os_disk.setter
    def use_ephemeral_os_disk(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "use_ephemeral_os_disk", value)

    @property
    @pulumi.getter(name="useTempDataDisk")
    def use_temp_data_disk(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether to use the temporary disk for the service fabric data root, in which case no managed data disk will be attached and the temporary disk will be used. It is only allowed for stateless node types.
        """
        return pulumi.get(self, "use_temp_data_disk")

    @use_temp_data_disk.setter
    def use_temp_data_disk(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "use_temp_data_disk", value)

    @property
    @pulumi.getter(name="vmExtensions")
    def vm_extensions(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VMSSExtensionArgs']]]]:
        """
        Set of extensions that should be installed onto the virtual machines.
        """
        return pulumi.get(self, "vm_extensions")

    @vm_extensions.setter
    def vm_extensions(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VMSSExtensionArgs']]]]):
        pulumi.set(self, "vm_extensions", value)

    @property
    @pulumi.getter(name="vmImageOffer")
    def vm_image_offer(self) -> Optional[pulumi.Input[str]]:
        """
        The offer type of the Azure Virtual Machines Marketplace image. For example, UbuntuServer or WindowsServer.
        """
        return pulumi.get(self, "vm_image_offer")

    @vm_image_offer.setter
    def vm_image_offer(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vm_image_offer", value)

    @property
    @pulumi.getter(name="vmImagePlan")
    def vm_image_plan(self) -> Optional[pulumi.Input['VmImagePlanArgs']]:
        """
        Specifies information about the marketplace image used to create the virtual machine. This element is only used for marketplace images. Before you can use a marketplace image from an API, you must enable the image for programmatic use. In the Azure portal, find the marketplace image that you want to use and then click Want to deploy programmatically, Get Started ->. Enter any required information and then click Save.
        """
        return pulumi.get(self, "vm_image_plan")

    @vm_image_plan.setter
    def vm_image_plan(self, value: Optional[pulumi.Input['VmImagePlanArgs']]):
        pulumi.set(self, "vm_image_plan", value)

    @property
    @pulumi.getter(name="vmImagePublisher")
    def vm_image_publisher(self) -> Optional[pulumi.Input[str]]:
        """
        The publisher of the Azure Virtual Machines Marketplace image. For example, Canonical or MicrosoftWindowsServer.
        """
        return pulumi.get(self, "vm_image_publisher")

    @vm_image_publisher.setter
    def vm_image_publisher(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vm_image_publisher", value)

    @property
    @pulumi.getter(name="vmImageResourceId")
    def vm_image_resource_id(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates the resource id of the vm image. This parameter is used for custom vm image.
        """
        return pulumi.get(self, "vm_image_resource_id")

    @vm_image_resource_id.setter
    def vm_image_resource_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vm_image_resource_id", value)

    @property
    @pulumi.getter(name="vmImageSku")
    def vm_image_sku(self) -> Optional[pulumi.Input[str]]:
        """
        The SKU of the Azure Virtual Machines Marketplace image. For example, 14.04.0-LTS or 2012-R2-Datacenter.
        """
        return pulumi.get(self, "vm_image_sku")

    @vm_image_sku.setter
    def vm_image_sku(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vm_image_sku", value)

    @property
    @pulumi.getter(name="vmImageVersion")
    def vm_image_version(self) -> Optional[pulumi.Input[str]]:
        """
        The version of the Azure Virtual Machines Marketplace image. A value of 'latest' can be specified to select the latest version of an image. If omitted, the default is 'latest'.
        """
        return pulumi.get(self, "vm_image_version")

    @vm_image_version.setter
    def vm_image_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vm_image_version", value)

    @property
    @pulumi.getter(name="vmManagedIdentity")
    def vm_managed_identity(self) -> Optional[pulumi.Input['VmManagedIdentityArgs']]:
        """
        Identities to assign to the virtual machine scale set under the node type.
        """
        return pulumi.get(self, "vm_managed_identity")

    @vm_managed_identity.setter
    def vm_managed_identity(self, value: Optional[pulumi.Input['VmManagedIdentityArgs']]):
        pulumi.set(self, "vm_managed_identity", value)

    @property
    @pulumi.getter(name="vmSecrets")
    def vm_secrets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VaultSecretGroupArgs']]]]:
        """
        The secrets to install in the virtual machines.
        """
        return pulumi.get(self, "vm_secrets")

    @vm_secrets.setter
    def vm_secrets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VaultSecretGroupArgs']]]]):
        pulumi.set(self, "vm_secrets", value)

    @property
    @pulumi.getter(name="vmSetupActions")
    def vm_setup_actions(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[Union[str, 'VmSetupAction']]]]]:
        """
        Specifies the actions to be performed on the vms before bootstrapping the service fabric runtime.
        """
        return pulumi.get(self, "vm_setup_actions")

    @vm_setup_actions.setter
    def vm_setup_actions(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[Union[str, 'VmSetupAction']]]]]):
        pulumi.set(self, "vm_setup_actions", value)

    @property
    @pulumi.getter(name="vmSharedGalleryImageId")
    def vm_shared_gallery_image_id(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates the resource id of the vm shared galleries image. This parameter is used for custom vm image.
        """
        return pulumi.get(self, "vm_shared_gallery_image_id")

    @vm_shared_gallery_image_id.setter
    def vm_shared_gallery_image_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vm_shared_gallery_image_id", value)

    @property
    @pulumi.getter(name="vmSize")
    def vm_size(self) -> Optional[pulumi.Input[str]]:
        """
        The size of virtual machines in the pool. All virtual machines in a pool are the same size. For example, Standard_D3.
        """
        return pulumi.get(self, "vm_size")

    @vm_size.setter
    def vm_size(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vm_size", value)

    @property
    @pulumi.getter
    def zones(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Specifies the availability zones where the node type would span across. If the cluster is not spanning across availability zones, initiates az migration for the cluster.
        """
        return pulumi.get(self, "zones")

    @zones.setter
    def zones(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "zones", value)


class NodeType(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 additional_data_disks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VmssDataDiskArgs']]]]] = None,
                 additional_network_interface_configurations: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AdditionalNetworkInterfaceConfigurationArgs']]]]] = None,
                 application_ports: Optional[pulumi.Input[pulumi.InputType['EndpointRangeDescriptionArgs']]] = None,
                 capacities: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 cluster_name: Optional[pulumi.Input[str]] = None,
                 data_disk_letter: Optional[pulumi.Input[str]] = None,
                 data_disk_size_gb: Optional[pulumi.Input[int]] = None,
                 data_disk_type: Optional[pulumi.Input[Union[str, 'DiskType']]] = None,
                 dscp_configuration_id: Optional[pulumi.Input[str]] = None,
                 enable_accelerated_networking: Optional[pulumi.Input[bool]] = None,
                 enable_encryption_at_host: Optional[pulumi.Input[bool]] = None,
                 enable_node_public_ip: Optional[pulumi.Input[bool]] = None,
                 enable_node_public_i_pv6: Optional[pulumi.Input[bool]] = None,
                 enable_over_provisioning: Optional[pulumi.Input[bool]] = None,
                 ephemeral_ports: Optional[pulumi.Input[pulumi.InputType['EndpointRangeDescriptionArgs']]] = None,
                 eviction_policy: Optional[pulumi.Input[Union[str, 'EvictionPolicyType']]] = None,
                 frontend_configurations: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['FrontendConfigurationArgs']]]]] = None,
                 host_group_id: Optional[pulumi.Input[str]] = None,
                 is_primary: Optional[pulumi.Input[bool]] = None,
                 is_spot_vm: Optional[pulumi.Input[bool]] = None,
                 is_stateless: Optional[pulumi.Input[bool]] = None,
                 multiple_placement_groups: Optional[pulumi.Input[bool]] = None,
                 nat_gateway_id: Optional[pulumi.Input[str]] = None,
                 network_security_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NetworkSecurityRuleArgs']]]]] = None,
                 node_type_name: Optional[pulumi.Input[str]] = None,
                 placement_properties: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 secure_boot_enabled: Optional[pulumi.Input[bool]] = None,
                 security_type: Optional[pulumi.Input[Union[str, 'SecurityType']]] = None,
                 service_artifact_reference_id: Optional[pulumi.Input[str]] = None,
                 sku: Optional[pulumi.Input[pulumi.InputType['NodeTypeSkuArgs']]] = None,
                 spot_restore_timeout: Optional[pulumi.Input[str]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 use_default_public_load_balancer: Optional[pulumi.Input[bool]] = None,
                 use_ephemeral_os_disk: Optional[pulumi.Input[bool]] = None,
                 use_temp_data_disk: Optional[pulumi.Input[bool]] = None,
                 vm_extensions: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VMSSExtensionArgs']]]]] = None,
                 vm_image_offer: Optional[pulumi.Input[str]] = None,
                 vm_image_plan: Optional[pulumi.Input[pulumi.InputType['VmImagePlanArgs']]] = None,
                 vm_image_publisher: Optional[pulumi.Input[str]] = None,
                 vm_image_resource_id: Optional[pulumi.Input[str]] = None,
                 vm_image_sku: Optional[pulumi.Input[str]] = None,
                 vm_image_version: Optional[pulumi.Input[str]] = None,
                 vm_instance_count: Optional[pulumi.Input[int]] = None,
                 vm_managed_identity: Optional[pulumi.Input[pulumi.InputType['VmManagedIdentityArgs']]] = None,
                 vm_secrets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VaultSecretGroupArgs']]]]] = None,
                 vm_setup_actions: Optional[pulumi.Input[Sequence[pulumi.Input[Union[str, 'VmSetupAction']]]]] = None,
                 vm_shared_gallery_image_id: Optional[pulumi.Input[str]] = None,
                 vm_size: Optional[pulumi.Input[str]] = None,
                 zones: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Describes a node type in the cluster, each node type represents sub set of nodes in the cluster.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VmssDataDiskArgs']]]] additional_data_disks: Additional managed data disks.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AdditionalNetworkInterfaceConfigurationArgs']]]] additional_network_interface_configurations: Specifies the settings for any additional secondary network interfaces to attach to the node type.
        :param pulumi.Input[pulumi.InputType['EndpointRangeDescriptionArgs']] application_ports: The range of ports from which cluster assigned port to Service Fabric applications.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] capacities: The capacity tags applied to the nodes in the node type, the cluster resource manager uses these tags to understand how much resource a node has.
        :param pulumi.Input[str] cluster_name: The name of the cluster resource.
        :param pulumi.Input[str] data_disk_letter: Managed data disk letter. It can not use the reserved letter C or D and it can not change after created.
        :param pulumi.Input[int] data_disk_size_gb: Disk size for the managed disk attached to the vms on the node type in GBs.
        :param pulumi.Input[Union[str, 'DiskType']] data_disk_type: Managed data disk type. Specifies the storage account type for the managed disk
        :param pulumi.Input[str] dscp_configuration_id: Specifies the resource id of the DSCP configuration to apply to the node type network interface.
        :param pulumi.Input[bool] enable_accelerated_networking: Specifies whether the network interface is accelerated networking-enabled.
        :param pulumi.Input[bool] enable_encryption_at_host: Enable or disable the Host Encryption for the virtual machines on the node type. This will enable the encryption for all the disks including Resource/Temp disk at host itself. Default: The Encryption at host will be disabled unless this property is set to true for the resource.
        :param pulumi.Input[bool] enable_node_public_ip: Specifies whether each node is allocated its own public IPv4 address. This is only supported on secondary node types with custom Load Balancers.
        :param pulumi.Input[bool] enable_node_public_i_pv6: Specifies whether each node is allocated its own public IPv6 address. This is only supported on secondary node types with custom Load Balancers.
        :param pulumi.Input[bool] enable_over_provisioning: Specifies whether the node type should be overprovisioned. It is only allowed for stateless node types.
        :param pulumi.Input[pulumi.InputType['EndpointRangeDescriptionArgs']] ephemeral_ports: The range of ephemeral ports that nodes in this node type should be configured with.
        :param pulumi.Input[Union[str, 'EvictionPolicyType']] eviction_policy: Specifies the eviction policy for virtual machines in a SPOT node type. Default is Delete.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['FrontendConfigurationArgs']]]] frontend_configurations: Indicates the node type uses its own frontend configurations instead of the default one for the cluster. This setting can only be specified for non-primary node types and can not be added or removed after the node type is created.
        :param pulumi.Input[str] host_group_id: Specifies the full host group resource Id. This property is used for deploying on azure dedicated hosts.
        :param pulumi.Input[bool] is_primary: Indicates the Service Fabric system services for the cluster will run on this node type. This setting cannot be changed once the node type is created.
        :param pulumi.Input[bool] is_spot_vm: Indicates whether the node type will be Spot Virtual Machines. Azure will allocate the VMs if there is capacity available and the VMs can be evicted at any time.
        :param pulumi.Input[bool] is_stateless: Indicates if the node type can only host Stateless workloads.
        :param pulumi.Input[bool] multiple_placement_groups: Indicates if scale set associated with the node type can be composed of multiple placement groups.
        :param pulumi.Input[str] nat_gateway_id: Specifies the resource id of a NAT Gateway to attach to the subnet of this node type. Node type must use custom load balancer.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NetworkSecurityRuleArgs']]]] network_security_rules: The Network Security Rules for this node type. This setting can only be specified for node types that are configured with frontend configurations.
        :param pulumi.Input[str] node_type_name: The name of the node type.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] placement_properties: The placement tags applied to nodes in the node type, which can be used to indicate where certain services (workload) should run.
        :param pulumi.Input[str] resource_group_name: The name of the resource group.
        :param pulumi.Input[bool] secure_boot_enabled: Specifies whether secure boot should be enabled on the nodeType. Can only be used with TrustedLaunch SecurityType
        :param pulumi.Input[Union[str, 'SecurityType']] security_type: Specifies the security type of the nodeType. Only TrustedLaunch is currently supported
        :param pulumi.Input[str] service_artifact_reference_id: Specifies the service artifact reference id used to set same image version for all virtual machines in the scale set when using 'latest' image version.
        :param pulumi.Input[pulumi.InputType['NodeTypeSkuArgs']] sku: The node type sku.
        :param pulumi.Input[str] spot_restore_timeout: Indicates the time duration after which the platform will not try to restore the VMSS SPOT instances specified as ISO 8601.
        :param pulumi.Input[str] subnet_id: Indicates the resource id of the subnet for the node type.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Azure resource tags.
        :param pulumi.Input[bool] use_default_public_load_balancer: Specifies whether the use public load balancer. If not specified and the node type doesn't have its own frontend configuration, it will be attached to the default load balancer. If the node type uses its own Load balancer and useDefaultPublicLoadBalancer is true, then the frontend has to be an Internal Load Balancer. If the node type uses its own Load balancer and useDefaultPublicLoadBalancer is false or not set, then the custom load balancer must include a public load balancer to provide outbound connectivity.
        :param pulumi.Input[bool] use_ephemeral_os_disk: Indicates whether to use ephemeral os disk. The sku selected on the vmSize property needs to support this feature.
        :param pulumi.Input[bool] use_temp_data_disk: Specifies whether to use the temporary disk for the service fabric data root, in which case no managed data disk will be attached and the temporary disk will be used. It is only allowed for stateless node types.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VMSSExtensionArgs']]]] vm_extensions: Set of extensions that should be installed onto the virtual machines.
        :param pulumi.Input[str] vm_image_offer: The offer type of the Azure Virtual Machines Marketplace image. For example, UbuntuServer or WindowsServer.
        :param pulumi.Input[pulumi.InputType['VmImagePlanArgs']] vm_image_plan: Specifies information about the marketplace image used to create the virtual machine. This element is only used for marketplace images. Before you can use a marketplace image from an API, you must enable the image for programmatic use. In the Azure portal, find the marketplace image that you want to use and then click Want to deploy programmatically, Get Started ->. Enter any required information and then click Save.
        :param pulumi.Input[str] vm_image_publisher: The publisher of the Azure Virtual Machines Marketplace image. For example, Canonical or MicrosoftWindowsServer.
        :param pulumi.Input[str] vm_image_resource_id: Indicates the resource id of the vm image. This parameter is used for custom vm image.
        :param pulumi.Input[str] vm_image_sku: The SKU of the Azure Virtual Machines Marketplace image. For example, 14.04.0-LTS or 2012-R2-Datacenter.
        :param pulumi.Input[str] vm_image_version: The version of the Azure Virtual Machines Marketplace image. A value of 'latest' can be specified to select the latest version of an image. If omitted, the default is 'latest'.
        :param pulumi.Input[int] vm_instance_count: The number of nodes in the node type. <br /><br />**Values:** <br />-1 - Use when auto scale rules are configured or sku.capacity is defined <br /> 0 - Not supported <br /> >0 - Use for manual scale.
        :param pulumi.Input[pulumi.InputType['VmManagedIdentityArgs']] vm_managed_identity: Identities to assign to the virtual machine scale set under the node type.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VaultSecretGroupArgs']]]] vm_secrets: The secrets to install in the virtual machines.
        :param pulumi.Input[Sequence[pulumi.Input[Union[str, 'VmSetupAction']]]] vm_setup_actions: Specifies the actions to be performed on the vms before bootstrapping the service fabric runtime.
        :param pulumi.Input[str] vm_shared_gallery_image_id: Indicates the resource id of the vm shared galleries image. This parameter is used for custom vm image.
        :param pulumi.Input[str] vm_size: The size of virtual machines in the pool. All virtual machines in a pool are the same size. For example, Standard_D3.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] zones: Specifies the availability zones where the node type would span across. If the cluster is not spanning across availability zones, initiates az migration for the cluster.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NodeTypeArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Describes a node type in the cluster, each node type represents sub set of nodes in the cluster.

        :param str resource_name: The name of the resource.
        :param NodeTypeArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NodeTypeArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 additional_data_disks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VmssDataDiskArgs']]]]] = None,
                 additional_network_interface_configurations: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AdditionalNetworkInterfaceConfigurationArgs']]]]] = None,
                 application_ports: Optional[pulumi.Input[pulumi.InputType['EndpointRangeDescriptionArgs']]] = None,
                 capacities: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 cluster_name: Optional[pulumi.Input[str]] = None,
                 data_disk_letter: Optional[pulumi.Input[str]] = None,
                 data_disk_size_gb: Optional[pulumi.Input[int]] = None,
                 data_disk_type: Optional[pulumi.Input[Union[str, 'DiskType']]] = None,
                 dscp_configuration_id: Optional[pulumi.Input[str]] = None,
                 enable_accelerated_networking: Optional[pulumi.Input[bool]] = None,
                 enable_encryption_at_host: Optional[pulumi.Input[bool]] = None,
                 enable_node_public_ip: Optional[pulumi.Input[bool]] = None,
                 enable_node_public_i_pv6: Optional[pulumi.Input[bool]] = None,
                 enable_over_provisioning: Optional[pulumi.Input[bool]] = None,
                 ephemeral_ports: Optional[pulumi.Input[pulumi.InputType['EndpointRangeDescriptionArgs']]] = None,
                 eviction_policy: Optional[pulumi.Input[Union[str, 'EvictionPolicyType']]] = None,
                 frontend_configurations: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['FrontendConfigurationArgs']]]]] = None,
                 host_group_id: Optional[pulumi.Input[str]] = None,
                 is_primary: Optional[pulumi.Input[bool]] = None,
                 is_spot_vm: Optional[pulumi.Input[bool]] = None,
                 is_stateless: Optional[pulumi.Input[bool]] = None,
                 multiple_placement_groups: Optional[pulumi.Input[bool]] = None,
                 nat_gateway_id: Optional[pulumi.Input[str]] = None,
                 network_security_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NetworkSecurityRuleArgs']]]]] = None,
                 node_type_name: Optional[pulumi.Input[str]] = None,
                 placement_properties: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 secure_boot_enabled: Optional[pulumi.Input[bool]] = None,
                 security_type: Optional[pulumi.Input[Union[str, 'SecurityType']]] = None,
                 service_artifact_reference_id: Optional[pulumi.Input[str]] = None,
                 sku: Optional[pulumi.Input[pulumi.InputType['NodeTypeSkuArgs']]] = None,
                 spot_restore_timeout: Optional[pulumi.Input[str]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 use_default_public_load_balancer: Optional[pulumi.Input[bool]] = None,
                 use_ephemeral_os_disk: Optional[pulumi.Input[bool]] = None,
                 use_temp_data_disk: Optional[pulumi.Input[bool]] = None,
                 vm_extensions: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VMSSExtensionArgs']]]]] = None,
                 vm_image_offer: Optional[pulumi.Input[str]] = None,
                 vm_image_plan: Optional[pulumi.Input[pulumi.InputType['VmImagePlanArgs']]] = None,
                 vm_image_publisher: Optional[pulumi.Input[str]] = None,
                 vm_image_resource_id: Optional[pulumi.Input[str]] = None,
                 vm_image_sku: Optional[pulumi.Input[str]] = None,
                 vm_image_version: Optional[pulumi.Input[str]] = None,
                 vm_instance_count: Optional[pulumi.Input[int]] = None,
                 vm_managed_identity: Optional[pulumi.Input[pulumi.InputType['VmManagedIdentityArgs']]] = None,
                 vm_secrets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VaultSecretGroupArgs']]]]] = None,
                 vm_setup_actions: Optional[pulumi.Input[Sequence[pulumi.Input[Union[str, 'VmSetupAction']]]]] = None,
                 vm_shared_gallery_image_id: Optional[pulumi.Input[str]] = None,
                 vm_size: Optional[pulumi.Input[str]] = None,
                 zones: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NodeTypeArgs.__new__(NodeTypeArgs)

            __props__.__dict__["additional_data_disks"] = additional_data_disks
            __props__.__dict__["additional_network_interface_configurations"] = additional_network_interface_configurations
            __props__.__dict__["application_ports"] = application_ports
            __props__.__dict__["capacities"] = capacities
            if cluster_name is None and not opts.urn:
                raise TypeError("Missing required property 'cluster_name'")
            __props__.__dict__["cluster_name"] = cluster_name
            __props__.__dict__["data_disk_letter"] = data_disk_letter
            __props__.__dict__["data_disk_size_gb"] = data_disk_size_gb
            __props__.__dict__["data_disk_type"] = data_disk_type
            __props__.__dict__["dscp_configuration_id"] = dscp_configuration_id
            __props__.__dict__["enable_accelerated_networking"] = enable_accelerated_networking
            if enable_encryption_at_host is None:
                enable_encryption_at_host = False
            __props__.__dict__["enable_encryption_at_host"] = enable_encryption_at_host
            __props__.__dict__["enable_node_public_ip"] = enable_node_public_ip
            __props__.__dict__["enable_node_public_i_pv6"] = enable_node_public_i_pv6
            __props__.__dict__["enable_over_provisioning"] = enable_over_provisioning
            __props__.__dict__["ephemeral_ports"] = ephemeral_ports
            __props__.__dict__["eviction_policy"] = eviction_policy
            __props__.__dict__["frontend_configurations"] = frontend_configurations
            __props__.__dict__["host_group_id"] = host_group_id
            if is_primary is None and not opts.urn:
                raise TypeError("Missing required property 'is_primary'")
            __props__.__dict__["is_primary"] = is_primary
            __props__.__dict__["is_spot_vm"] = is_spot_vm
            if is_stateless is None:
                is_stateless = False
            __props__.__dict__["is_stateless"] = is_stateless
            if multiple_placement_groups is None:
                multiple_placement_groups = False
            __props__.__dict__["multiple_placement_groups"] = multiple_placement_groups
            __props__.__dict__["nat_gateway_id"] = nat_gateway_id
            __props__.__dict__["network_security_rules"] = network_security_rules
            __props__.__dict__["node_type_name"] = node_type_name
            __props__.__dict__["placement_properties"] = placement_properties
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["secure_boot_enabled"] = secure_boot_enabled
            __props__.__dict__["security_type"] = security_type
            __props__.__dict__["service_artifact_reference_id"] = service_artifact_reference_id
            __props__.__dict__["sku"] = sku
            __props__.__dict__["spot_restore_timeout"] = spot_restore_timeout
            __props__.__dict__["subnet_id"] = subnet_id
            __props__.__dict__["tags"] = tags
            __props__.__dict__["use_default_public_load_balancer"] = use_default_public_load_balancer
            __props__.__dict__["use_ephemeral_os_disk"] = use_ephemeral_os_disk
            __props__.__dict__["use_temp_data_disk"] = use_temp_data_disk
            __props__.__dict__["vm_extensions"] = vm_extensions
            __props__.__dict__["vm_image_offer"] = vm_image_offer
            __props__.__dict__["vm_image_plan"] = vm_image_plan
            __props__.__dict__["vm_image_publisher"] = vm_image_publisher
            __props__.__dict__["vm_image_resource_id"] = vm_image_resource_id
            __props__.__dict__["vm_image_sku"] = vm_image_sku
            __props__.__dict__["vm_image_version"] = vm_image_version
            if vm_instance_count is None and not opts.urn:
                raise TypeError("Missing required property 'vm_instance_count'")
            __props__.__dict__["vm_instance_count"] = vm_instance_count
            __props__.__dict__["vm_managed_identity"] = vm_managed_identity
            __props__.__dict__["vm_secrets"] = vm_secrets
            __props__.__dict__["vm_setup_actions"] = vm_setup_actions
            __props__.__dict__["vm_shared_gallery_image_id"] = vm_shared_gallery_image_id
            __props__.__dict__["vm_size"] = vm_size
            __props__.__dict__["zones"] = zones
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:servicefabric:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20200101preview:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20210101preview:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20210501:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20210701preview:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20210901privatepreview:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20211101preview:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20220101:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20220201preview:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20220601preview:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20220801preview:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20221001preview:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20230201preview:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20230301preview:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20230701preview:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20230901preview:NodeType"), pulumi.Alias(type_="azure-native:servicefabric/v20231101preview:NodeType")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(NodeType, __self__).__init__(
            'azure-native:servicefabric/v20231201preview:NodeType',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'NodeType':
        """
        Get an existing NodeType resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = NodeTypeArgs.__new__(NodeTypeArgs)

        __props__.__dict__["additional_data_disks"] = None
        __props__.__dict__["additional_network_interface_configurations"] = None
        __props__.__dict__["application_ports"] = None
        __props__.__dict__["capacities"] = None
        __props__.__dict__["data_disk_letter"] = None
        __props__.__dict__["data_disk_size_gb"] = None
        __props__.__dict__["data_disk_type"] = None
        __props__.__dict__["dscp_configuration_id"] = None
        __props__.__dict__["enable_accelerated_networking"] = None
        __props__.__dict__["enable_encryption_at_host"] = None
        __props__.__dict__["enable_node_public_ip"] = None
        __props__.__dict__["enable_node_public_i_pv6"] = None
        __props__.__dict__["enable_over_provisioning"] = None
        __props__.__dict__["ephemeral_ports"] = None
        __props__.__dict__["eviction_policy"] = None
        __props__.__dict__["frontend_configurations"] = None
        __props__.__dict__["host_group_id"] = None
        __props__.__dict__["is_primary"] = None
        __props__.__dict__["is_spot_vm"] = None
        __props__.__dict__["is_stateless"] = None
        __props__.__dict__["multiple_placement_groups"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["nat_gateway_id"] = None
        __props__.__dict__["network_security_rules"] = None
        __props__.__dict__["placement_properties"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["secure_boot_enabled"] = None
        __props__.__dict__["security_type"] = None
        __props__.__dict__["service_artifact_reference_id"] = None
        __props__.__dict__["sku"] = None
        __props__.__dict__["spot_restore_timeout"] = None
        __props__.__dict__["subnet_id"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        __props__.__dict__["use_default_public_load_balancer"] = None
        __props__.__dict__["use_ephemeral_os_disk"] = None
        __props__.__dict__["use_temp_data_disk"] = None
        __props__.__dict__["vm_extensions"] = None
        __props__.__dict__["vm_image_offer"] = None
        __props__.__dict__["vm_image_plan"] = None
        __props__.__dict__["vm_image_publisher"] = None
        __props__.__dict__["vm_image_resource_id"] = None
        __props__.__dict__["vm_image_sku"] = None
        __props__.__dict__["vm_image_version"] = None
        __props__.__dict__["vm_instance_count"] = None
        __props__.__dict__["vm_managed_identity"] = None
        __props__.__dict__["vm_secrets"] = None
        __props__.__dict__["vm_setup_actions"] = None
        __props__.__dict__["vm_shared_gallery_image_id"] = None
        __props__.__dict__["vm_size"] = None
        __props__.__dict__["zones"] = None
        return NodeType(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="additionalDataDisks")
    def additional_data_disks(self) -> pulumi.Output[Optional[Sequence['outputs.VmssDataDiskResponse']]]:
        """
        Additional managed data disks.
        """
        return pulumi.get(self, "additional_data_disks")

    @property
    @pulumi.getter(name="additionalNetworkInterfaceConfigurations")
    def additional_network_interface_configurations(self) -> pulumi.Output[Optional[Sequence['outputs.AdditionalNetworkInterfaceConfigurationResponse']]]:
        """
        Specifies the settings for any additional secondary network interfaces to attach to the node type.
        """
        return pulumi.get(self, "additional_network_interface_configurations")

    @property
    @pulumi.getter(name="applicationPorts")
    def application_ports(self) -> pulumi.Output[Optional['outputs.EndpointRangeDescriptionResponse']]:
        """
        The range of ports from which cluster assigned port to Service Fabric applications.
        """
        return pulumi.get(self, "application_ports")

    @property
    @pulumi.getter
    def capacities(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        The capacity tags applied to the nodes in the node type, the cluster resource manager uses these tags to understand how much resource a node has.
        """
        return pulumi.get(self, "capacities")

    @property
    @pulumi.getter(name="dataDiskLetter")
    def data_disk_letter(self) -> pulumi.Output[Optional[str]]:
        """
        Managed data disk letter. It can not use the reserved letter C or D and it can not change after created.
        """
        return pulumi.get(self, "data_disk_letter")

    @property
    @pulumi.getter(name="dataDiskSizeGB")
    def data_disk_size_gb(self) -> pulumi.Output[Optional[int]]:
        """
        Disk size for the managed disk attached to the vms on the node type in GBs.
        """
        return pulumi.get(self, "data_disk_size_gb")

    @property
    @pulumi.getter(name="dataDiskType")
    def data_disk_type(self) -> pulumi.Output[Optional[str]]:
        """
        Managed data disk type. Specifies the storage account type for the managed disk
        """
        return pulumi.get(self, "data_disk_type")

    @property
    @pulumi.getter(name="dscpConfigurationId")
    def dscp_configuration_id(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the resource id of the DSCP configuration to apply to the node type network interface.
        """
        return pulumi.get(self, "dscp_configuration_id")

    @property
    @pulumi.getter(name="enableAcceleratedNetworking")
    def enable_accelerated_networking(self) -> pulumi.Output[Optional[bool]]:
        """
        Specifies whether the network interface is accelerated networking-enabled.
        """
        return pulumi.get(self, "enable_accelerated_networking")

    @property
    @pulumi.getter(name="enableEncryptionAtHost")
    def enable_encryption_at_host(self) -> pulumi.Output[Optional[bool]]:
        """
        Enable or disable the Host Encryption for the virtual machines on the node type. This will enable the encryption for all the disks including Resource/Temp disk at host itself. Default: The Encryption at host will be disabled unless this property is set to true for the resource.
        """
        return pulumi.get(self, "enable_encryption_at_host")

    @property
    @pulumi.getter(name="enableNodePublicIP")
    def enable_node_public_ip(self) -> pulumi.Output[Optional[bool]]:
        """
        Specifies whether each node is allocated its own public IPv4 address. This is only supported on secondary node types with custom Load Balancers.
        """
        return pulumi.get(self, "enable_node_public_ip")

    @property
    @pulumi.getter(name="enableNodePublicIPv6")
    def enable_node_public_i_pv6(self) -> pulumi.Output[Optional[bool]]:
        """
        Specifies whether each node is allocated its own public IPv6 address. This is only supported on secondary node types with custom Load Balancers.
        """
        return pulumi.get(self, "enable_node_public_i_pv6")

    @property
    @pulumi.getter(name="enableOverProvisioning")
    def enable_over_provisioning(self) -> pulumi.Output[Optional[bool]]:
        """
        Specifies whether the node type should be overprovisioned. It is only allowed for stateless node types.
        """
        return pulumi.get(self, "enable_over_provisioning")

    @property
    @pulumi.getter(name="ephemeralPorts")
    def ephemeral_ports(self) -> pulumi.Output[Optional['outputs.EndpointRangeDescriptionResponse']]:
        """
        The range of ephemeral ports that nodes in this node type should be configured with.
        """
        return pulumi.get(self, "ephemeral_ports")

    @property
    @pulumi.getter(name="evictionPolicy")
    def eviction_policy(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the eviction policy for virtual machines in a SPOT node type. Default is Delete.
        """
        return pulumi.get(self, "eviction_policy")

    @property
    @pulumi.getter(name="frontendConfigurations")
    def frontend_configurations(self) -> pulumi.Output[Optional[Sequence['outputs.FrontendConfigurationResponse']]]:
        """
        Indicates the node type uses its own frontend configurations instead of the default one for the cluster. This setting can only be specified for non-primary node types and can not be added or removed after the node type is created.
        """
        return pulumi.get(self, "frontend_configurations")

    @property
    @pulumi.getter(name="hostGroupId")
    def host_group_id(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the full host group resource Id. This property is used for deploying on azure dedicated hosts.
        """
        return pulumi.get(self, "host_group_id")

    @property
    @pulumi.getter(name="isPrimary")
    def is_primary(self) -> pulumi.Output[bool]:
        """
        Indicates the Service Fabric system services for the cluster will run on this node type. This setting cannot be changed once the node type is created.
        """
        return pulumi.get(self, "is_primary")

    @property
    @pulumi.getter(name="isSpotVM")
    def is_spot_vm(self) -> pulumi.Output[Optional[bool]]:
        """
        Indicates whether the node type will be Spot Virtual Machines. Azure will allocate the VMs if there is capacity available and the VMs can be evicted at any time.
        """
        return pulumi.get(self, "is_spot_vm")

    @property
    @pulumi.getter(name="isStateless")
    def is_stateless(self) -> pulumi.Output[Optional[bool]]:
        """
        Indicates if the node type can only host Stateless workloads.
        """
        return pulumi.get(self, "is_stateless")

    @property
    @pulumi.getter(name="multiplePlacementGroups")
    def multiple_placement_groups(self) -> pulumi.Output[Optional[bool]]:
        """
        Indicates if scale set associated with the node type can be composed of multiple placement groups.
        """
        return pulumi.get(self, "multiple_placement_groups")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Azure resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="natGatewayId")
    def nat_gateway_id(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the resource id of a NAT Gateway to attach to the subnet of this node type. Node type must use custom load balancer.
        """
        return pulumi.get(self, "nat_gateway_id")

    @property
    @pulumi.getter(name="networkSecurityRules")
    def network_security_rules(self) -> pulumi.Output[Optional[Sequence['outputs.NetworkSecurityRuleResponse']]]:
        """
        The Network Security Rules for this node type. This setting can only be specified for node types that are configured with frontend configurations.
        """
        return pulumi.get(self, "network_security_rules")

    @property
    @pulumi.getter(name="placementProperties")
    def placement_properties(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        The placement tags applied to nodes in the node type, which can be used to indicate where certain services (workload) should run.
        """
        return pulumi.get(self, "placement_properties")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        The provisioning state of the node type resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="secureBootEnabled")
    def secure_boot_enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Specifies whether secure boot should be enabled on the nodeType. Can only be used with TrustedLaunch SecurityType
        """
        return pulumi.get(self, "secure_boot_enabled")

    @property
    @pulumi.getter(name="securityType")
    def security_type(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the security type of the nodeType. Only TrustedLaunch is currently supported
        """
        return pulumi.get(self, "security_type")

    @property
    @pulumi.getter(name="serviceArtifactReferenceId")
    def service_artifact_reference_id(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the service artifact reference id used to set same image version for all virtual machines in the scale set when using 'latest' image version.
        """
        return pulumi.get(self, "service_artifact_reference_id")

    @property
    @pulumi.getter
    def sku(self) -> pulumi.Output[Optional['outputs.NodeTypeSkuResponse']]:
        """
        The node type sku.
        """
        return pulumi.get(self, "sku")

    @property
    @pulumi.getter(name="spotRestoreTimeout")
    def spot_restore_timeout(self) -> pulumi.Output[Optional[str]]:
        """
        Indicates the time duration after which the platform will not try to restore the VMSS SPOT instances specified as ISO 8601.
        """
        return pulumi.get(self, "spot_restore_timeout")

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> pulumi.Output[Optional[str]]:
        """
        Indicates the resource id of the subnet for the node type.
        """
        return pulumi.get(self, "subnet_id")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Metadata pertaining to creation and last modification of the resource.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Azure resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        Azure resource type.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="useDefaultPublicLoadBalancer")
    def use_default_public_load_balancer(self) -> pulumi.Output[Optional[bool]]:
        """
        Specifies whether the use public load balancer. If not specified and the node type doesn't have its own frontend configuration, it will be attached to the default load balancer. If the node type uses its own Load balancer and useDefaultPublicLoadBalancer is true, then the frontend has to be an Internal Load Balancer. If the node type uses its own Load balancer and useDefaultPublicLoadBalancer is false or not set, then the custom load balancer must include a public load balancer to provide outbound connectivity.
        """
        return pulumi.get(self, "use_default_public_load_balancer")

    @property
    @pulumi.getter(name="useEphemeralOSDisk")
    def use_ephemeral_os_disk(self) -> pulumi.Output[Optional[bool]]:
        """
        Indicates whether to use ephemeral os disk. The sku selected on the vmSize property needs to support this feature.
        """
        return pulumi.get(self, "use_ephemeral_os_disk")

    @property
    @pulumi.getter(name="useTempDataDisk")
    def use_temp_data_disk(self) -> pulumi.Output[Optional[bool]]:
        """
        Specifies whether to use the temporary disk for the service fabric data root, in which case no managed data disk will be attached and the temporary disk will be used. It is only allowed for stateless node types.
        """
        return pulumi.get(self, "use_temp_data_disk")

    @property
    @pulumi.getter(name="vmExtensions")
    def vm_extensions(self) -> pulumi.Output[Optional[Sequence['outputs.VMSSExtensionResponse']]]:
        """
        Set of extensions that should be installed onto the virtual machines.
        """
        return pulumi.get(self, "vm_extensions")

    @property
    @pulumi.getter(name="vmImageOffer")
    def vm_image_offer(self) -> pulumi.Output[Optional[str]]:
        """
        The offer type of the Azure Virtual Machines Marketplace image. For example, UbuntuServer or WindowsServer.
        """
        return pulumi.get(self, "vm_image_offer")

    @property
    @pulumi.getter(name="vmImagePlan")
    def vm_image_plan(self) -> pulumi.Output[Optional['outputs.VmImagePlanResponse']]:
        """
        Specifies information about the marketplace image used to create the virtual machine. This element is only used for marketplace images. Before you can use a marketplace image from an API, you must enable the image for programmatic use. In the Azure portal, find the marketplace image that you want to use and then click Want to deploy programmatically, Get Started ->. Enter any required information and then click Save.
        """
        return pulumi.get(self, "vm_image_plan")

    @property
    @pulumi.getter(name="vmImagePublisher")
    def vm_image_publisher(self) -> pulumi.Output[Optional[str]]:
        """
        The publisher of the Azure Virtual Machines Marketplace image. For example, Canonical or MicrosoftWindowsServer.
        """
        return pulumi.get(self, "vm_image_publisher")

    @property
    @pulumi.getter(name="vmImageResourceId")
    def vm_image_resource_id(self) -> pulumi.Output[Optional[str]]:
        """
        Indicates the resource id of the vm image. This parameter is used for custom vm image.
        """
        return pulumi.get(self, "vm_image_resource_id")

    @property
    @pulumi.getter(name="vmImageSku")
    def vm_image_sku(self) -> pulumi.Output[Optional[str]]:
        """
        The SKU of the Azure Virtual Machines Marketplace image. For example, 14.04.0-LTS or 2012-R2-Datacenter.
        """
        return pulumi.get(self, "vm_image_sku")

    @property
    @pulumi.getter(name="vmImageVersion")
    def vm_image_version(self) -> pulumi.Output[Optional[str]]:
        """
        The version of the Azure Virtual Machines Marketplace image. A value of 'latest' can be specified to select the latest version of an image. If omitted, the default is 'latest'.
        """
        return pulumi.get(self, "vm_image_version")

    @property
    @pulumi.getter(name="vmInstanceCount")
    def vm_instance_count(self) -> pulumi.Output[int]:
        """
        The number of nodes in the node type. <br /><br />**Values:** <br />-1 - Use when auto scale rules are configured or sku.capacity is defined <br /> 0 - Not supported <br /> >0 - Use for manual scale.
        """
        return pulumi.get(self, "vm_instance_count")

    @property
    @pulumi.getter(name="vmManagedIdentity")
    def vm_managed_identity(self) -> pulumi.Output[Optional['outputs.VmManagedIdentityResponse']]:
        """
        Identities to assign to the virtual machine scale set under the node type.
        """
        return pulumi.get(self, "vm_managed_identity")

    @property
    @pulumi.getter(name="vmSecrets")
    def vm_secrets(self) -> pulumi.Output[Optional[Sequence['outputs.VaultSecretGroupResponse']]]:
        """
        The secrets to install in the virtual machines.
        """
        return pulumi.get(self, "vm_secrets")

    @property
    @pulumi.getter(name="vmSetupActions")
    def vm_setup_actions(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Specifies the actions to be performed on the vms before bootstrapping the service fabric runtime.
        """
        return pulumi.get(self, "vm_setup_actions")

    @property
    @pulumi.getter(name="vmSharedGalleryImageId")
    def vm_shared_gallery_image_id(self) -> pulumi.Output[Optional[str]]:
        """
        Indicates the resource id of the vm shared galleries image. This parameter is used for custom vm image.
        """
        return pulumi.get(self, "vm_shared_gallery_image_id")

    @property
    @pulumi.getter(name="vmSize")
    def vm_size(self) -> pulumi.Output[Optional[str]]:
        """
        The size of virtual machines in the pool. All virtual machines in a pool are the same size. For example, Standard_D3.
        """
        return pulumi.get(self, "vm_size")

    @property
    @pulumi.getter
    def zones(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Specifies the availability zones where the node type would span across. If the cluster is not spanning across availability zones, initiates az migration for the cluster.
        """
        return pulumi.get(self, "zones")

