# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['StorageAccountArgs', 'StorageAccount']

@pulumi.input_type
class StorageAccountArgs:
    def __init__(__self__, *,
                 kind: pulumi.Input[Union[str, 'Kind']],
                 resource_group_name: pulumi.Input[str],
                 sku: pulumi.Input['SkuArgs'],
                 access_tier: Optional[pulumi.Input['AccessTier']] = None,
                 account_name: Optional[pulumi.Input[str]] = None,
                 allow_blob_public_access: Optional[pulumi.Input[bool]] = None,
                 allow_cross_tenant_replication: Optional[pulumi.Input[bool]] = None,
                 allow_shared_key_access: Optional[pulumi.Input[bool]] = None,
                 allowed_copy_scope: Optional[pulumi.Input[Union[str, 'AllowedCopyScope']]] = None,
                 azure_files_identity_based_authentication: Optional[pulumi.Input['AzureFilesIdentityBasedAuthenticationArgs']] = None,
                 custom_domain: Optional[pulumi.Input['CustomDomainArgs']] = None,
                 default_to_o_auth_authentication: Optional[pulumi.Input[bool]] = None,
                 dns_endpoint_type: Optional[pulumi.Input[Union[str, 'DnsEndpointType']]] = None,
                 enable_https_traffic_only: Optional[pulumi.Input[bool]] = None,
                 enable_nfs_v3: Optional[pulumi.Input[bool]] = None,
                 encryption: Optional[pulumi.Input['EncryptionArgs']] = None,
                 extended_location: Optional[pulumi.Input['ExtendedLocationArgs']] = None,
                 identity: Optional[pulumi.Input['IdentityArgs']] = None,
                 immutable_storage_with_versioning: Optional[pulumi.Input['ImmutableStorageAccountArgs']] = None,
                 is_hns_enabled: Optional[pulumi.Input[bool]] = None,
                 is_local_user_enabled: Optional[pulumi.Input[bool]] = None,
                 is_sftp_enabled: Optional[pulumi.Input[bool]] = None,
                 key_policy: Optional[pulumi.Input['KeyPolicyArgs']] = None,
                 large_file_shares_state: Optional[pulumi.Input[Union[str, 'LargeFileSharesState']]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 minimum_tls_version: Optional[pulumi.Input[Union[str, 'MinimumTlsVersion']]] = None,
                 network_rule_set: Optional[pulumi.Input['NetworkRuleSetArgs']] = None,
                 public_network_access: Optional[pulumi.Input[Union[str, 'PublicNetworkAccess']]] = None,
                 routing_preference: Optional[pulumi.Input['RoutingPreferenceArgs']] = None,
                 sas_policy: Optional[pulumi.Input['SasPolicyArgs']] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a StorageAccount resource.
        :param pulumi.Input[Union[str, 'Kind']] kind: Required. Indicates the type of storage account.
        :param pulumi.Input[str] resource_group_name: The name of the resource group within the user's subscription. The name is case insensitive.
        :param pulumi.Input['SkuArgs'] sku: Required. Gets or sets the SKU name.
        :param pulumi.Input['AccessTier'] access_tier: Required for storage accounts where kind = BlobStorage. The access tier is used for billing. The 'Premium' access tier is the default value for premium block blobs storage account type and it cannot be changed for the premium block blobs storage account type.
        :param pulumi.Input[str] account_name: The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.
        :param pulumi.Input[bool] allow_blob_public_access: Allow or disallow public access to all blobs or containers in the storage account. The default interpretation is true for this property.
        :param pulumi.Input[bool] allow_cross_tenant_replication: Allow or disallow cross AAD tenant object replication. The default interpretation is true for this property.
        :param pulumi.Input[bool] allow_shared_key_access: Indicates whether the storage account permits requests to be authorized with the account access key via Shared Key. If false, then all requests, including shared access signatures, must be authorized with Azure Active Directory (Azure AD). The default value is null, which is equivalent to true.
        :param pulumi.Input[Union[str, 'AllowedCopyScope']] allowed_copy_scope: Restrict copy to and from Storage Accounts within an AAD tenant or with Private Links to the same VNet.
        :param pulumi.Input['AzureFilesIdentityBasedAuthenticationArgs'] azure_files_identity_based_authentication: Provides the identity based authentication settings for Azure Files.
        :param pulumi.Input['CustomDomainArgs'] custom_domain: User domain assigned to the storage account. Name is the CNAME source. Only one custom domain is supported per storage account at this time. To clear the existing custom domain, use an empty string for the custom domain name property.
        :param pulumi.Input[bool] default_to_o_auth_authentication: A boolean flag which indicates whether the default authentication is OAuth or not. The default interpretation is false for this property.
        :param pulumi.Input[Union[str, 'DnsEndpointType']] dns_endpoint_type: Allows you to specify the type of endpoint. Set this to AzureDNSZone to create a large number of accounts in a single subscription, which creates accounts in an Azure DNS Zone and the endpoint URL will have an alphanumeric DNS Zone identifier.
        :param pulumi.Input[bool] enable_https_traffic_only: Allows https traffic only to storage service if sets to true. The default value is true since API version 2019-04-01.
        :param pulumi.Input[bool] enable_nfs_v3: NFS 3.0 protocol support enabled if set to true.
        :param pulumi.Input['EncryptionArgs'] encryption: Encryption settings to be used for server-side encryption for the storage account.
        :param pulumi.Input['ExtendedLocationArgs'] extended_location: Optional. Set the extended location of the resource. If not set, the storage account will be created in Azure main region. Otherwise it will be created in the specified extended location
        :param pulumi.Input['IdentityArgs'] identity: The identity of the resource.
        :param pulumi.Input['ImmutableStorageAccountArgs'] immutable_storage_with_versioning: The property is immutable and can only be set to true at the account creation time. When set to true, it enables object level immutability for all the new containers in the account by default.
        :param pulumi.Input[bool] is_hns_enabled: Account HierarchicalNamespace enabled if sets to true.
        :param pulumi.Input[bool] is_local_user_enabled: Enables local users feature, if set to true
        :param pulumi.Input[bool] is_sftp_enabled: Enables Secure File Transfer Protocol, if set to true
        :param pulumi.Input['KeyPolicyArgs'] key_policy: KeyPolicy assigned to the storage account.
        :param pulumi.Input[Union[str, 'LargeFileSharesState']] large_file_shares_state: Allow large file shares if sets to Enabled. It cannot be disabled once it is enabled.
        :param pulumi.Input[str] location: Required. Gets or sets the location of the resource. This will be one of the supported and registered Azure Geo Regions (e.g. West US, East US, Southeast Asia, etc.). The geo region of a resource cannot be changed once it is created, but if an identical geo region is specified on update, the request will succeed.
        :param pulumi.Input[Union[str, 'MinimumTlsVersion']] minimum_tls_version: Set the minimum TLS version to be permitted on requests to storage. The default interpretation is TLS 1.0 for this property.
        :param pulumi.Input['NetworkRuleSetArgs'] network_rule_set: Network rule set
        :param pulumi.Input[Union[str, 'PublicNetworkAccess']] public_network_access: Allow or disallow public network access to Storage Account. Value is optional but if passed in, must be 'Enabled' or 'Disabled'.
        :param pulumi.Input['RoutingPreferenceArgs'] routing_preference: Maintains information about the network routing choice opted by the user for data transfer
        :param pulumi.Input['SasPolicyArgs'] sas_policy: SasPolicy assigned to the storage account.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Gets or sets a list of key value pairs that describe the resource. These tags can be used for viewing and grouping this resource (across resource groups). A maximum of 15 tags can be provided for a resource. Each tag must have a key with a length no greater than 128 characters and a value with a length no greater than 256 characters.
        """
        pulumi.set(__self__, "kind", kind)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "sku", sku)
        if access_tier is not None:
            pulumi.set(__self__, "access_tier", access_tier)
        if account_name is not None:
            pulumi.set(__self__, "account_name", account_name)
        if allow_blob_public_access is not None:
            pulumi.set(__self__, "allow_blob_public_access", allow_blob_public_access)
        if allow_cross_tenant_replication is not None:
            pulumi.set(__self__, "allow_cross_tenant_replication", allow_cross_tenant_replication)
        if allow_shared_key_access is not None:
            pulumi.set(__self__, "allow_shared_key_access", allow_shared_key_access)
        if allowed_copy_scope is not None:
            pulumi.set(__self__, "allowed_copy_scope", allowed_copy_scope)
        if azure_files_identity_based_authentication is not None:
            pulumi.set(__self__, "azure_files_identity_based_authentication", azure_files_identity_based_authentication)
        if custom_domain is not None:
            pulumi.set(__self__, "custom_domain", custom_domain)
        if default_to_o_auth_authentication is not None:
            pulumi.set(__self__, "default_to_o_auth_authentication", default_to_o_auth_authentication)
        if dns_endpoint_type is not None:
            pulumi.set(__self__, "dns_endpoint_type", dns_endpoint_type)
        if enable_https_traffic_only is not None:
            pulumi.set(__self__, "enable_https_traffic_only", enable_https_traffic_only)
        if enable_nfs_v3 is not None:
            pulumi.set(__self__, "enable_nfs_v3", enable_nfs_v3)
        if encryption is not None:
            pulumi.set(__self__, "encryption", encryption)
        if extended_location is not None:
            pulumi.set(__self__, "extended_location", extended_location)
        if identity is not None:
            pulumi.set(__self__, "identity", identity)
        if immutable_storage_with_versioning is not None:
            pulumi.set(__self__, "immutable_storage_with_versioning", immutable_storage_with_versioning)
        if is_hns_enabled is not None:
            pulumi.set(__self__, "is_hns_enabled", is_hns_enabled)
        if is_local_user_enabled is not None:
            pulumi.set(__self__, "is_local_user_enabled", is_local_user_enabled)
        if is_sftp_enabled is not None:
            pulumi.set(__self__, "is_sftp_enabled", is_sftp_enabled)
        if key_policy is not None:
            pulumi.set(__self__, "key_policy", key_policy)
        if large_file_shares_state is not None:
            pulumi.set(__self__, "large_file_shares_state", large_file_shares_state)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if minimum_tls_version is not None:
            pulumi.set(__self__, "minimum_tls_version", minimum_tls_version)
        if network_rule_set is not None:
            pulumi.set(__self__, "network_rule_set", network_rule_set)
        if public_network_access is not None:
            pulumi.set(__self__, "public_network_access", public_network_access)
        if routing_preference is not None:
            pulumi.set(__self__, "routing_preference", routing_preference)
        if sas_policy is not None:
            pulumi.set(__self__, "sas_policy", sas_policy)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def kind(self) -> pulumi.Input[Union[str, 'Kind']]:
        """
        Required. Indicates the type of storage account.
        """
        return pulumi.get(self, "kind")

    @kind.setter
    def kind(self, value: pulumi.Input[Union[str, 'Kind']]):
        pulumi.set(self, "kind", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group within the user's subscription. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter
    def sku(self) -> pulumi.Input['SkuArgs']:
        """
        Required. Gets or sets the SKU name.
        """
        return pulumi.get(self, "sku")

    @sku.setter
    def sku(self, value: pulumi.Input['SkuArgs']):
        pulumi.set(self, "sku", value)

    @property
    @pulumi.getter(name="accessTier")
    def access_tier(self) -> Optional[pulumi.Input['AccessTier']]:
        """
        Required for storage accounts where kind = BlobStorage. The access tier is used for billing. The 'Premium' access tier is the default value for premium block blobs storage account type and it cannot be changed for the premium block blobs storage account type.
        """
        return pulumi.get(self, "access_tier")

    @access_tier.setter
    def access_tier(self, value: Optional[pulumi.Input['AccessTier']]):
        pulumi.set(self, "access_tier", value)

    @property
    @pulumi.getter(name="accountName")
    def account_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.
        """
        return pulumi.get(self, "account_name")

    @account_name.setter
    def account_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "account_name", value)

    @property
    @pulumi.getter(name="allowBlobPublicAccess")
    def allow_blob_public_access(self) -> Optional[pulumi.Input[bool]]:
        """
        Allow or disallow public access to all blobs or containers in the storage account. The default interpretation is true for this property.
        """
        return pulumi.get(self, "allow_blob_public_access")

    @allow_blob_public_access.setter
    def allow_blob_public_access(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "allow_blob_public_access", value)

    @property
    @pulumi.getter(name="allowCrossTenantReplication")
    def allow_cross_tenant_replication(self) -> Optional[pulumi.Input[bool]]:
        """
        Allow or disallow cross AAD tenant object replication. The default interpretation is true for this property.
        """
        return pulumi.get(self, "allow_cross_tenant_replication")

    @allow_cross_tenant_replication.setter
    def allow_cross_tenant_replication(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "allow_cross_tenant_replication", value)

    @property
    @pulumi.getter(name="allowSharedKeyAccess")
    def allow_shared_key_access(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether the storage account permits requests to be authorized with the account access key via Shared Key. If false, then all requests, including shared access signatures, must be authorized with Azure Active Directory (Azure AD). The default value is null, which is equivalent to true.
        """
        return pulumi.get(self, "allow_shared_key_access")

    @allow_shared_key_access.setter
    def allow_shared_key_access(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "allow_shared_key_access", value)

    @property
    @pulumi.getter(name="allowedCopyScope")
    def allowed_copy_scope(self) -> Optional[pulumi.Input[Union[str, 'AllowedCopyScope']]]:
        """
        Restrict copy to and from Storage Accounts within an AAD tenant or with Private Links to the same VNet.
        """
        return pulumi.get(self, "allowed_copy_scope")

    @allowed_copy_scope.setter
    def allowed_copy_scope(self, value: Optional[pulumi.Input[Union[str, 'AllowedCopyScope']]]):
        pulumi.set(self, "allowed_copy_scope", value)

    @property
    @pulumi.getter(name="azureFilesIdentityBasedAuthentication")
    def azure_files_identity_based_authentication(self) -> Optional[pulumi.Input['AzureFilesIdentityBasedAuthenticationArgs']]:
        """
        Provides the identity based authentication settings for Azure Files.
        """
        return pulumi.get(self, "azure_files_identity_based_authentication")

    @azure_files_identity_based_authentication.setter
    def azure_files_identity_based_authentication(self, value: Optional[pulumi.Input['AzureFilesIdentityBasedAuthenticationArgs']]):
        pulumi.set(self, "azure_files_identity_based_authentication", value)

    @property
    @pulumi.getter(name="customDomain")
    def custom_domain(self) -> Optional[pulumi.Input['CustomDomainArgs']]:
        """
        User domain assigned to the storage account. Name is the CNAME source. Only one custom domain is supported per storage account at this time. To clear the existing custom domain, use an empty string for the custom domain name property.
        """
        return pulumi.get(self, "custom_domain")

    @custom_domain.setter
    def custom_domain(self, value: Optional[pulumi.Input['CustomDomainArgs']]):
        pulumi.set(self, "custom_domain", value)

    @property
    @pulumi.getter(name="defaultToOAuthAuthentication")
    def default_to_o_auth_authentication(self) -> Optional[pulumi.Input[bool]]:
        """
        A boolean flag which indicates whether the default authentication is OAuth or not. The default interpretation is false for this property.
        """
        return pulumi.get(self, "default_to_o_auth_authentication")

    @default_to_o_auth_authentication.setter
    def default_to_o_auth_authentication(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "default_to_o_auth_authentication", value)

    @property
    @pulumi.getter(name="dnsEndpointType")
    def dns_endpoint_type(self) -> Optional[pulumi.Input[Union[str, 'DnsEndpointType']]]:
        """
        Allows you to specify the type of endpoint. Set this to AzureDNSZone to create a large number of accounts in a single subscription, which creates accounts in an Azure DNS Zone and the endpoint URL will have an alphanumeric DNS Zone identifier.
        """
        return pulumi.get(self, "dns_endpoint_type")

    @dns_endpoint_type.setter
    def dns_endpoint_type(self, value: Optional[pulumi.Input[Union[str, 'DnsEndpointType']]]):
        pulumi.set(self, "dns_endpoint_type", value)

    @property
    @pulumi.getter(name="enableHttpsTrafficOnly")
    def enable_https_traffic_only(self) -> Optional[pulumi.Input[bool]]:
        """
        Allows https traffic only to storage service if sets to true. The default value is true since API version 2019-04-01.
        """
        return pulumi.get(self, "enable_https_traffic_only")

    @enable_https_traffic_only.setter
    def enable_https_traffic_only(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_https_traffic_only", value)

    @property
    @pulumi.getter(name="enableNfsV3")
    def enable_nfs_v3(self) -> Optional[pulumi.Input[bool]]:
        """
        NFS 3.0 protocol support enabled if set to true.
        """
        return pulumi.get(self, "enable_nfs_v3")

    @enable_nfs_v3.setter
    def enable_nfs_v3(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_nfs_v3", value)

    @property
    @pulumi.getter
    def encryption(self) -> Optional[pulumi.Input['EncryptionArgs']]:
        """
        Encryption settings to be used for server-side encryption for the storage account.
        """
        return pulumi.get(self, "encryption")

    @encryption.setter
    def encryption(self, value: Optional[pulumi.Input['EncryptionArgs']]):
        pulumi.set(self, "encryption", value)

    @property
    @pulumi.getter(name="extendedLocation")
    def extended_location(self) -> Optional[pulumi.Input['ExtendedLocationArgs']]:
        """
        Optional. Set the extended location of the resource. If not set, the storage account will be created in Azure main region. Otherwise it will be created in the specified extended location
        """
        return pulumi.get(self, "extended_location")

    @extended_location.setter
    def extended_location(self, value: Optional[pulumi.Input['ExtendedLocationArgs']]):
        pulumi.set(self, "extended_location", value)

    @property
    @pulumi.getter
    def identity(self) -> Optional[pulumi.Input['IdentityArgs']]:
        """
        The identity of the resource.
        """
        return pulumi.get(self, "identity")

    @identity.setter
    def identity(self, value: Optional[pulumi.Input['IdentityArgs']]):
        pulumi.set(self, "identity", value)

    @property
    @pulumi.getter(name="immutableStorageWithVersioning")
    def immutable_storage_with_versioning(self) -> Optional[pulumi.Input['ImmutableStorageAccountArgs']]:
        """
        The property is immutable and can only be set to true at the account creation time. When set to true, it enables object level immutability for all the new containers in the account by default.
        """
        return pulumi.get(self, "immutable_storage_with_versioning")

    @immutable_storage_with_versioning.setter
    def immutable_storage_with_versioning(self, value: Optional[pulumi.Input['ImmutableStorageAccountArgs']]):
        pulumi.set(self, "immutable_storage_with_versioning", value)

    @property
    @pulumi.getter(name="isHnsEnabled")
    def is_hns_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Account HierarchicalNamespace enabled if sets to true.
        """
        return pulumi.get(self, "is_hns_enabled")

    @is_hns_enabled.setter
    def is_hns_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_hns_enabled", value)

    @property
    @pulumi.getter(name="isLocalUserEnabled")
    def is_local_user_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Enables local users feature, if set to true
        """
        return pulumi.get(self, "is_local_user_enabled")

    @is_local_user_enabled.setter
    def is_local_user_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_local_user_enabled", value)

    @property
    @pulumi.getter(name="isSftpEnabled")
    def is_sftp_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Enables Secure File Transfer Protocol, if set to true
        """
        return pulumi.get(self, "is_sftp_enabled")

    @is_sftp_enabled.setter
    def is_sftp_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_sftp_enabled", value)

    @property
    @pulumi.getter(name="keyPolicy")
    def key_policy(self) -> Optional[pulumi.Input['KeyPolicyArgs']]:
        """
        KeyPolicy assigned to the storage account.
        """
        return pulumi.get(self, "key_policy")

    @key_policy.setter
    def key_policy(self, value: Optional[pulumi.Input['KeyPolicyArgs']]):
        pulumi.set(self, "key_policy", value)

    @property
    @pulumi.getter(name="largeFileSharesState")
    def large_file_shares_state(self) -> Optional[pulumi.Input[Union[str, 'LargeFileSharesState']]]:
        """
        Allow large file shares if sets to Enabled. It cannot be disabled once it is enabled.
        """
        return pulumi.get(self, "large_file_shares_state")

    @large_file_shares_state.setter
    def large_file_shares_state(self, value: Optional[pulumi.Input[Union[str, 'LargeFileSharesState']]]):
        pulumi.set(self, "large_file_shares_state", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        Required. Gets or sets the location of the resource. This will be one of the supported and registered Azure Geo Regions (e.g. West US, East US, Southeast Asia, etc.). The geo region of a resource cannot be changed once it is created, but if an identical geo region is specified on update, the request will succeed.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="minimumTlsVersion")
    def minimum_tls_version(self) -> Optional[pulumi.Input[Union[str, 'MinimumTlsVersion']]]:
        """
        Set the minimum TLS version to be permitted on requests to storage. The default interpretation is TLS 1.0 for this property.
        """
        return pulumi.get(self, "minimum_tls_version")

    @minimum_tls_version.setter
    def minimum_tls_version(self, value: Optional[pulumi.Input[Union[str, 'MinimumTlsVersion']]]):
        pulumi.set(self, "minimum_tls_version", value)

    @property
    @pulumi.getter(name="networkRuleSet")
    def network_rule_set(self) -> Optional[pulumi.Input['NetworkRuleSetArgs']]:
        """
        Network rule set
        """
        return pulumi.get(self, "network_rule_set")

    @network_rule_set.setter
    def network_rule_set(self, value: Optional[pulumi.Input['NetworkRuleSetArgs']]):
        pulumi.set(self, "network_rule_set", value)

    @property
    @pulumi.getter(name="publicNetworkAccess")
    def public_network_access(self) -> Optional[pulumi.Input[Union[str, 'PublicNetworkAccess']]]:
        """
        Allow or disallow public network access to Storage Account. Value is optional but if passed in, must be 'Enabled' or 'Disabled'.
        """
        return pulumi.get(self, "public_network_access")

    @public_network_access.setter
    def public_network_access(self, value: Optional[pulumi.Input[Union[str, 'PublicNetworkAccess']]]):
        pulumi.set(self, "public_network_access", value)

    @property
    @pulumi.getter(name="routingPreference")
    def routing_preference(self) -> Optional[pulumi.Input['RoutingPreferenceArgs']]:
        """
        Maintains information about the network routing choice opted by the user for data transfer
        """
        return pulumi.get(self, "routing_preference")

    @routing_preference.setter
    def routing_preference(self, value: Optional[pulumi.Input['RoutingPreferenceArgs']]):
        pulumi.set(self, "routing_preference", value)

    @property
    @pulumi.getter(name="sasPolicy")
    def sas_policy(self) -> Optional[pulumi.Input['SasPolicyArgs']]:
        """
        SasPolicy assigned to the storage account.
        """
        return pulumi.get(self, "sas_policy")

    @sas_policy.setter
    def sas_policy(self, value: Optional[pulumi.Input['SasPolicyArgs']]):
        pulumi.set(self, "sas_policy", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Gets or sets a list of key value pairs that describe the resource. These tags can be used for viewing and grouping this resource (across resource groups). A maximum of 15 tags can be provided for a resource. Each tag must have a key with a length no greater than 128 characters and a value with a length no greater than 256 characters.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)


class StorageAccount(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_tier: Optional[pulumi.Input['AccessTier']] = None,
                 account_name: Optional[pulumi.Input[str]] = None,
                 allow_blob_public_access: Optional[pulumi.Input[bool]] = None,
                 allow_cross_tenant_replication: Optional[pulumi.Input[bool]] = None,
                 allow_shared_key_access: Optional[pulumi.Input[bool]] = None,
                 allowed_copy_scope: Optional[pulumi.Input[Union[str, 'AllowedCopyScope']]] = None,
                 azure_files_identity_based_authentication: Optional[pulumi.Input[pulumi.InputType['AzureFilesIdentityBasedAuthenticationArgs']]] = None,
                 custom_domain: Optional[pulumi.Input[pulumi.InputType['CustomDomainArgs']]] = None,
                 default_to_o_auth_authentication: Optional[pulumi.Input[bool]] = None,
                 dns_endpoint_type: Optional[pulumi.Input[Union[str, 'DnsEndpointType']]] = None,
                 enable_https_traffic_only: Optional[pulumi.Input[bool]] = None,
                 enable_nfs_v3: Optional[pulumi.Input[bool]] = None,
                 encryption: Optional[pulumi.Input[pulumi.InputType['EncryptionArgs']]] = None,
                 extended_location: Optional[pulumi.Input[pulumi.InputType['ExtendedLocationArgs']]] = None,
                 identity: Optional[pulumi.Input[pulumi.InputType['IdentityArgs']]] = None,
                 immutable_storage_with_versioning: Optional[pulumi.Input[pulumi.InputType['ImmutableStorageAccountArgs']]] = None,
                 is_hns_enabled: Optional[pulumi.Input[bool]] = None,
                 is_local_user_enabled: Optional[pulumi.Input[bool]] = None,
                 is_sftp_enabled: Optional[pulumi.Input[bool]] = None,
                 key_policy: Optional[pulumi.Input[pulumi.InputType['KeyPolicyArgs']]] = None,
                 kind: Optional[pulumi.Input[Union[str, 'Kind']]] = None,
                 large_file_shares_state: Optional[pulumi.Input[Union[str, 'LargeFileSharesState']]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 minimum_tls_version: Optional[pulumi.Input[Union[str, 'MinimumTlsVersion']]] = None,
                 network_rule_set: Optional[pulumi.Input[pulumi.InputType['NetworkRuleSetArgs']]] = None,
                 public_network_access: Optional[pulumi.Input[Union[str, 'PublicNetworkAccess']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 routing_preference: Optional[pulumi.Input[pulumi.InputType['RoutingPreferenceArgs']]] = None,
                 sas_policy: Optional[pulumi.Input[pulumi.InputType['SasPolicyArgs']]] = None,
                 sku: Optional[pulumi.Input[pulumi.InputType['SkuArgs']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        The storage account.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input['AccessTier'] access_tier: Required for storage accounts where kind = BlobStorage. The access tier is used for billing. The 'Premium' access tier is the default value for premium block blobs storage account type and it cannot be changed for the premium block blobs storage account type.
        :param pulumi.Input[str] account_name: The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.
        :param pulumi.Input[bool] allow_blob_public_access: Allow or disallow public access to all blobs or containers in the storage account. The default interpretation is true for this property.
        :param pulumi.Input[bool] allow_cross_tenant_replication: Allow or disallow cross AAD tenant object replication. The default interpretation is true for this property.
        :param pulumi.Input[bool] allow_shared_key_access: Indicates whether the storage account permits requests to be authorized with the account access key via Shared Key. If false, then all requests, including shared access signatures, must be authorized with Azure Active Directory (Azure AD). The default value is null, which is equivalent to true.
        :param pulumi.Input[Union[str, 'AllowedCopyScope']] allowed_copy_scope: Restrict copy to and from Storage Accounts within an AAD tenant or with Private Links to the same VNet.
        :param pulumi.Input[pulumi.InputType['AzureFilesIdentityBasedAuthenticationArgs']] azure_files_identity_based_authentication: Provides the identity based authentication settings for Azure Files.
        :param pulumi.Input[pulumi.InputType['CustomDomainArgs']] custom_domain: User domain assigned to the storage account. Name is the CNAME source. Only one custom domain is supported per storage account at this time. To clear the existing custom domain, use an empty string for the custom domain name property.
        :param pulumi.Input[bool] default_to_o_auth_authentication: A boolean flag which indicates whether the default authentication is OAuth or not. The default interpretation is false for this property.
        :param pulumi.Input[Union[str, 'DnsEndpointType']] dns_endpoint_type: Allows you to specify the type of endpoint. Set this to AzureDNSZone to create a large number of accounts in a single subscription, which creates accounts in an Azure DNS Zone and the endpoint URL will have an alphanumeric DNS Zone identifier.
        :param pulumi.Input[bool] enable_https_traffic_only: Allows https traffic only to storage service if sets to true. The default value is true since API version 2019-04-01.
        :param pulumi.Input[bool] enable_nfs_v3: NFS 3.0 protocol support enabled if set to true.
        :param pulumi.Input[pulumi.InputType['EncryptionArgs']] encryption: Encryption settings to be used for server-side encryption for the storage account.
        :param pulumi.Input[pulumi.InputType['ExtendedLocationArgs']] extended_location: Optional. Set the extended location of the resource. If not set, the storage account will be created in Azure main region. Otherwise it will be created in the specified extended location
        :param pulumi.Input[pulumi.InputType['IdentityArgs']] identity: The identity of the resource.
        :param pulumi.Input[pulumi.InputType['ImmutableStorageAccountArgs']] immutable_storage_with_versioning: The property is immutable and can only be set to true at the account creation time. When set to true, it enables object level immutability for all the new containers in the account by default.
        :param pulumi.Input[bool] is_hns_enabled: Account HierarchicalNamespace enabled if sets to true.
        :param pulumi.Input[bool] is_local_user_enabled: Enables local users feature, if set to true
        :param pulumi.Input[bool] is_sftp_enabled: Enables Secure File Transfer Protocol, if set to true
        :param pulumi.Input[pulumi.InputType['KeyPolicyArgs']] key_policy: KeyPolicy assigned to the storage account.
        :param pulumi.Input[Union[str, 'Kind']] kind: Required. Indicates the type of storage account.
        :param pulumi.Input[Union[str, 'LargeFileSharesState']] large_file_shares_state: Allow large file shares if sets to Enabled. It cannot be disabled once it is enabled.
        :param pulumi.Input[str] location: Required. Gets or sets the location of the resource. This will be one of the supported and registered Azure Geo Regions (e.g. West US, East US, Southeast Asia, etc.). The geo region of a resource cannot be changed once it is created, but if an identical geo region is specified on update, the request will succeed.
        :param pulumi.Input[Union[str, 'MinimumTlsVersion']] minimum_tls_version: Set the minimum TLS version to be permitted on requests to storage. The default interpretation is TLS 1.0 for this property.
        :param pulumi.Input[pulumi.InputType['NetworkRuleSetArgs']] network_rule_set: Network rule set
        :param pulumi.Input[Union[str, 'PublicNetworkAccess']] public_network_access: Allow or disallow public network access to Storage Account. Value is optional but if passed in, must be 'Enabled' or 'Disabled'.
        :param pulumi.Input[str] resource_group_name: The name of the resource group within the user's subscription. The name is case insensitive.
        :param pulumi.Input[pulumi.InputType['RoutingPreferenceArgs']] routing_preference: Maintains information about the network routing choice opted by the user for data transfer
        :param pulumi.Input[pulumi.InputType['SasPolicyArgs']] sas_policy: SasPolicy assigned to the storage account.
        :param pulumi.Input[pulumi.InputType['SkuArgs']] sku: Required. Gets or sets the SKU name.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Gets or sets a list of key value pairs that describe the resource. These tags can be used for viewing and grouping this resource (across resource groups). A maximum of 15 tags can be provided for a resource. Each tag must have a key with a length no greater than 128 characters and a value with a length no greater than 256 characters.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: StorageAccountArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The storage account.

        :param str resource_name: The name of the resource.
        :param StorageAccountArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(StorageAccountArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_tier: Optional[pulumi.Input['AccessTier']] = None,
                 account_name: Optional[pulumi.Input[str]] = None,
                 allow_blob_public_access: Optional[pulumi.Input[bool]] = None,
                 allow_cross_tenant_replication: Optional[pulumi.Input[bool]] = None,
                 allow_shared_key_access: Optional[pulumi.Input[bool]] = None,
                 allowed_copy_scope: Optional[pulumi.Input[Union[str, 'AllowedCopyScope']]] = None,
                 azure_files_identity_based_authentication: Optional[pulumi.Input[pulumi.InputType['AzureFilesIdentityBasedAuthenticationArgs']]] = None,
                 custom_domain: Optional[pulumi.Input[pulumi.InputType['CustomDomainArgs']]] = None,
                 default_to_o_auth_authentication: Optional[pulumi.Input[bool]] = None,
                 dns_endpoint_type: Optional[pulumi.Input[Union[str, 'DnsEndpointType']]] = None,
                 enable_https_traffic_only: Optional[pulumi.Input[bool]] = None,
                 enable_nfs_v3: Optional[pulumi.Input[bool]] = None,
                 encryption: Optional[pulumi.Input[pulumi.InputType['EncryptionArgs']]] = None,
                 extended_location: Optional[pulumi.Input[pulumi.InputType['ExtendedLocationArgs']]] = None,
                 identity: Optional[pulumi.Input[pulumi.InputType['IdentityArgs']]] = None,
                 immutable_storage_with_versioning: Optional[pulumi.Input[pulumi.InputType['ImmutableStorageAccountArgs']]] = None,
                 is_hns_enabled: Optional[pulumi.Input[bool]] = None,
                 is_local_user_enabled: Optional[pulumi.Input[bool]] = None,
                 is_sftp_enabled: Optional[pulumi.Input[bool]] = None,
                 key_policy: Optional[pulumi.Input[pulumi.InputType['KeyPolicyArgs']]] = None,
                 kind: Optional[pulumi.Input[Union[str, 'Kind']]] = None,
                 large_file_shares_state: Optional[pulumi.Input[Union[str, 'LargeFileSharesState']]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 minimum_tls_version: Optional[pulumi.Input[Union[str, 'MinimumTlsVersion']]] = None,
                 network_rule_set: Optional[pulumi.Input[pulumi.InputType['NetworkRuleSetArgs']]] = None,
                 public_network_access: Optional[pulumi.Input[Union[str, 'PublicNetworkAccess']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 routing_preference: Optional[pulumi.Input[pulumi.InputType['RoutingPreferenceArgs']]] = None,
                 sas_policy: Optional[pulumi.Input[pulumi.InputType['SasPolicyArgs']]] = None,
                 sku: Optional[pulumi.Input[pulumi.InputType['SkuArgs']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = StorageAccountArgs.__new__(StorageAccountArgs)

            __props__.__dict__["access_tier"] = access_tier
            __props__.__dict__["account_name"] = account_name
            __props__.__dict__["allow_blob_public_access"] = allow_blob_public_access
            __props__.__dict__["allow_cross_tenant_replication"] = allow_cross_tenant_replication
            __props__.__dict__["allow_shared_key_access"] = allow_shared_key_access
            __props__.__dict__["allowed_copy_scope"] = allowed_copy_scope
            __props__.__dict__["azure_files_identity_based_authentication"] = azure_files_identity_based_authentication
            __props__.__dict__["custom_domain"] = custom_domain
            __props__.__dict__["default_to_o_auth_authentication"] = default_to_o_auth_authentication
            __props__.__dict__["dns_endpoint_type"] = dns_endpoint_type
            __props__.__dict__["enable_https_traffic_only"] = enable_https_traffic_only
            __props__.__dict__["enable_nfs_v3"] = enable_nfs_v3
            __props__.__dict__["encryption"] = encryption
            __props__.__dict__["extended_location"] = extended_location
            __props__.__dict__["identity"] = identity
            __props__.__dict__["immutable_storage_with_versioning"] = immutable_storage_with_versioning
            __props__.__dict__["is_hns_enabled"] = is_hns_enabled
            __props__.__dict__["is_local_user_enabled"] = is_local_user_enabled
            __props__.__dict__["is_sftp_enabled"] = is_sftp_enabled
            __props__.__dict__["key_policy"] = key_policy
            if kind is None and not opts.urn:
                raise TypeError("Missing required property 'kind'")
            __props__.__dict__["kind"] = kind
            __props__.__dict__["large_file_shares_state"] = large_file_shares_state
            __props__.__dict__["location"] = location
            __props__.__dict__["minimum_tls_version"] = minimum_tls_version
            __props__.__dict__["network_rule_set"] = network_rule_set
            __props__.__dict__["public_network_access"] = public_network_access
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["routing_preference"] = routing_preference
            __props__.__dict__["sas_policy"] = sas_policy
            if sku is None and not opts.urn:
                raise TypeError("Missing required property 'sku'")
            __props__.__dict__["sku"] = sku
            __props__.__dict__["tags"] = tags
            __props__.__dict__["blob_restore_status"] = None
            __props__.__dict__["creation_time"] = None
            __props__.__dict__["failover_in_progress"] = None
            __props__.__dict__["geo_replication_stats"] = None
            __props__.__dict__["key_creation_time"] = None
            __props__.__dict__["last_geo_failover_time"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["primary_endpoints"] = None
            __props__.__dict__["primary_location"] = None
            __props__.__dict__["private_endpoint_connections"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["secondary_endpoints"] = None
            __props__.__dict__["secondary_location"] = None
            __props__.__dict__["status_of_primary"] = None
            __props__.__dict__["status_of_secondary"] = None
            __props__.__dict__["storage_account_sku_conversion_status"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:storage:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20150501preview:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20150615:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20160101:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20160501:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20161201:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20170601:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20171001:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20180201:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20180301preview:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20180701:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20181101:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20190401:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20190601:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20200801preview:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20210101:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20210201:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20210401:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20210601:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20210801:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20210901:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20220501:StorageAccount"), pulumi.Alias(type_="azure-native:storage/v20230101:StorageAccount")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(StorageAccount, __self__).__init__(
            'azure-native:storage/v20220901:StorageAccount',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'StorageAccount':
        """
        Get an existing StorageAccount resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = StorageAccountArgs.__new__(StorageAccountArgs)

        __props__.__dict__["access_tier"] = None
        __props__.__dict__["allow_blob_public_access"] = None
        __props__.__dict__["allow_cross_tenant_replication"] = None
        __props__.__dict__["allow_shared_key_access"] = None
        __props__.__dict__["allowed_copy_scope"] = None
        __props__.__dict__["azure_files_identity_based_authentication"] = None
        __props__.__dict__["blob_restore_status"] = None
        __props__.__dict__["creation_time"] = None
        __props__.__dict__["custom_domain"] = None
        __props__.__dict__["default_to_o_auth_authentication"] = None
        __props__.__dict__["dns_endpoint_type"] = None
        __props__.__dict__["enable_https_traffic_only"] = None
        __props__.__dict__["enable_nfs_v3"] = None
        __props__.__dict__["encryption"] = None
        __props__.__dict__["extended_location"] = None
        __props__.__dict__["failover_in_progress"] = None
        __props__.__dict__["geo_replication_stats"] = None
        __props__.__dict__["identity"] = None
        __props__.__dict__["immutable_storage_with_versioning"] = None
        __props__.__dict__["is_hns_enabled"] = None
        __props__.__dict__["is_local_user_enabled"] = None
        __props__.__dict__["is_sftp_enabled"] = None
        __props__.__dict__["key_creation_time"] = None
        __props__.__dict__["key_policy"] = None
        __props__.__dict__["kind"] = None
        __props__.__dict__["large_file_shares_state"] = None
        __props__.__dict__["last_geo_failover_time"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["minimum_tls_version"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["network_rule_set"] = None
        __props__.__dict__["primary_endpoints"] = None
        __props__.__dict__["primary_location"] = None
        __props__.__dict__["private_endpoint_connections"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["public_network_access"] = None
        __props__.__dict__["routing_preference"] = None
        __props__.__dict__["sas_policy"] = None
        __props__.__dict__["secondary_endpoints"] = None
        __props__.__dict__["secondary_location"] = None
        __props__.__dict__["sku"] = None
        __props__.__dict__["status_of_primary"] = None
        __props__.__dict__["status_of_secondary"] = None
        __props__.__dict__["storage_account_sku_conversion_status"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        return StorageAccount(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accessTier")
    def access_tier(self) -> pulumi.Output[str]:
        """
        Required for storage accounts where kind = BlobStorage. The access tier is used for billing. The 'Premium' access tier is the default value for premium block blobs storage account type and it cannot be changed for the premium block blobs storage account type.
        """
        return pulumi.get(self, "access_tier")

    @property
    @pulumi.getter(name="allowBlobPublicAccess")
    def allow_blob_public_access(self) -> pulumi.Output[Optional[bool]]:
        """
        Allow or disallow public access to all blobs or containers in the storage account. The default interpretation is true for this property.
        """
        return pulumi.get(self, "allow_blob_public_access")

    @property
    @pulumi.getter(name="allowCrossTenantReplication")
    def allow_cross_tenant_replication(self) -> pulumi.Output[Optional[bool]]:
        """
        Allow or disallow cross AAD tenant object replication. The default interpretation is true for this property.
        """
        return pulumi.get(self, "allow_cross_tenant_replication")

    @property
    @pulumi.getter(name="allowSharedKeyAccess")
    def allow_shared_key_access(self) -> pulumi.Output[Optional[bool]]:
        """
        Indicates whether the storage account permits requests to be authorized with the account access key via Shared Key. If false, then all requests, including shared access signatures, must be authorized with Azure Active Directory (Azure AD). The default value is null, which is equivalent to true.
        """
        return pulumi.get(self, "allow_shared_key_access")

    @property
    @pulumi.getter(name="allowedCopyScope")
    def allowed_copy_scope(self) -> pulumi.Output[Optional[str]]:
        """
        Restrict copy to and from Storage Accounts within an AAD tenant or with Private Links to the same VNet.
        """
        return pulumi.get(self, "allowed_copy_scope")

    @property
    @pulumi.getter(name="azureFilesIdentityBasedAuthentication")
    def azure_files_identity_based_authentication(self) -> pulumi.Output[Optional['outputs.AzureFilesIdentityBasedAuthenticationResponse']]:
        """
        Provides the identity based authentication settings for Azure Files.
        """
        return pulumi.get(self, "azure_files_identity_based_authentication")

    @property
    @pulumi.getter(name="blobRestoreStatus")
    def blob_restore_status(self) -> pulumi.Output['outputs.BlobRestoreStatusResponse']:
        """
        Blob restore status
        """
        return pulumi.get(self, "blob_restore_status")

    @property
    @pulumi.getter(name="creationTime")
    def creation_time(self) -> pulumi.Output[str]:
        """
        Gets the creation date and time of the storage account in UTC.
        """
        return pulumi.get(self, "creation_time")

    @property
    @pulumi.getter(name="customDomain")
    def custom_domain(self) -> pulumi.Output['outputs.CustomDomainResponse']:
        """
        Gets the custom domain the user assigned to this storage account.
        """
        return pulumi.get(self, "custom_domain")

    @property
    @pulumi.getter(name="defaultToOAuthAuthentication")
    def default_to_o_auth_authentication(self) -> pulumi.Output[Optional[bool]]:
        """
        A boolean flag which indicates whether the default authentication is OAuth or not. The default interpretation is false for this property.
        """
        return pulumi.get(self, "default_to_o_auth_authentication")

    @property
    @pulumi.getter(name="dnsEndpointType")
    def dns_endpoint_type(self) -> pulumi.Output[Optional[str]]:
        """
        Allows you to specify the type of endpoint. Set this to AzureDNSZone to create a large number of accounts in a single subscription, which creates accounts in an Azure DNS Zone and the endpoint URL will have an alphanumeric DNS Zone identifier.
        """
        return pulumi.get(self, "dns_endpoint_type")

    @property
    @pulumi.getter(name="enableHttpsTrafficOnly")
    def enable_https_traffic_only(self) -> pulumi.Output[Optional[bool]]:
        """
        Allows https traffic only to storage service if sets to true.
        """
        return pulumi.get(self, "enable_https_traffic_only")

    @property
    @pulumi.getter(name="enableNfsV3")
    def enable_nfs_v3(self) -> pulumi.Output[Optional[bool]]:
        """
        NFS 3.0 protocol support enabled if set to true.
        """
        return pulumi.get(self, "enable_nfs_v3")

    @property
    @pulumi.getter
    def encryption(self) -> pulumi.Output['outputs.EncryptionResponse']:
        """
        Encryption settings to be used for server-side encryption for the storage account.
        """
        return pulumi.get(self, "encryption")

    @property
    @pulumi.getter(name="extendedLocation")
    def extended_location(self) -> pulumi.Output[Optional['outputs.ExtendedLocationResponse']]:
        """
        The extendedLocation of the resource.
        """
        return pulumi.get(self, "extended_location")

    @property
    @pulumi.getter(name="failoverInProgress")
    def failover_in_progress(self) -> pulumi.Output[bool]:
        """
        If the failover is in progress, the value will be true, otherwise, it will be null.
        """
        return pulumi.get(self, "failover_in_progress")

    @property
    @pulumi.getter(name="geoReplicationStats")
    def geo_replication_stats(self) -> pulumi.Output['outputs.GeoReplicationStatsResponse']:
        """
        Geo Replication Stats
        """
        return pulumi.get(self, "geo_replication_stats")

    @property
    @pulumi.getter
    def identity(self) -> pulumi.Output[Optional['outputs.IdentityResponse']]:
        """
        The identity of the resource.
        """
        return pulumi.get(self, "identity")

    @property
    @pulumi.getter(name="immutableStorageWithVersioning")
    def immutable_storage_with_versioning(self) -> pulumi.Output[Optional['outputs.ImmutableStorageAccountResponse']]:
        """
        The property is immutable and can only be set to true at the account creation time. When set to true, it enables object level immutability for all the containers in the account by default.
        """
        return pulumi.get(self, "immutable_storage_with_versioning")

    @property
    @pulumi.getter(name="isHnsEnabled")
    def is_hns_enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Account HierarchicalNamespace enabled if sets to true.
        """
        return pulumi.get(self, "is_hns_enabled")

    @property
    @pulumi.getter(name="isLocalUserEnabled")
    def is_local_user_enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Enables local users feature, if set to true
        """
        return pulumi.get(self, "is_local_user_enabled")

    @property
    @pulumi.getter(name="isSftpEnabled")
    def is_sftp_enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Enables Secure File Transfer Protocol, if set to true
        """
        return pulumi.get(self, "is_sftp_enabled")

    @property
    @pulumi.getter(name="keyCreationTime")
    def key_creation_time(self) -> pulumi.Output['outputs.KeyCreationTimeResponse']:
        """
        Storage account keys creation time.
        """
        return pulumi.get(self, "key_creation_time")

    @property
    @pulumi.getter(name="keyPolicy")
    def key_policy(self) -> pulumi.Output['outputs.KeyPolicyResponse']:
        """
        KeyPolicy assigned to the storage account.
        """
        return pulumi.get(self, "key_policy")

    @property
    @pulumi.getter
    def kind(self) -> pulumi.Output[str]:
        """
        Gets the Kind.
        """
        return pulumi.get(self, "kind")

    @property
    @pulumi.getter(name="largeFileSharesState")
    def large_file_shares_state(self) -> pulumi.Output[Optional[str]]:
        """
        Allow large file shares if sets to Enabled. It cannot be disabled once it is enabled.
        """
        return pulumi.get(self, "large_file_shares_state")

    @property
    @pulumi.getter(name="lastGeoFailoverTime")
    def last_geo_failover_time(self) -> pulumi.Output[str]:
        """
        Gets the timestamp of the most recent instance of a failover to the secondary location. Only the most recent timestamp is retained. This element is not returned if there has never been a failover instance. Only available if the accountType is Standard_GRS or Standard_RAGRS.
        """
        return pulumi.get(self, "last_geo_failover_time")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter(name="minimumTlsVersion")
    def minimum_tls_version(self) -> pulumi.Output[Optional[str]]:
        """
        Set the minimum TLS version to be permitted on requests to storage. The default interpretation is TLS 1.0 for this property.
        """
        return pulumi.get(self, "minimum_tls_version")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkRuleSet")
    def network_rule_set(self) -> pulumi.Output['outputs.NetworkRuleSetResponse']:
        """
        Network rule set
        """
        return pulumi.get(self, "network_rule_set")

    @property
    @pulumi.getter(name="primaryEndpoints")
    def primary_endpoints(self) -> pulumi.Output['outputs.EndpointsResponse']:
        """
        Gets the URLs that are used to perform a retrieval of a public blob, queue, or table object. Note that Standard_ZRS and Premium_LRS accounts only return the blob endpoint.
        """
        return pulumi.get(self, "primary_endpoints")

    @property
    @pulumi.getter(name="primaryLocation")
    def primary_location(self) -> pulumi.Output[str]:
        """
        Gets the location of the primary data center for the storage account.
        """
        return pulumi.get(self, "primary_location")

    @property
    @pulumi.getter(name="privateEndpointConnections")
    def private_endpoint_connections(self) -> pulumi.Output[Sequence['outputs.PrivateEndpointConnectionResponse']]:
        """
        List of private endpoint connection associated with the specified storage account
        """
        return pulumi.get(self, "private_endpoint_connections")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        Gets the status of the storage account at the time the operation was called.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="publicNetworkAccess")
    def public_network_access(self) -> pulumi.Output[Optional[str]]:
        """
        Allow or disallow public network access to Storage Account. Value is optional but if passed in, must be 'Enabled' or 'Disabled'.
        """
        return pulumi.get(self, "public_network_access")

    @property
    @pulumi.getter(name="routingPreference")
    def routing_preference(self) -> pulumi.Output[Optional['outputs.RoutingPreferenceResponse']]:
        """
        Maintains information about the network routing choice opted by the user for data transfer
        """
        return pulumi.get(self, "routing_preference")

    @property
    @pulumi.getter(name="sasPolicy")
    def sas_policy(self) -> pulumi.Output['outputs.SasPolicyResponse']:
        """
        SasPolicy assigned to the storage account.
        """
        return pulumi.get(self, "sas_policy")

    @property
    @pulumi.getter(name="secondaryEndpoints")
    def secondary_endpoints(self) -> pulumi.Output['outputs.EndpointsResponse']:
        """
        Gets the URLs that are used to perform a retrieval of a public blob, queue, or table object from the secondary location of the storage account. Only available if the SKU name is Standard_RAGRS.
        """
        return pulumi.get(self, "secondary_endpoints")

    @property
    @pulumi.getter(name="secondaryLocation")
    def secondary_location(self) -> pulumi.Output[str]:
        """
        Gets the location of the geo-replicated secondary for the storage account. Only available if the accountType is Standard_GRS or Standard_RAGRS.
        """
        return pulumi.get(self, "secondary_location")

    @property
    @pulumi.getter
    def sku(self) -> pulumi.Output['outputs.SkuResponse']:
        """
        Gets the SKU.
        """
        return pulumi.get(self, "sku")

    @property
    @pulumi.getter(name="statusOfPrimary")
    def status_of_primary(self) -> pulumi.Output[str]:
        """
        Gets the status indicating whether the primary location of the storage account is available or unavailable.
        """
        return pulumi.get(self, "status_of_primary")

    @property
    @pulumi.getter(name="statusOfSecondary")
    def status_of_secondary(self) -> pulumi.Output[str]:
        """
        Gets the status indicating whether the secondary location of the storage account is available or unavailable. Only available if the SKU name is Standard_GRS or Standard_RAGRS.
        """
        return pulumi.get(self, "status_of_secondary")

    @property
    @pulumi.getter(name="storageAccountSkuConversionStatus")
    def storage_account_sku_conversion_status(self) -> pulumi.Output[Optional['outputs.StorageAccountSkuConversionStatusResponse']]:
        """
        This property is readOnly and is set by server during asynchronous storage account sku conversion operations.
        """
        return pulumi.get(self, "storage_account_sku_conversion_status")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

