# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'CreateMode',
    'NodeSize',
    'NodeSizeFamily',
    'ResourceIdentityType',
    'StorageAccountType',
    'WorkspacePublicNetworkAccess',
]


class CreateMode(str, Enum):
    """
    Specifies the mode of sql pool creation.

    Default: regular sql pool creation.

    PointInTimeRestore: Creates a sql pool by restoring a point in time backup of an existing sql pool. sourceDatabaseId must be specified as the resource ID of the existing sql pool, and restorePointInTime must be specified.

    Recovery: Creates a sql pool by a geo-replicated backup. sourceDatabaseId  must be specified as the recoverableDatabaseId to restore.

    Restore: Creates a sql pool by restoring a backup of a deleted sql  pool. SourceDatabaseId should be the sql pool's original resource ID. SourceDatabaseId and sourceDatabaseDeletionDate must be specified.
    """
    DEFAULT = "Default"
    POINT_IN_TIME_RESTORE = "PointInTimeRestore"
    RECOVERY = "Recovery"
    RESTORE = "Restore"


class NodeSize(str, Enum):
    """
    The level of compute power that each node in the Big Data pool has.
    """
    NONE = "None"
    SMALL = "Small"
    MEDIUM = "Medium"
    LARGE = "Large"
    X_LARGE = "XLarge"
    XX_LARGE = "XXLarge"
    XXX_LARGE = "XXXLarge"


class NodeSizeFamily(str, Enum):
    """
    The kind of nodes that the Big Data pool provides.
    """
    NONE = "None"
    MEMORY_OPTIMIZED = "MemoryOptimized"
    HARDWARE_ACCELERATED_FPGA = "HardwareAcceleratedFPGA"
    HARDWARE_ACCELERATED_GPU = "HardwareAcceleratedGPU"


class ResourceIdentityType(str, Enum):
    """
    The type of managed identity for the workspace
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


class StorageAccountType(str, Enum):
    """
    The storage account type used to store backups for this sql pool.
    """
    GRS = "GRS"
    LRS = "LRS"
    ZRS = "ZRS"


class WorkspacePublicNetworkAccess(str, Enum):
    """
    Enable or Disable public network access to workspace
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"
