# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['ActionRequestArgs', 'ActionRequest']

@pulumi.input_type
class ActionRequestArgs:
    def __init__(__self__, *,
                 request_type: pulumi.Input[Union[str, 'RequestTypes']],
                 resource_group_name: pulumi.Input[str],
                 test_base_account_name: pulumi.Input[str],
                 action_request_name: Optional[pulumi.Input[str]] = None,
                 pre_release_access_request_spec: Optional[pulumi.Input['PreReleaseAccessRequestSpecArgs']] = None):
        """
        The set of arguments for constructing a ActionRequest resource.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] test_base_account_name: The resource name of the Test Base Account.
        """
        pulumi.set(__self__, "request_type", request_type)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "test_base_account_name", test_base_account_name)
        if action_request_name is not None:
            pulumi.set(__self__, "action_request_name", action_request_name)
        if pre_release_access_request_spec is not None:
            pulumi.set(__self__, "pre_release_access_request_spec", pre_release_access_request_spec)

    @property
    @pulumi.getter(name="requestType")
    def request_type(self) -> pulumi.Input[Union[str, 'RequestTypes']]:
        return pulumi.get(self, "request_type")

    @request_type.setter
    def request_type(self, value: pulumi.Input[Union[str, 'RequestTypes']]):
        pulumi.set(self, "request_type", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="testBaseAccountName")
    def test_base_account_name(self) -> pulumi.Input[str]:
        """
        The resource name of the Test Base Account.
        """
        return pulumi.get(self, "test_base_account_name")

    @test_base_account_name.setter
    def test_base_account_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "test_base_account_name", value)

    @property
    @pulumi.getter(name="actionRequestName")
    def action_request_name(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "action_request_name")

    @action_request_name.setter
    def action_request_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "action_request_name", value)

    @property
    @pulumi.getter(name="preReleaseAccessRequestSpec")
    def pre_release_access_request_spec(self) -> Optional[pulumi.Input['PreReleaseAccessRequestSpecArgs']]:
        return pulumi.get(self, "pre_release_access_request_spec")

    @pre_release_access_request_spec.setter
    def pre_release_access_request_spec(self, value: Optional[pulumi.Input['PreReleaseAccessRequestSpecArgs']]):
        pulumi.set(self, "pre_release_access_request_spec", value)


class ActionRequest(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action_request_name: Optional[pulumi.Input[str]] = None,
                 pre_release_access_request_spec: Optional[pulumi.Input[pulumi.InputType['PreReleaseAccessRequestSpecArgs']]] = None,
                 request_type: Optional[pulumi.Input[Union[str, 'RequestTypes']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 test_base_account_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Azure REST API version: 2023-11-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] test_base_account_name: The resource name of the Test Base Account.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ActionRequestArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Azure REST API version: 2023-11-01-preview.

        :param str resource_name: The name of the resource.
        :param ActionRequestArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ActionRequestArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action_request_name: Optional[pulumi.Input[str]] = None,
                 pre_release_access_request_spec: Optional[pulumi.Input[pulumi.InputType['PreReleaseAccessRequestSpecArgs']]] = None,
                 request_type: Optional[pulumi.Input[Union[str, 'RequestTypes']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 test_base_account_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ActionRequestArgs.__new__(ActionRequestArgs)

            __props__.__dict__["action_request_name"] = action_request_name
            __props__.__dict__["pre_release_access_request_spec"] = pre_release_access_request_spec
            if request_type is None and not opts.urn:
                raise TypeError("Missing required property 'request_type'")
            __props__.__dict__["request_type"] = request_type
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            if test_base_account_name is None and not opts.urn:
                raise TypeError("Missing required property 'test_base_account_name'")
            __props__.__dict__["test_base_account_name"] = test_base_account_name
            __props__.__dict__["creation_date"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:testbase/v20231101preview:ActionRequest")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(ActionRequest, __self__).__init__(
            'azure-native:testbase:ActionRequest',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'ActionRequest':
        """
        Get an existing ActionRequest resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = ActionRequestArgs.__new__(ActionRequestArgs)

        __props__.__dict__["creation_date"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["pre_release_access_request_spec"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["request_type"] = None
        __props__.__dict__["status"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return ActionRequest(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="creationDate")
    def creation_date(self) -> pulumi.Output[str]:
        return pulumi.get(self, "creation_date")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="preReleaseAccessRequestSpec")
    def pre_release_access_request_spec(self) -> pulumi.Output[Optional['outputs.PreReleaseAccessRequestSpecResponse']]:
        return pulumi.get(self, "pre_release_access_request_spec")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        The provisioning state of the resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="requestType")
    def request_type(self) -> pulumi.Output[str]:
        return pulumi.get(self, "request_type")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

