# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['ACSSBackupConnectionArgs', 'ACSSBackupConnection']

@pulumi.input_type
class ACSSBackupConnectionArgs:
    def __init__(__self__, *,
                 connector_name: pulumi.Input[str],
                 resource_group_name: pulumi.Input[str],
                 backup_data: Optional[pulumi.Input[Union['HanaBackupDataArgs', 'SqlBackupDataArgs', 'VMBackupDataArgs']]] = None,
                 backup_name: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a ACSSBackupConnection resource.
        :param pulumi.Input[str] connector_name: The name of the connector resource
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Union['HanaBackupDataArgs', 'SqlBackupDataArgs', 'VMBackupDataArgs']] backup_data: Information about the recovery services vault and backup policy used for backup.
        :param pulumi.Input[str] backup_name: The name of the backup connection resource of virtual instance for SAP.
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        """
        pulumi.set(__self__, "connector_name", connector_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if backup_data is not None:
            pulumi.set(__self__, "backup_data", backup_data)
        if backup_name is not None:
            pulumi.set(__self__, "backup_name", backup_name)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="connectorName")
    def connector_name(self) -> pulumi.Input[str]:
        """
        The name of the connector resource
        """
        return pulumi.get(self, "connector_name")

    @connector_name.setter
    def connector_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "connector_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="backupData")
    def backup_data(self) -> Optional[pulumi.Input[Union['HanaBackupDataArgs', 'SqlBackupDataArgs', 'VMBackupDataArgs']]]:
        """
        Information about the recovery services vault and backup policy used for backup.
        """
        return pulumi.get(self, "backup_data")

    @backup_data.setter
    def backup_data(self, value: Optional[pulumi.Input[Union['HanaBackupDataArgs', 'SqlBackupDataArgs', 'VMBackupDataArgs']]]):
        pulumi.set(self, "backup_data", value)

    @property
    @pulumi.getter(name="backupName")
    def backup_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the backup connection resource of virtual instance for SAP.
        """
        return pulumi.get(self, "backup_name")

    @backup_name.setter
    def backup_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "backup_name", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)


class ACSSBackupConnection(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 backup_data: Optional[pulumi.Input[Union[pulumi.InputType['HanaBackupDataArgs'], pulumi.InputType['SqlBackupDataArgs'], pulumi.InputType['VMBackupDataArgs']]]] = None,
                 backup_name: Optional[pulumi.Input[str]] = None,
                 connector_name: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Define the backup connection resource of virtual instance for SAP..

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union[pulumi.InputType['HanaBackupDataArgs'], pulumi.InputType['SqlBackupDataArgs'], pulumi.InputType['VMBackupDataArgs']]] backup_data: Information about the recovery services vault and backup policy used for backup.
        :param pulumi.Input[str] backup_name: The name of the backup connection resource of virtual instance for SAP.
        :param pulumi.Input[str] connector_name: The name of the connector resource
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ACSSBackupConnectionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Define the backup connection resource of virtual instance for SAP..

        :param str resource_name: The name of the resource.
        :param ACSSBackupConnectionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ACSSBackupConnectionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 backup_data: Optional[pulumi.Input[Union[pulumi.InputType['HanaBackupDataArgs'], pulumi.InputType['SqlBackupDataArgs'], pulumi.InputType['VMBackupDataArgs']]]] = None,
                 backup_name: Optional[pulumi.Input[str]] = None,
                 connector_name: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ACSSBackupConnectionArgs.__new__(ACSSBackupConnectionArgs)

            __props__.__dict__["backup_data"] = backup_data
            __props__.__dict__["backup_name"] = backup_name
            if connector_name is None and not opts.urn:
                raise TypeError("Missing required property 'connector_name'")
            __props__.__dict__["connector_name"] = connector_name
            __props__.__dict__["location"] = location
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["tags"] = tags
            __props__.__dict__["errors"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:workloads:ACSSBackupConnection")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(ACSSBackupConnection, __self__).__init__(
            'azure-native:workloads/v20231001preview:ACSSBackupConnection',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'ACSSBackupConnection':
        """
        Get an existing ACSSBackupConnection resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = ACSSBackupConnectionArgs.__new__(ACSSBackupConnectionArgs)

        __props__.__dict__["backup_data"] = None
        __props__.__dict__["errors"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        return ACSSBackupConnection(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="backupData")
    def backup_data(self) -> pulumi.Output[Optional[Any]]:
        """
        Information about the recovery services vault and backup policy used for backup.
        """
        return pulumi.get(self, "backup_data")

    @property
    @pulumi.getter
    def errors(self) -> pulumi.Output['outputs.ConnectorErrorDefinitionResponse']:
        """
        Defines the errors related to backup connection resource of virtual instance for SAP.
        """
        return pulumi.get(self, "errors")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        Defines the provisioning states.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

